;
; Entre :
; - HL = Buffer (fichier compact)
; - DE = Destination
; Sortie :
; - AF, BC, DE, HL modifis
;
DepkLzw:
        XOR     A
        LD      (BclLzw+1),A
BclLzw:
        LD      A,0
        RR      A                   ; Rotation avec calcul Flags C et Z
        LD      (BclLzw+1),A
        JR      Z,TstBitLzw
        JR      C,TstCodeLzw

        LDI
        JR      BclLzw
;
TstBitLzw:
        LD      A,(HL)
        INC     HL
        RRA                         ; Rotation rapide calcul seulement flag C
        SET     7,A                 ; Positionne bit 7 en gardant flag C
        LD      (BclLzw+1),A
        JR      C,TstCodeLzw

        LDI
        JR      BclLzw

;
TstCodeLzw:
;
;       a = inbuffer[ inbytes ];
;
        LD      A,(HL)
        AND     A
;
; Plus d'octets  traiter
; = fini
;
        RET     Z

        INC     HL
        LD      B,A
        RLCA
        JR      NC,TstLzw40
;
;       length = 3 + ( ( inbuffer[ inbytes ] >> 4 ) & 7 );
;       index = ( inbuffer[ inbytes++ ] & 15 ) << 8;
;       index |= inbuffer[ inbytes++ ];
;       index++;
;
        PUSH    HL
        LD      L,(HL)
        LD      C,B
        RLCA
        RLCA
        RLCA
        AND     7
        ADD     A,3
        LD      B,A
        LD      A,C
        AND     #0F
        LD      H,A
        LD      C,B
        LD      B,0
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JR      BclLzw
;
TstLzw40:
        RLCA
        JR      NC,TstLzw20
;
;       length = 2;
;       index = inbuffer[ inbytes++ ] & 0x3f;
;       index++;
;
        LD      A,B
        PUSH    HL
        AND     #3F
        LD      L,A
        LD      H,0
        INC     L
        LD      B,D
        LD      C,E
        EX      DE,HL
        SBC     HL,DE
        LD      D,B
        LD      E,C
        LDI
        LDI
        POP     HL
        JR      BclLzw
;
TstLzw20:
        RLCA
        JR      NC,TstLzw10
;
;       length = 2 + ( inbuffer[ inbytes++ ] & 31 );
;       index = inbuffer[ inbytes++ ];
;       index++;
;
        PUSH    HL
        LD      A,B
        LD      L,(HL)
        AND     #1F
        ADD     A,2
        LD      C,A
        LD      H,0
        LD      B,H
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JR      BclLzw
;
TstLzw10:
        RLCA
        JR      NC,CodeLzw00
;
;       index = ( inbuffer[ inbytes++ ] & 15 ) << 8;
;       index |= inbuffer[ inbytes++ ];
;       length = inbuffer[ inbytes++ ] + 1;
;       index++;
;
        LD      A,B
        AND     #0F
        LD      B,(HL)
        INC     HL
        PUSH    HL
        LD      C,(HL)
        LD      H,A
        LD      L,B
        LD      B,0
        INC     BC
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JP      BclLzw
;
CodeLzw00:
        PUSH    HL
        LD      A,B
        CP      15
        JR      NZ,CodeLzwN15
;
;       length = index = inbuffer[ inbytes+1 ] + 1;
;       inbytes += 2;
;
        LD      C,(HL)
        XOR     A
        LD      B,A
        INC     BC
        LD      H,B
        LD      L,C
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JP      BclLzw
;
CodeLzwN15:
        CP      2
        JR      C,CodeLzwInf2
;
;       length = index = inbuffer[ inbytes ];
;
        LD      C,A
        LD      L,A
        XOR     A
        LD      H,A
        LD      B,H
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        JP      BclLzw
;
;       length = index = 256;
;
CodeLzwInf2:
        XOR     A
        LD      BC,#100
        LD      H,D
        LD      L,E
        DEC     H
        LDIR
        POP     HL
        JP      BclLzw
