;
; Fonctions des vues
;

;
; #####################################
; ##                                 ##
; ## Vue 1 - Extrieur maison        ##
; ##                                 ##
; #####################################
;
FctAlarmeVue1:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(AlarmeOff)
        AND     A                       ; Alarme est sur off ?
        JP      NZ,FctAffRienSpecial    ; Si oui, afficher "rien de spcial"
        LD      HL,DialAlarmeVue1
        CALL    AfficheWinNoWait
        LD      HL,#0217
        CALL    #BB75
        CALL    SaisieMot               ; Saisie code alarme
        LD      HL,MotSaisi
        LD      DE,CodeAlarme
FctTestCodeAlarm:
        LD      A,(DE)
        AND     A
        JR      Z,FctCodeAlarmOk
        CP      (HL)
        JR      NZ,FctMauvaisCode
        INC     HL
        INC     DE
        JR      FctTestCodeAlarm
FctCodeAlarmOk:
        LD      A,1
        LD      (AlarmeOff),A           ; Indique alarme off
        LD      HL,DialCodeOkVue1
        JR      FctAfficheMaison
FctMauvaisCode:
        LD      HL,DialBadCodeVue1      ; Mauvais code...
        JR      FctAfficheMaison

FctPorteVue1:
        LD      A,(ModeUtil)            ; Dans quel mode sommes-nous
        AND     A                       ; Mode utilisation ?
        JR      Z,FctPorteVue1Rech      ; Si non, mode recherche
        LD      A,(ObjUtil)             ; Regarde l'objet utilis
        CP      OBJ_Pierre              ; Est-ce la pierre ?
        JP      NZ,FctAffMarchePas
        LD      A,(AlarmeOff)
        AND     A
        JR      NZ,FctPorteVue1CasseOk
        LD      A,1
        LD      (JoueurPerdu),A         ; Joueur a perdu
        LD      HL,DialAlarmeActiveVue1
        JR      FctAfficheMaison
FctPorteVue1CasseOk:
        LD      A,1
        LD      (PorteCassee),A         ; Porte casse
        LD      A,OBJ_Pierre
        CALL    SupObjInv               ; Supprime pierre de l'inventaire
        LD      HL,DialCasseFenetreVue1
FctAfficheMaison:
        JP      AfficheWinWait
FctPorteVue1Rech:
        LD      A,(PorteCassee)
        AND     A                       ; Porte dja "casse" ?
        JR      Z,FctPorteVue1Voir      ; Si non, affichage message
        LD      B,2
        JP      GoVue                   ; On passe  la vue 2 !!!
FctPorteVue1Voir:
        LD      HL,DialPorteFermeeVue1
        JR      FctAfficheMaison

FctSolVue1:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(TrouvePierre)
        AND     A
        JP      NZ,FctAffRienSpecial    ; Pierre dj trouve.
        LD      A,1
        LD      (TrouvePierre),A
        LD      A,Obj_Pierre            ; Numro de l'objet PIERRE
        CALL    AjouteObjInv            ; Ajoute dans l'inventaire
        LD      HL,DialTrouvePierreVue1
        JR      FctAfficheMaison

;
; #####################################
; ##                                 ##
; ## Vue 2 - Le salon                ##
; ##                                 ##
; #####################################
;
FctStartVue2:
        LD      A,#FF
        LD      (ZoneVue2+1),A          ; inhiber la zone du perroquet
        LD      A,(PerroquetPris)
        AND     A
        JR      NZ,FctStartVue2FinSpt
        LD      HL,SptPerroquet
        CALL    DepkWin
        LD      A,73
        LD      (ZoneVue2+1),A          ; Autoriser la zone du perroquet
FctStartVue2FinSpt:
        CALL    SetColImg
        LD      A,(PerroquetCalme)
        AND     A                       ; Le perroquet est-il calme ?
        RET     NZ                      ; Si oui, rien afficher
        LD      HL,DialPerroquetVolVue2
        CALL    AfficheWinMsg           ; Afficher message du perroquet
        LD      A,#30
        CALL    SetAdrMemEcr            ; Adresse cran en #C000
        CALL    CopieEcran
        CALL    #BB18                   ; Attente appui sur une touche
        CALL    AffImgDcmp              ; Affiche l'image
        LD      HL,SptPerroquet
        JP      DepkWin                 ; Affiche le perroquet

FctLivre1Vue2:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(TrouveClePlacards)
        AND     A
        JP      NZ,FctAffRienSpecial    ; Cl dja trouve
        LD      A,1
        LD      (TrouveClePlacards),A   ; Si non, mmorise cl prise
        LD      HL,DialLivre1Vue2
        CALL    AfficheWinWait
        LD      A,OBJ_ClePlacard        ; Objet = cl
        JP      AjouteObjInv            ; Ajouter objet dans inventaire

FctBouteilleVue2:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(FormuleTrouvee)
        AND     A                       ; Trouv formule de la potion ?
        JR      Z,FctBouteilleMsg       ; Si non, ne fait qu'afficher
        LD      A,(WhiskyPris)
        AND     A                       ; Whisky dj pris ?
        JP      NZ,FctAffRienSpecial    ; Si oui, rien de spcial
        LD      A,OBJ_Whisky            ; Objet = whisky
        CALL    AjouteObjInv            ; Ajouter objet dans inventaire
        LD      A,1
        LD      (WhiskyPris),A          ; Mmoriser whisky pris
FctBouteilleMsg:
        LD      HL,DialBouteilleVue2
FctAfficheSalon:
        JP      AfficheWinWait

FctPlacardGVue2:
        LD      A,(ModeUtil)            ; Dans quel mode sommes-nous
        AND     A                       ; Mode utilisation ?
        JR      Z,FctPlacardGVue2Rech   ; Si non, mode recherche
        LD      A,(ObjUtil)             ; Regarde l'objet utilis
        CP      OBJ_ClePlacard          ; Est-ce la cl ?
        JP      NZ,FctAffMarchePas      ; Si non, afficher "marche pas"
        LD      A,1
        LD      (PlacardGOuvert),A      ; Placard est ouvert
        JP      FctAffPlacardOuvre      ; Afficher placard ouvert
FctPlacardGVue2Rech:
        LD      A,(PlacardGOuvert)
        AND     A                       ; Le placard est-il ouvert ?
        JP      Z,FctAffPlacFerme       ; Si non, affiche "placard ferm"
        LD      HL,DialPlacardGVue2
        JR      FctAfficheSalon

FctPlacardMVue2:
        LD      A,(ModeUtil)            ; Dans quel mode sommes-nous
        AND     A                       ; Mode utilisation ?
        JR      Z,FctPlacardMVue2Rech   ; Si non, mode recherche
        LD      A,(ObjUtil)             ; Regarde l'objet utilis
        CP      OBJ_ClePlacard          ; Est-ce la cl ?
        JP      NZ,FctAffMarchePas      ; Si non, afficher "marche pas"
        LD      A,1
        LD      (PlacardMOuvert),A      ; Placard est ouvert
        JP      FctAffPlacardOuvre      ; Afficher placard ouvert
FctPlacardMVue2Rech:
        LD      A,(PlacardMOuvert)
        AND     A                       ; Le placard est-il ouvert ?
        JP      Z,FctAffPlacFerme       ; Si non, affiche "placard ferm"
        LD      A,(IngredientsSalon)
        AND     A                       ; Ingrdients dj pris ?
        LD      HL,DialPlacardMPrisVue2
        JR      NZ,FctAfficheSalon1     ; Si oui, afficher restant
        LD      A,(FormuleTrouvee)
        AND     A                       ; Formule trouve ?
        LD      HL,DialPlacardMVue2
        JR      Z,FctAfficheSalon1      ; Si non, juste afficher message
        LD      A,(Inventaire+8)
        AND     A                       ; De la place pour 2 objets ?
        JP      NZ,FctAffInvPlein       ; Si non, affiche message
        LD      A,OBJ_PoudreBlanche     ; Objet = Poudre blanche
        CALL    AjouteObjInv
        LD      A,OBJ_FioleBleue        ; Objet = Fiole bleue
        CALL    AjouteObjInv
        LD      A,1
        LD      (IngredientsSalon),A    ; Indique ingrdients pris
        LD      HL,DialPlacardMPrendsVue2
FctAfficheSalon1:
        JR      FctAfficheSalon

FctPlacardDVue2:
        LD      A,(ModeUtil)            ; Dans quel mode sommes-nous
        AND     A                       ; Mode utilisation ?
        JR      Z,FctPlacardDVue2Rech   ; Si non, mode recherche
        LD      A,(ObjUtil)             ; Regarde l'objet utilis
        CP      OBJ_ClePlacard          ; Est-ce la cl ?
        JP      NZ,FctAffMarchePas      ; Si non, afficher "marche pas"
        LD      A,1
        LD      (PlacardDOuvert),A      ; Placard est ouvert
        JP      FctAffPlacardOuvre      ; Afficher placard ouvert
FctPlacardDVue2Rech
        LD      A,(PlacardDOuvert)
        AND     A                       ; Le placard est-il ouvert ?
        JP      Z,FctAffPlacFerme       ; Si non, affiche "placard ferm"
        JP      FctAffRienInteressant

FctPerroquetVue2:
        LD      A,(ModeUtil)            ; Dans quel mode sommes-nous
        AND     A                       ; Mode utilisation ?
        JR      NZ,FctPerroquetUtilVue2
        LD      A,1
        LD      (PerroquetVu),A         ; Indique on a vu le perroquet
        LD      HL,DialPerroquetVue2    ; Dialogue sur le perroquet
        JR      FctAfficheSalon1
FctPerroquetUtilVue2:
        LD      A,(ObjUtil)             ; Regarde l'objet utilis
        CP      OBJ_Tenaille            ; Est-ce la tenaille ?
        JR      NZ,FctPerroquetCalme
        LD      A,(PerroquetCalme)
        AND     A
        JR      NZ,FctPrendPerroquetVue2
        LD      HL,DialPerroquetEnerve
        JR      FctAfficheSalon1
FctPrendPerroquetVue2:
        LD      A,OBJ_Perroquet
        CALL    AjouteObjInv
        LD      A,1
        LD      (PerroquetPris),A
        LD      HL,DialPerroquetPrendsVue2
        JR      FctAfficheSalon1
FctPerroquetCalme:
        CP      OBJ_Cacahouetes         ; Est-ce les cacahoutes ?
        JP      NZ,FctAffMarchePas      ; Sinon, afficher "marche pas"
        CALL    SupObjInv               ; Supprime les cacahoutes de l'inv.
        LD      A,1
        LD      (PerroquetCalme),A      ; Perroquet est calm
        LD      HL,DialPerroquetCalmeVue2
        JR      FctAfficheSalon1

;
; #####################################
; ##                                 ##
; ## Vue 3 - Le garage               ##
; ##                                 ##
; #####################################
;
FctStartVue3:
        LD      A,(TenaillePris)
        AND     A
        RET     NZ
        LD      HL,SptTenaille
        JP      DepkWin

FctEtagereBVue3:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(TenaillePris)
        AND     A                       ; Tenaille prise ?
        JR      NZ,FctTenaillePrisVue3  ; Si oui...
        LD      A,(PerroquetVu)
        AND     A                       ; Perroquet vu ?
        JR      NZ,FctPrendsTenailleVue3    ; si oui...
        LD      HL,DialPasPrisTenailleVue3
        JR      FctAfficheGarage
FctPrendsTenailleVue3:
        LD      A,OBJ_Tenaille
        CALL    AjouteObjInv
        LD      A,1
        LD      (TenaillePris),A
        LD      HL,DialPrendsTenailleVue3
        JR      FctAfficheGarage
FctTenaillePrisVue3:
        LD      HL,DialPrisTenailleVue3
FctAfficheGarage:
        JP      AfficheWinWait

;
; #####################################
; ##                                 ##
; ## Vue 4 - La cuisine              ##
; ##                                 ##
; #####################################
;
FctStartVue4:
        LD      A,(CasserolePose)
        AND     A
        RET     Z
        LD      HL,SptCasserole
        JP      DepkWin

FctEvierVue4:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctEvierUtilVue4
        LD      HL,DialEvierVue4
        JR      FctAfficheCuisine2
FctEvierUtilVue4:
        LD      A,(ObjUtil)
        CP      OBJ_Casserole           ; Est-ce la casserole ?
        JP      NZ,FctAffMarchePas
        LD      HL,IngredientsCasserole
        SET     0,(HL)                  ; Indiquer eau dans la casserole
        LD      HL,DialEauCasseroleVue4
FctAfficheCuisine2:
        JR      FctAfficheCuisine
FctTiroirVue4:
        LD      HL,DialTiroirVue4
        LD      A,(FormuleTrouvee)
        AND     A                       ; Formule trouve ?
        JP      Z,FctAffMessGene
        LD      A,(SpatuleTrouvee)      ; Spatule trouve ?
        AND     A
        JP      NZ,FctAffRienInteressant
        LD      A,OBJ_Spatule           ; Objet = spatule
        CALL    AjouteObjInv
        LD      A,1
        LD      (SpatuleTrouvee),A       ; Spatule trouve
        LD      HL,DialTiroirVue4
        JP      FctAffMessGene
FctPlacardGVue4:
        LD      HL,DialPlacardGVue4
        JP      FctAffMessGene
FctRefrigerateurVue4:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(FormuleTrouvee)
        AND     A                       ; Formule trouve ?
        JR      NZ,FctRefrigerateurAil
FctRefrigerateurMsgVue4:
        LD      HL,DialRefrigerateurVue4
        JR      FctAfficheCuisine
FctRefrigerateurAil:
        LD      A,(AilTrouve)
        AND     A                       ; Ail trouv ?
        JR      NZ,FctRefrigerateurMsgVue4
        LD      A,OBJ_Ail               ; Objet = ail
        CALL    AjouteObjInv
        LD      A,1
        LD      (AilTrouve),A
        LD      HL,DialRefrigerateurAil
        JR      FctAfficheCuisine
FctMessageVue4:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,1
        LD      (MessageTrouve),A
        LD      HL,DialMessageVue4
        CALL    AfficheWinMsg
        CALL    #BB18
        JP      AffImgVue

FctPlacardDBGVue4:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(FormuleTrouvee)
        AND     A                       ; Formule trouve ?
        JR      NZ,FctCasseroleVue4     ; Si oui, test casserole
FctCasseroleMsgVue4:
        LD      HL,DialPlacardDBGVue4
FctAfficheCuisine:
        JP      AfficheWinWait
FctCasseroleVue4:
        LD      A,(CasseroleTrouve)
        AND     A                       ; Casserole trouve ?
        JR      NZ,FctCasseroleMsgVue4
        LD      A,OBJ_Casserole
        CALL    AjouteObjInv
        LD      A,1
        LD      (CasseroleTrouve),A
        LD      HL,DialPlacardDBGFormule
        JR      FctAfficheCuisine
FctPlaqueCasseroleVue4:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctPlaqueUtilVue4
        LD      HL,DialPlaqueVue4
        LD      A,(CasserolePose)
        AND     A                       ; Casserole pose ?
        JR      Z,FctPlaqueMsg
        LD      HL,DialPotionCasserole
        LD      A,(IngredientsCasserole)
        CP      #1F                     ; Tous les ingrdients ok ?
        JR      NZ,FctPlaqueMsg
        LD      A,OBJ_Potion
        CALL    AjouteObjInv
        LD      A,1
        LD      (PotionOk),A
        XOR     A
        LD      (CasserolePose),A
        LD      HL,DialPotionOk
        JR      FctPlaqueMsg
FctPlaqueUtilVue4:
        LD      A,(CasserolePose)
        AND     A                       ; Casserole pose ?
        JR      NZ,FctPlaqueIngredients
        LD      A,(ObjUtil)
        CP      OBJ_Casserole           ; Est-ce la casserole ?
        JP      NZ,FctAffMarchePas      ; Sinon, marche pas
        LD      HL,IngredientsCasserole:
        BIT     0,(HL)                  ; Eau dans casserole ?
        JR      NZ,FctPlaquePoseOk
        LD      HL,DialPasEauCasseroleVue4
FctPlaqueMsg:
        JP      AfficheWinWait
FctPlaquePoseOk:
        CALL    SupObjInv               ; Supprime casserole de l'inventaire
        LD      A,1
        LD      (CasserolePose),A       ; Casserole pose
        JP      AffImgVue               ; Pour redessiner la vue+casserole
FctPlaqueIngredients:
        LD      A,(ObjUtil)
        LD      HL,IngredientsCasserole
        LD      B,2
        CP      OBJ_PoudreBlanche       ; Poudre blanche
        JR      Z,FctPlaqueAjoute
        LD      B,4
        CP      OBJ_FioleBleue          ; Fiole Bleue
        JR      Z,FctPlaqueAjoute
        LD      B,8
        CP      OBJ_Ail                 ; Ail
        JR      Z,FctPlaqueAjoute
        CP      OBJ_Spatule             ; Spatule
        JP      NZ,FctAffMarchePas
        SET     4,(HL)
        LD      A,(HL)                  ; Lecture tat ingrdients
        LD      HL,DialSpatuleCasserole
        AND     #0F
        CP      #0F                     ; Tous les ingrdients
        JR      NC,FctPlaqueMsg
        LD      HL,DialPotionCasserole
FctPlaqueMsg1:
        JR      FctPlaqueMsg
FctPlaqueAjoute:
        PUSH    AF
        LD      A,(HL)
        OR      B
        LD      (HL),A
        POP     AF
        CALL    SupObjInv               ; Supprime l'objet de l'inventaire
        LD      HL,DialIngredientsCasserole
        JR      FctPlaqueMsg

FctPlacardHMVue4:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(PerroquetVu)
        AND     A
        JR      NZ,FctPerroquetVuVue4
        LD      HL,DialPlacardHMVue4
        JR      FctPlaqueMsg
FctPerroquetVuVue4:
        LD      A,(CacahoueteTrouve)
        AND     A
        JR      NZ,FctCacahoueteVue4
        LD      A,OBJ_Cacahouetes
        CALL    AjouteObjInv
        LD      A,1
        LD      (CacahoueteTrouve),A
        LD      HL,DialPlacardHMPerroquet
        JR      FctPlaqueMsg
FctCacahoueteVue4:
        LD      HL,DialPlacardHMCacahouete
        JR      FctPlaqueMsg1

;
; #####################################
; ##                                 ##
; ## Vue 5 - Le couloir              ##
; ##                                 ##
; #####################################
;
FctGrenierVue5:
        LD      A,(ModeUtil)
        AND     A
        RET     NZ
        LD      B,9
        LD      A,(GrenierOuvert)
        AND     A
        JP      NZ,GoVue
        LD      HL,DialTrappeVue5
        JP      AfficheWinWait

;
; #####################################
; ##                                 ##
; ## Vue 6 - La salle de bain        ##
; ##                                 ##
; #####################################
;
FctCouvercleVue6:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(EauVidee)
        AND     A
        JR      Z,FctEauNonVideeVue6
        LD      A,(AmuletteTrouvee)
        AND     A                       ; Amulette trouve ?
        JP      NZ,FctAffRienSpecial    ; Si oui, plus rien d'intressant.
        LD      A,OBJ_Amulette          ; Objet = amulette
        CALL    AjouteObjInv
        LD      A,1
        LD      (AmuletteTrouvee),A
        LD      HL,DialAmuletteVue6
        JP      FctAffMessGene
FctEauNonVideeVue6:
        LD      HL,DialCouvercleVue6
        JP      FctaffMessGene

FctBoutonVue6:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,1
        LD      (EauVidee),A
        LD      HL,DialBoutonVue6
        JP      FctAffMessGene

;
; #####################################
; ##                                 ##
; ## Vue 7 - La chambre du serviteur ##
; ##                                 ##
; #####################################
;
FctLampeVue7:
        LD      A,(PetiteCleTrouvee)
        AND     A
        JP      NZ,FctAffRienSpecial
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,OBJ_PetiteCle
        CALL    AjouteObjInv
        LD      A,1
        LD      (PetiteCleTrouvee),A
        LD      HL,DialLampeChevetVue7
        JP      FctAffMessGene

;
; #####################################
; ##                                 ##
; ## Vue 8 - La chambre de Zakar     ##
; ##                                 ##
; #####################################
;
FctLivreBVue8:
        LD      A,1
        LD      (GrenierOuvert),A       ; Dverouille trape du grenier
        LD      HL,DialLivreVue8
        JP      FctAffMessGene

FctBureauVue8:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctUtilBureauVue8
        LD      HL,DialBureauVue8
        LD      A,(BureauOuvert)
        AND     A
        JP      Z,FctAffMessGene
        LD      A,1
        LD      (FormuleTrouvee),A      ; Formule trouve
        LD      HL,DialFormuleVue8
        CALL    FctAffMessGene
        LD      HL,DialFormule2Vue8
        CALL    AfficheWinMsg           ; Afficher la formule
        CALL    #BB18
        JP      AffImgVue
FctUtilBureauVue8:
        LD      A,(ObjUtil)
        CP      OBJ_PetiteCle           ; Objet = petite cl ?
        JP      NZ,FctAffMarchePas      ; Sinon, affiche ne marche pas
        LD      A,1
        LD      (BureauOuvert),A
        LD      HL,DialBureauOuvreVue8
        JP      AfficheWinWait

;
; #####################################
; ##                                 ##
; ## Vue 9 - Le grenier              ##
; ##                                 ##
; #####################################
;
FctStartVue9:
        LD      A,(CpcAllume)
        AND     A                       ; Cpc est allum ?
        RET     Z                       ; Si non, retour
        LD      HL,SptTourbillon
        JP      DepkWin

FctCpcVue9:
        LD      A,(ModeUtil)
        AND     A                       ; Mode utilisation ?
        JR      NZ,FctCpcUtil
        LD      A,1
        LD      (CpcAllume),A
        LD      HL,DialAllumeCpcVue9
FctAfficheVue9:
        JP      AfficheWinWait
FctCpcUtil:
        LD      A,(CpcAllume)
        AND     A
        JR      Z,FctCpcEteint
        LD      A,(ObjUtil)
        CP      OBJ_Perroquet           ; Objet = perroquet ?
        JP      NZ,FctAffMarchePas
        LD      HL,DialIncantationVue9
        CALL    AfficheWinWait
        LD      A,(AmuletteTrouvee)
        AND     A
        JR      Z,FctCpcManque
        LD      A,(PotionBue)
        AND     A
        JR      Z,FctCpcManque
        LD      A,4                     ; Banque 4 = image dcompacte
        CALL    SetBank
        XOR     A
        LD      (CpcAllume),A           ; Pour ne plus afficher le sprite
        LD      HL,#4000
        LD      DE,#4001
        LD      BC,#3FCF
        LD      (HL),L
        LDIR                            ; Efface image = cran devient noir
        LD      HL,DialAspireVue9       ; On se sent aspir...
        CALL    AfficheWinWait
        LD      HL,DialAspire2Vue9
        CALL    AfficheWinWait          ; Message aprs dplacement
        LD      HL,DialAspire3Vue9
        CALL    AfficheWinWait          ; Message aprs dplacement
        XOR     A
        LD      (ObjUtil),A             ; Mode = recherche
        LD      (ModeUtil),A            ; Pas d'objets utiliss
        LD      HL,Inventaire
        LD      DE,Inventaire+1
        LD      BC,9
        LD      (HL),A
        LDIR                            ; Vider inventaire
        LD      B,18
        JP      GoVue                   ; Aller  la vue de "Willy"
FctCpcManque:
        LD      HL,DialCpcManqueVue9    ; Il manque quelque chose...
        JR      FctAfficheVue9
FctCpcEteint
        LD      HL,DialCpcEteintVue9
        JR      FctAfficheVue9

;
; #####################################
; ##                                 ##
; ## Vue 12 - L'ange Gabrielle       ##
; ##                                 ##
; #####################################
;
FctStartVue12:
        LD      A,(GabrielleVue)
        AND     A                       ; Dj vu Gabrielle ?
        RET     NZ                      ; Si oui, pas de message d'accueil
        INC     A
        LD      (GabrielleVue),A
        LD      A,3
        LD      (NbVies),A
        LD      HL,DialInitGabrielVue12
        CALL    AfficheTexteInit
        LD      HL,DialInitGabriel2Vue12
        JR      FctRepAngeVue12

FctAngeVue12:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialQuestionGabrielVue12
        LD      A,2                     ; 2 choix possibles
        CALL    WaitQCM                 ; Attente rponse du joueur
        LD      HL,DialRep1GabrielVue12 ; Rponse au choix 1
        DEC     A                       ; Choix 1 ?
        JR      Z,FctRepAngeVue12       ; si oui, afficher
        LD      HL,DialRep2GabrielVue12 ; Rponse au choix 2
FctRepAngeVue12:
        JP      AfficheWinWait

;
; #####################################
; ##                                 ##
; ## Vue 14 - Dbarquement ennemi    ##
; ##                                 ##
; #####################################
;
FctStartVue14:
        LD      HL,DialDebarqueVue14
        JP      AfficheTexteInit

;
; #####################################
; ##                                 ##
; ## Vue 15 - Astrix et Oblix      ##
; ##                                 ##
; #####################################
;
FctAsterixObelixVue15
        LD      HL,DialAsterix5Vue15
        LD      A,(AsterixDejaVu)
        AND     A
        JR      NZ,FctAsterixGarnisonVue15
        LD      A,1
        LD      (AsterixDejaVu),A
        LD      HL,DialAsterix1Vue15
        CALL    AfficheWinMsg
        CALL    #BB18
        CALL    AffImgVue
        LD      HL,DialAsterix2Vue15
FctAsterixGarnisonVue15:
        CALL    AfficheWinMsg
        CALL    #BB18
        CALL    AffImgVue
        LD      HL,DialAsterix3Vue15
        CALL    AfficheWinWait
        LD      HL,DialAsterix4Vue15
        CALL    AfficheWinMsg
        CALL    #BB18
        JP      AffImgVue

;
; #####################################
; ##                                 ##
; ## Vue 18 - Willy                  ##
; ##                                 ##
; #####################################
;
FctWillyVue18:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(WillyVu)
        AND     A
        JR      NZ,FctWillyVuVue18
        LD      HL,DialWilly1Vue18
        CALL    AfficheWinWait
        LD      HL,DialQCMOuiNon
        LD      A,2
        CALL    WaitQCM
        CP      2
        JR      Z,FctRepOkWillyVue18
        LD      HL,DialWillyRep1Vue18
        JR      FctWillyMsg
FctRepOkWillyVue18:
        LD      A,1
        LD      (WillyVu),A
        LD      HL,DialWillyRep2Vue18
        CALL    AfficheWinWait
        LD      HL,DialWillyRep3Vue18
        CALL    AfficheWinWait
FctWillyVuVue18:
        LD      HL,DialWillyRep4Vue18
        LD      A,(ZakarEnFuite)
        AND     A
        JR      Z,FctWillyMsg
        LD      HL,DialWillyRep5Vue18
FctWillyMsg:
        JP      AfficheWinWait

;
; ########################################
; ##                                    ##
; ## Vue 20 - La clairire des barbares ##
; ##                                    ##
; ########################################
;
FctStartVue20:
        LD      A,(ManiementEpee)
        AND     A
        RET     NZ
        LD      A,(EpeePrise)
        AND     A
        RET     NZ
        LD      HL,DialBarbare1Vue20
        JP      AfficheTexteInit

FctBarbareDeplaceVue20:
        LD      B,19
        LD      A,(ManiementEpee)
        AND     A
        JP      NZ,GoVue                ; On passe  la vue 19 !!!
        LD      A,1
        LD      (PerdVie),A
        LD      HL,DialBarbareTueVue20
        LD      A,1
        LD      (InhibeInit+1),A        ; Inhibition fonction init.
        JR      FctBarbareAffiche

FctBarbareVue20:
        LD      HL,DialBarbare2Vue20
        LD      A,(ModeUtil)
        AND     A
        JR      Z,FctBarbareAffiche
        LD      A,(ObjUtil)
        CP      OBJ_Epee                ; Objet = pe ?
        JP      NZ,FctAffMarchePas
        LD      A,(ToucheBarbare)
        INC     A
        LD      (ToucheBarbare),A
        LD      HL,DialBarbare3Vue20
        DEC     A
        JR      Z,FctBarbareAffiche
        LD      HL,DialBarbare4Vue20
        DEC     A
        JR      Z,FctBarbareAffiche
        LD      A,1
        LD      (ManiementEpee),A       ; Maniement de l'pe obtenue
        LD      HL,DialBarbare5Vue20
FctBarbareAffiche:
        JP      AfficheWinWait

FctVaincuVue20:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialRienInteressant
        LD      A,(EpeePrise)
        AND     A                       ; Epe dj prise ?
        JR      NZ,FctBarbareAffiche
        LD      A,OBJ_Epee              ; Objet = pe
        CALL    AjouteObjInv
        LD      A,1
        LD      (EpeePrise),A           ; pe prise
        LD      HL,DialEpeeVue20
        JR      FctBarbareAffiche

;
; ########################################
; ##                                    ##
; ## Vue 22 - Chez la sorcire          ##
; ##                                    ##
; ########################################
;
FctSorciereVue22:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctSorciereUtil
        LD      HL,DialProtectionMagieOk
        LD      A,(ProtectionMagie)
        AND     A                       ; Protection contre la magie obtenue ?
        JP      NZ,FctAfficheVue22
        LD      HL,DialSorcierePasIngredients
        LD      A,(IngredientsPotionMagie)
        CP      7
        JR      NZ,FctSorciere2Vue22
        LD      HL,DialSorcierePasPiece
FctSorciere2Vue22:
        LD      A,(AccepteSorciere)
        AND     A                       ; Proposition de la sorcire accepte ?
        JR      NZ,FctAfficheVue22
        LD      HL,DialSorciere1Vue22
        CALL    AfficheWinWait
        LD      HL,DialQCMAccepteRefuse
        LD      A,2
        CALL    WaitQCM                 ; Attente rponse du joueur
        DEC     A                       ; Choix 1 ?
        RET     NZ                      ; Si non, ne fait rien d'autre
        LD      A,1
        LD      (AccepteSorciere),A
        LD      HL,DialSorciere2Vue22   ; Rponse au choix 1
        JR      FctAfficheVue22
FctSorciereUtil:
        LD      A,(AccepteSorciere)
        AND     A                       ; Proposition de la sorcire accepte ?
        JP      Z,FctAffMarchePas
        LD      A,(ProtectionMagie)     ; Protection contre la magie obtenue ?
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,IngredientsPotionMagie
        LD      A,(ObjUtil)
        LD      B,1
        CP      OBJ_FleurTropicale      ; Objet = Fleur tropicale ?
        JR      Z,FctSorciereAjoute
        LD      B,2
        CP      OBJ_OsHumain            ; Objet = Os humain ?
        JR      Z,FctSorciereAjoute
        LD      B,4
        CP      OBJ_Energium            ; Objet = Energium ?
        JR      Z,FctSorciereAjoute
        CP      OBJ_PiecesOr
        LD      HL,DialIngredientMauvais
        JR      NZ,FctAfficheVue22
        LD      A,(PiecesDonnees)
        LD      HL,DialSorcierePasIngredients
        AND     A                       ; Pices dj donnes ?
        JR      NZ,FctAfficheVue22
        LD      A,(NbPiecesOr)
        CP      10                      ; Au moins 10 pices d'or ?
        LD      HL,DialPasAssezPieces
        JR      C,FctAfficheVue22       ; Sinon, message pas assez
        SUB     10
        LD      (NbPiecesOr),A          ; Enlve 10 pices d'or
        AND     A
        JR      NZ,FctEncorePieces      ; Si encore pices, pas supprimer
        LD      A,OBJ_PiecesOr
        CALL    SupObjInv               ; Supprime pices de l'inventaire
FctEncorePieces:
        LD      A,1
        LD      (PiecesDonnees),A
        LD      A,(IngredientsPotionMagie)
        CP      7
        LD      HL,DialSorcierePasIngredients
        JR      NZ,FctAfficheVue22
        LD      A,1
        LD      (ProtectionMagie),A
        LD      HL,DialPotionMagieOk
FctAfficheVue22:
        JP      AfficheWinWait
FctSorciereAjoute:
        PUSH    AF
        LD      A,(HL)
        OR      B                       ; Positionne le bit correspondant
        LD      (HL),A
        POP     AF
        CALL    SupObjInv               ; Supprime l'objet de l'inventaire
        LD      HL,DialIngredientOk
        CALL    AfficheWinWait          ; Affiche ingrdient ok
        LD      A,(PiecesDonnees)
        AND     A
        RET     Z
        JR      FctEncorePieces

;
; ########################################
; ##                                    ##
; ## Vue 23 - Dizzy                     ##
; ##                                    ##
; ########################################
;
FctDizzyVue23:
        LD      A,(DizzyVu)
        AND     A
        JR      NZ,FctVuDizzyVue23
        LD      HL,DialDizzy1Vue23
        CALL    AfficheWinWait
        LD      HL,DialDizzy2Vue23
        LD      A,1
        LD      (DizzyVu),A
FctAfficheVue23:
        JP      AfficheWinWait
FctVuDizzyVue23:
        LD      HL,DialDizzy3Vue23
        JR      FctAfficheVue23

;
; ########################################
; ##                                    ##
; ## Vue 25 - La mine - Premire salle  ##
; ##                                    ##
; ########################################
;
FctStartVue25:
        LD      A,#FF
        LD      (LampeZoneVue25+1),A    ; Inhiber zone lampe vue 25
        LD      (CasqueZoneVue25+1),A   ; Inhiber zone casque vue 25
        LD      (PiocheZoneVue25+1),A   ; Inhiber zone pioche vue 25
        LD      HL,SptPioche25
        LD      A,(PiochePrisSalle25)
        AND     A                       ; Pioche prise ?
        JR      NZ,FctStart2Vue25
        LD      A,66
        LD      (PiocheZoneVue25+1),A   ; Autoriser zone pioche vue 25
        CALL    DepkWin
FctStart2Vue25:
        LD      HL,SptCasque25
        LD      A,(CasquePris)
        AND     A                       ; Casque pris ?
        JR      NZ,FctStart3Vue25
        LD      A,69
        LD      (CasqueZoneVue25+1),A   ; Autoriser zone casque vue 25
        CALL    DepkWin
FctStart3Vue25
        LD      HL,SptLampe25
        LD      A,(LampePris)
        AND     A                       ; Lampe prise ?
        RET     NZ
        LD      A,67
        LD      (LampeZoneVue25+1),A    ; Autoriser zone lampe vue 25
        JP      DepkWin

FctLampeVue25:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,OBJ_Lampe
        CALL    RechObjInv
        LD      HL,DialDejaLampe
        JP      Z,AfficheWinWaitC7
        LD      A,OBJ_Lampe             ; Objet = Lampe
        CALL    AjouteObjInv
        LD      A,1
        LD      (LampePris),A
        CPL
        LD      (LampeZoneVue25+1),A    ; Inhiber zone de la lampe
        LD      HL,DialPrLampe
        JR      FctAfficheVue25

FctCasqueVue25:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,OBJ_Casque            ; Objet = casque
        CALL    AjouteObjInv
        LD      A,1
        LD      (CasquePris),A
        CPL
        LD      (CasqueZoneVue25+1),A   ; Inhiber zone du casque
        LD      HL,DialPrCasque
FctAfficheVue25:
        JP      AfficheWinWait

FctPiocheVue25:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialDejaPioche
        LD      A,(PiochePrisSalle27)
        AND     A
        JR      NZ,FctAfficheVue25
        LD      A,OBJ_Pioche            ; Objet = pioche
        CALL    AjouteObjInv
        LD      A,1
        LD      (PiochePrisSalle25),A
        CPL
        LD      (PiocheZoneVue25+1),A   ; Inhiber zone de la pioche
        LD      HL,DialPrPioche
        JR      FctAfficheVue25

FctSorsMineVue25:
        LD      A,OBJ_Casque
        CALL    SupObjInv               ; Repose le casque si pris
        LD      A,OBJ_Pioche
        CALL    SupObjInv               ; Repose la pioche si prise
        XOR     A
        LD      (PiochePrisSalle25),A
        LD      (PiochePrisSalle27),A
        LD      (CasquePris),A
        LD      B,24
        JP      GoVue

;
; ########################################
; ##                                    ##
; ## Vue 26 - La mine - Le couloir      ##
; ##                                    ##
; ########################################
;
FctAscenceurVue26:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialEbouleVue26
        LD      A,(ProtectionArmure)
        AND     A
        JP      NZ,AfficheWinWait
        LD      HL,DialAscenseurVue26
        CALL    AfficheWinWait
        LD      B,29
        JP      GoVue

;
; ########################################
; ##                                    ##
; ## Vue 27 - La mine - Seconde salle   ##
; ##                                    ##
; ########################################
;
FctStartVue27:
        LD      A,#FF
        LD      (PiocheZoneVue27+1),A   ; Inhiber zone pioche
        LD      HL,SptPioche27
        LD      A,(PiochePrisSalle27)
        AND     A
        RET     NZ
        LD      A,5
        LD      (PiocheZoneVue27+1),A   ; Autoriser zone pioche
        JP      DepkWin

FctPiocheVue27:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialDejaPioche
        LD      A,(PiochePrisSalle25)
        AND     A
        JP      NZ,FctAfficheVue27
        LD      A,OBJ_Pioche            ; Objet = pioche
        CALL    AjouteObjInv
        LD      A,1
        LD      (PiochePrisSalle27),A
        CPL
        LD      (PiocheZoneVue27+1),A    ; Inhiber zone de la pioche
        LD      HL,DialPrPioche
FctAfficheVue27:
        JP      AfficheWinWait

;
; ########################################
; ##                                    ##
; ## Vue 28 - La mine - Salle boule   ##
; ##                                    ##
; ########################################
;
FctPierreVue28:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctTerreVue28
        LD      HL,DialPierreVue28
FctAfficheVue28:
        JP      AfficheWinWait

FctDiamantVue28:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctTerreVue28
        LD      A,OBJ_Diamant
        CALL    RechObjInv
        LD      HL,DialDejaDiamantVue28
        JR      Z,FctAfficheVue28
        LD      A,Obj_Diamant
        CALL    AjouteObjInv
        LD      HL,DialDiamantVue28
        JR      FctAfficheVue28
FctTerreVue28:
        LD      A,(ModeUtil)
        AND     A
        RET     Z
        LD      A,(ObjUtil)
        CP      OBJ_Pioche          ; Objet = pioche ?
        JP      NZ,FctAffMarchePas
        LD      HL,DialTerreVue28
        JR      FctAfficheVue28

;
; ########################################
; ##                                    ##
; ## Vue 29 - L'ennemi cherche l'armure ##
; ##                                    ##
; ########################################
;
FctStartVue29:
        LD      A,#FF
        LD      (GeantZoneVue29+1),A    ; Inhiber zone du gant
        LD      A,(GeantEnFuite)
        AND     A
        RET     NZ
        LD      A,40
        LD      (GeantZoneVue29+1),A    ; Autoriser zone du gant
        LD      HL,SptGeant
        CALL    DepkWin
        LD      A,(NouvelleVue)
        AND     A
        RET     Z
        XOR     A
        LD      (NouvelleVue),A
        CALL    SetColImg
        LD      A,#30
        CALL    SetAdrMemEcr            ; Adresse cran en #C000
        LD      HL,DialGeantVue29
        CALL    AfficheWinNoWait
        CALL    CopieEcran
        CALL    #BB18
        CALL    AffImgDcmp
        LD      HL,SptGeant
        CALL    DepkWin
        LD      A,#30
        CALL    SetAdrMemEcr            ; Adresse cran en #C000
        LD      HL,DialQCMOuiNon
        LD      A,2
        CALL    WaitQCM
        CP      2
        LD      HL,DialGeant2Vue29
        JR      Z,GeantAffiche
        LD      HL,DialGeant3Vue29
        LD      A,1
        LD      (PerdVie),A
GeantAffiche:
        JP      AfficheWinWait

FctGeantVue29:
        LD      HL,DialGeant5Vue29
        LD      A,(ModeUtil)
        AND     A                       ; Mode utilisation ?
        JR      Z,GeantAffiche          ; Si non, affiche message du gant
        LD      A,(ObjUtil)
        CP      OBJ_Epee                ; Objet = pe ?
        JR      NZ,GeantAffiche
        LD      HL,DialGeant4Vue29
        LD      A,1
        LD      (GeantEnFuite),A        ; Gant en fuite
        JR      GeantAffiche

FctPancarteVue29:
        LD      HL,DialGeant5Vue29
        LD      A,(GeantEnFuite)
        AND     A
        JR      Z,GeantAffiche
        LD      HL,DialPancarteVue29
        JP      FctAffMessGene

FctTerreVue29:
        LD      HL,DialGeant5Vue29
        LD      A,(GeantEnFuite)
        AND     A
        JR      Z,GeantAffiche
        LD      HL,DialRienInteressant
        JP      FctAffMessGene

FctMurVue29:
        LD      HL,DialGeant5Vue29
        LD      A,(GeantEnFuite)
        AND     A                       ; Gant en fuite ?
        JR      Z,GeantAffiche
        LD      HL,DialMurVue29
        LD      A,(ModeUtil)
        AND     A
        JR      Z,GeantAffiche
        LD      A,(ObjUtil)
        CP      OBJ_Pioche
        JP      NZ,FctAffMarchePas
        LD      HL,DialMur2Vue29
        CALL    AfficheWinWait
        XOR     A
        LD      (ModeUtil),A
        LD      B,30
        JP      GoVue

;
; ########################################
; ##                                    ##
; ## Vue 30 - L'armure d'Antiriad       ##
; ##                                    ##
; ########################################
;
FctStartVue30:
        LD      HL,DialArmureVue30
        CALL    AfficheTexteInit
        LD      A,1
        LD      (ProtectionArmure),A    ; Protection aqcuise
        LD      B,26
        JP      GoVue                   ; On retourne  la vue 26

;
; ########################################
; ##                                    ##
; ## Vue 32 - Le sphynx                 ##
; ##                                    ##
; ########################################
;
FctSphynxVue32:
        LD      HL,DialSphinxVue32
        CALL    AfficheWinNoWait
        LD      HL,#0217
        CALL    #BB75
        CALL    SaisieMot               ; Saisie clavier
        LD      DE,MotSphinx
        CALL    RechercheMot
        LD      HL,DialSphinxOkVue32
        JR      Z,FctAfficheVue32
        LD      HL,DialSphinxPasOkVue32
FctAfficheVue32:
        JP      AfficheWinWait

;
; ########################################
; ##                                    ##
; ## Vue 33 - La salle des sacrifices   ##
; ##                                    ##
; ########################################
;
FctTableauVue33:
        LD      HL,DialTableau1Vue33
        CALL    AfficheWinWaitC7
        LD      HL,DialTableau2Vue33
        CALL    AfficheWinWaitC7
        LD      HL,DialTableau3Vue33
        JR      FctAfficheVue33

FctOssementsVue33:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(OsPris)
        AND     A
        JP      NZ,FctAffRienSpecial
        LD      A,OBJ_OsHumain
        CALL    AjouteObjInv
        LD      HL,DialOsVue33
        LD      A,1
        LD      (OsPris),A
FctAfficheVue33:
        JP      AfficheWinWaitC7

;
; ########################################
; ##                                    ##
; ## Vue 34 - Rick dangerous            ##
; ##                                    ##
; ########################################
;
FctStartVue34:
        LD      A,(NouvelleVue)         ; Permet de n'excuter qu'une seule
        AND     A                       ; fois la fonction d'init. lorsque
        RET     Z                       ; l'on reste sur la mme vue.
        XOR     A
        LD      (NouvelleVue),A
        LD      A,(DynamiteDonnee)
        AND     A                       ; Donn dynamite  Rick ?
        RET     Z                       ; Si non, ne rien faire
        LD      A,2                     ; Indique Rick peut nous donner
        LD      (DynamiteDonnee),A      ; le clavier du CPC
        RET

FctRickVue34:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctRickUtil
        LD      HL,DialRick1Vue34
        LD      A,(DynamiteDonnee)
        AND     A
        JR      Z,FctAfficheVue34
        LD      HL,DialRick21Vue34
        DEC     A
        JR      Z,FctAfficheVue34
        LD      A,OBJ_ClavierCPC
        CALL    RechObjInv              ; Avons-nous dja le clavier ?
        LD      HL,DialRick4Vue34
        JR      Z,FctAfficheVue34       ; Clavier dj donn
        LD      A,OBJ_ClavierCPC
        CALL    AjouteObjInv            ; Rick nous donne le clavier
        LD      HL,DialRick3Vue34
        JR      FctAfficheVue34
FctRickUtil:
        LD      A,(ObjUtil)
        CP      OBJ_Dynamite            ; Objet = dynamite ?
        JP      NZ,FctAffMarchePas
        CALL    SupObjInv
        LD      A,1
        LD      (DynamiteDonnee),A      ; Dynamite donne  rick
        LD      HL,DialRick2Vue34
        JR      FctAfficheVue34
FctAfficheVue34:
        JP      AfficheWinWait

;
; ########################################
; ##                                    ##
; ## Vue 35 - Blue Berry                ##
; ##                                    ##
; ########################################
;
FctBlueBerryVue35:
        LD      HL,DialBlueBerry1Vue35
        CALL    AfficheWinWaitC7
        LD      HL,DialBlueBerry2Vue35
        JP      AfficheWinWaitC7

;
; ########################################
; ##                                    ##
; ## Vue 36 - Billy the kid             ##
; ##                                    ##
; ########################################
;
FctStartVue36
        LD      A,(NouvelleVue)
        AND     A
        RET     Z
        XOR     A
        LD      (NouvelleVue),A
        LD      HL,DialBillyVue36
        CALL    AfficheTexteInit
        LD      HL,DialQCMBillyVue36
        LD      A,3                     ; 3 choix possibles
        CALL    WaitQCM                 ; Attente rponse du joueur
        LD      HL,DialRepBilly3
        CP      3                       ; Choix 3 ?
        JR      Z,FctMsgBilly
        LD      HL,DialRepBilly2
        CP      2                       ; Choix 2 ?
        JR      Z,FctMsgBilly
        LD      HL,DialRepBilly1
        LD      A,(ProtectionArmure)
        AND     A                       ; Avons-nous l'armure d'Antiriad ?
        JR      Z,FctPerdVieVue36
        CALL    AfficheTexteInit
        LD      HL,DialArmureSauve      ; L'armure nous sauve...
        JR      FctMsgBilly
FctPerdVieVue36:
        LD      A,1
        LD      (PerdVie),A             ; On pert une vie...
FctMsgBilly:
        JP      AfficheTexteInit

;
; ########################################
; ##                                    ##
; ## Vue 37 - Le saloon                 ##
; ##                                    ##
; ########################################
;
FctPokerVue37:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctPokerUtil
        LD      HL,DialHomme6
        LD      A,(CarteGagnee)
        AND     A
        JP      NZ,FctAfficheVue37
        LD      HL,DialHomme1
        JP      FctAfficheVue37
FctPokerUtil:
        LD      A,(CarteGagnee)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(ObjUtil)
        CP      OBJ_Diamant
        LD      HL,DialHomme2
        JP      NZ,FctAfficheVue37
        CALL    SupObjInv
        LD      HL,DialHomme3
        CALL    AfficheWinWaitC7
        XOR     A
        LD      (MancheJoueur+1),A
        LD      (MancheCPC+1),A
        LD      HL,DialPoker1
        CALL    AfficheWinWaitC7
FctJouePoker:
        CALL    CopieEcran
        CALL    EffaceEcran
        LD      A,1
        LD      BC,#1A1A
        CALL    #BC32
        LD      A,2
        LD      BC,#0606
        CALL    #BC32
        LD      A,3
        LD      BC,#0909
        CALL    #BC32
        LD      A,#30
        CALL    SetAdrMemEcr
        LD      A,30
        LD      (NumVue),A              ; Vue 30 n'a pas de zones
        CALL    JouePoker               ; Jouer une partie
        CALL    VideBuffClav
        LD      A,37
        LD      (NumVue),A              ; Remet la bonne vue
        LD      A,(ScoreCPC)
        LD      B,A
        LD      A,(ScoreJoueur)
        CP      B
        JR      C,MancheCPC             ; CPC a gagn
MancheJoueur:
        LD      A,0
        INC     A
        LD      (MancheJoueur+1),A      ; Joueur gagne une partie en plus
        CP      2
        JR      Z,JoueurGagne2
        LD      HL,DialPokerGagne1
        CALL    AfficheWinNoWaitC7
        LD      B,150
        CALL    WaitFrames
        JR      FctJouePoker
JoueurGagne2:
        LD      A,OBJ_CarteTresor
        CALL    AjouteObjInv            ; Joueur gagne carte au trsor
        LD      HL,DialPokerGagne2
        CALL    AfficheWinWaitC7
        LD      A,1
        LD      (CarteGagnee),A         ; Mmoriser carte gagne
        LD      HL,DialHomme4
        JR      FctAfficheVue37
MancheCPC:
        LD      A,0
        INC     A
        LD      (MancheCPC+1),A         ; CPC gagne une partie en plus
        CP      2
        JR      Z,JoueurPerd2
        LD      HL,DialPokerPerd1
        CALL    AfficheWinNoWaitC7
        LD      B,150
        CALL    WaitFrames
        JR      FctJouePoker
JoueurPerd2:
        LD      HL,DialPokerPerd2
        CALL    AfficheWinWaitC7
        LD      HL,DialHomme5
FctAfficheVue37:
        JP      AfficheWinWaitC7

FctBarmanVue37:
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,FctBarmanUtil
        LD      HL,DialBarman1
        JR      FctAfficheVue37
FctBarmanUtil:
        LD      A,(ObjUtil)
        CP      OBJ_CaisseWhisky
        JR      Z,FctBarmanLivraison
        CP      OBJ_PiecesOr
        JP      NZ,FctAffMarchePas
        LD      HL,DialBarman3
        CALL    AfficheWinWaitC7
        LD      A,(NbPiecesOr)
        DEC     A                       ; Enlve une pice d'or
        LD      (NbPiecesOr),A
        AND     A
        RET     NZ
        LD      A,OBJ_PiecesOr
        JP      SupObjInv               ; Supprime pices de l'inventaire
FctBarManLivraison:
        CALL    SupObjInv
        LD      A,OBJ_PiecesOr
        CALL    RechObjInv              ; A-t-on dj des pices d'or ?
        JR      Z,FctBarmanDejaOr
        LD      A,OBJ_PiecesOr
        CALL    AjouteObjInv            ; On ajoute les pices d'or
FctBarmanDejaOr:
        LD      A,(NbPiecesOr)
        ADD     A,10
        LD      (NbPiecesOr),A
        LD      HL,DialBarman2
        JR      FctAfficheVue37


;
; ########################################
; ##                                    ##
; ## Vue 39 - Lecon de karat           ##
; ##                                    ##
; ########################################
;
FctMaitreVue39:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialMaitre3Vue39
        LD      A,(LeconKarate)
        AND     A
        JR      NZ,FctAfficheVue39
        LD      HL,DialQCMMaitreVue39
        LD      A,2                     ; 2 choix possibles
        CALL    WaitQCM                 ; Attente rponse du joueur
        CP      2
        RET     Z
        LD      HL,DialMaitre1Vue39
        CALL    AfficheWinWait
        LD      A,1
        LD      (LeconKarate),A
        LD      HL,DialMaitre2Vue39
FctAfficheVue39:
        JP      AfficheWinWait

;
; ########################################
; ##                                    ##
; ## Vue 40 - Nbulus                   ##
; ##                                    ##
; ########################################
;
FctNebulusVue40:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
FctNebulusObjVue40
        LD      HL,DialSousMarinPanne
        LD      A,(NavigateurRepare)
        AND     A                       ; Navigateur rpar ?
        JR      Z,FctNebulusAffiche
        LD      HL,DialSousMarinOk
        JR      FctNebulusAffiche

FctSousMarinVue40:
        LD      A,(ModeUtil)
        AND     A                       ; Mode utilisation ?
        JR      Z,FctNebulusObjVue40
        LD      A,(ObjUtil)
        CP      OBJ_Navigateur          ; Objet = navigateur ?
        JP      NZ,FctAffMarchePas
        CALL    SupObjInv
        LD      A,1
        LD      (NavigateurRepare),A    ; Navigateur rpar 
        JR      FctNebulusVue40

FctIleVue40:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(NavigateurRepare)
        LD      B,41
        AND     A                       ; Navigateur rpar ?
        JP      NZ,GoVue
        LD      HL,DialIleVue40
FctNebulusAffiche:
        JP      AfficheWinWait

;
; ########################################
; ##                                    ##
; ## Vue 42 - Jungle tropicale          ##
; ##                                    ##
; ########################################
;
FctFleurVue42
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(FleurPrise)
        AND     A
        JP      NZ,FctAffRienSpecial
        LD      A,OBJ_FleurTropicale
        CALL    AjouteObjInv
        LD      HL,DialFleurTropicaleVue42
        LD      A,1
        LD      (FleurPrise),A
        JP      AfficheWinWait

;
; ########################################
; ##                                    ##
; ## Vue 44 - Robinson Cruso           ##
; ##                                    ##
; ########################################
;
FctStartVue44:
        LD      A,#FF
        LD      (LanterneZoneVue44+1),A ; Inhiber zone lanterne
        LD      A,(LampeRobinsonPrise)
        AND     A
        RET     NZ
        LD      (LanterneZoneVue44+1),A ; Autoriser zone lanterne
        LD      HL,SptLampeRobinson
        JP      DepkWin

FctRobinsonVue44:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(RobinsonVu)
        AND     A                       ; Dj vu Robinson ?
        JR      NZ,FctRobinsonVuVue44
        INC     A
        lD      (RobinsonVu),A
        LD      HL,DialRobinson1Vue44   ; Sinon, Robinson pose une question
        CALL    AfficheWinWaitC7
        LD      HL,DialQCMRobinsonVue44
        LD      A,2
        CALL    WaitQCM                 ; Attente rponse du joueur
        DEC     A                       ; Aider Robinson ?
        JR      Z,FctRobinsonAmiVue44
        LD      HL,DialRobinsonPasAmi1Vue44
        JR      FctAfficheVue44
FctRobinsonAmiVue44:
        LD      A,1
        LD      (RobinsonAmi),A
        LD      HL,DialRobinsonAmi1Vue44
        JR      FctAfficheVue44
FctRobinsonVuVue44:
        LD      HL,DialRobinsonPasAmi2Vue44
        LD      A,(RobinSonAmi)
        AND     A
        JR      Z,FctAfficheVue44
        LD      HL,DialRobinsonAmi2Vue44
FctAfficheVue44:
        JP      AfficheWinWaitC7

FctLanterneVue44:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,OBJ_Lampe
        CALL    RechObjInv              ; Avons-nous dj une lampe ?
        LD      HL,DialDejaLampe
        JR      Z,FctAfficheVue44       ; Si oui, inutile de prendre celle-ci
        LD      HL,DialCouteauFusilVue44
        LD      A,(GrotteVue)
        AND     A                       ; Avons-nous vu la grotte ?
        JP      Z,AfficheWinWait        ; Si non, il ne nous la donne pas
        LD      A,(RobinsonAmi)
        AND     A                       ; Robinson est-il notre ami ?
        JR      Z,FctAfficheVue44       ; Si non, il ne nous la donne pas
        LD      A,OBJ_Lampe
        CALL    AjouteObjInv            ; On prends la lampe
        LD      A,1
        LD      (LampeRobinsonPrise),A  ; Lampe prise
        LD      HL,DialRobinsonAmi3Vue44
        JR      FctAfficheVue44

;
; ########################################
; ##                                    ##
; ## Vue 45 - Les indignes             ##
; ##                                    ##
; ########################################
;
FctHommeVue45:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialHomme3Vue45
        LD      A,(ProtectionEsprit)
        AND     A
        JR      NZ,FctAfficheVue45
        LD      HL,DialHomme1Vue45
        LD      A,(PiratesPartis)
        AND     A                       ; Pirates sur le point de partir ?
        JR      Z,FctAfficheVue45
        LD      HL,DialHomme2Vue45
        CALL    AfficheWinWaitC7
        LD      A,1
        LD      (ProtectionEsprit),A
        LD      HL,DialChamanVue45
FctAfficheVue45:
        JP      AfficheWinWaitC7

;
; ########################################
; ##                                    ##
; ## Vue 47 - Dans la grotte            ##
; ##                                    ##
; ########################################
;
FctStartVue47:
        LD      A,1
        LD      (GrotteVue),A           ; Nous avons vu la grotte
        LD      (ZoneVue47),A           ; Curseur sur trsor = Loupe
        LD      A,OBJ_Lampe             ; Possde-t-on la lampe ?
        CALL    RechObjInv
        RET     Z                       ; Si oui, ne pas effacer
        CALL    EffaceEcran
        LD      A,4
        LD      (ZoneVue47),A           ; Curseur sur trsor = Flche
        LD      A,#30
        CALL    SetAdrMemEcr
        LD      A,5
        CALL    SetBank
        LD      HL,FenDialogue
        CALL    AfficheWinMsg
        LD      DE,DialGrotteSombreVue47
        CALL    PrtMWin
        CALL    #BB18
        JP      EffaceEcran

FctTresorVue47:
        LD      A,OBJ_Tresor
        CALL    RechObjInv              ; Trsor dj trouv ?
        JP      Z,FctAffRienInteressant
        LD      A,(ModeUtil)
        AND     A
        JR      Z,FctPasCarteVue47
        LD      A,(ObjUtil)
        CP      OBJ_CarteTresor         ; Objet utilis = carte trsor ?
        JP      NZ,FctAffMarchePas
        LD      A,OBJ_Tresor
        CALL    AjouteObjInv            ; Ajoute le trsor dans l'inventaire
        LD      HL,DialTresorVue47
        JR      FctAfficheVue47
FctPasCarteVue47:
        LD      HL,DialPasCarteVue47
FctAfficheVue47:
        JP      AfficheWinWaitC7

;
; ########################################
; ##                                    ##
; ## Vue 48 - Les pirates               ##
; ##                                    ##
; ########################################
;
FctPirateVue48:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialRepChef4Vue48
        LD      A,(PiratesPartis)
        AND     A                       ; Pirates sur le point de partir ?
        JR      NZ,FctAfficheVue48
        LD      HL,DialChefVue48
        CALL    AfficheWinWaitC7
        LD      HL,DialQCMChefVue48
        LD      A,3
        CALL    WaitQCM                 ; Attente rponse du joueur
        LD      HL,DialRepChef1Vue48
        DEC     A
        JR      Z,FctAfficheVue48
        LD      HL,DialRepChef2Vue48
        DEC     A
        JR      Z,FctAfficheVue48
        LD      A,OBJ_Tresor
        CALL    RechObjInv              ; Possdes-t-on le trsor ?
        JR      Z,FctDonneTresorVue48   ; Si oui, on le donne aux pirates
        LD      HL,DialRepChefPasTresor
        JR      FctAfficheVue48
FctDonneTresorVue48:
        LD      A,OBJ_Tresor
        CALL    SupObjInv               ; Donne le trsor
        LD      A,OBJ_CarteTresor
        CALL    SupObjInv               ; Plus besoin de la carte non plus
        LD      A,1
        LD      (PiratesPartis),A       ; Pirates sur le point de partir
        LD      HL,DialRepChef3Vue48
        CALL    AfficheWinWaitC7
        LD      HL,DialRepChef4Vue48
FctAfficheVue48:
        JP      AfficheWinWaitC7

;
; ########################################
; ##                                    ##
; ## Vue 49 - Le cimetire des tnbres ##
; ##                                    ##
; ########################################
;
FctTombeXVue49:
        LD      HL,DialPasProtectionVue49
        LD      A,(ProtectionEsprit)
        AND     A
        JR      Z,FctAfficheVue49
        LD      HL,DialTombeVue49
FctAfficheVue49:
        JP      AfficheWinWaitC7

FctTombe3Vue49:
        LD      HL,DialPasProtectionVue49
        LD      A,(ProtectionEsprit)
        AND     A
        JR      Z,FctAfficheVue49
        LD      HL,DialTombe3Vue49
        CALL    AfficheWinWaitC7
        LD      B,50
        JP      GoVue

;
; ########################################
; ##                                    ##
; ## Vue 50 - Les gouts du chateau     ##
; ##                                    ##
; ########################################
;
FctStartVue50:
        LD      A,(PosLevier)
        ADD     A,A
        LD      C,A
        LD      B,0
        LD      HL,PtrSpriteLevier      ; On obtient l'adresse du sprite
        ADD     HL,BC                   ;  dessiner
        LD      A,(HL)
        INC     HL
        LD      H,(HL)
        LD      L,A
        CALL    DepkWin
        LD      A,#FF
        LD      (ZoneVue50+1),A         ; Inhiber zone porte secrte
        LD      A,(PosLevier)
        AND     7
        CP      5
        RET     NZ
        LD      A,32
        LD      (ZoneVue50+1),A         ; Autoriser zone porte secrte
        LD      HL,SptPorteSecrete
        JP      DepkWin
PtrSpriteLevier:
        DW      SptLevier000
        DW      SptLevier001
        DW      SptLevier010
        DW      SptLevier011
        DW      SptLevier100
        DW      SptLevier101
        DW      SptLevier110
        DW      SptLevier111

FctLevierVue50:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(PosLevier)
        AND     4
        LD      B,A
        RRCA
        ADD     A,B
        ADD     A,'B'
        LD      (DialLevier1Vue50),A
        LD      A,(PosLevier)
        AND     2
        LD      B,A
        ADD     A,A
        ADD     A,B
        ADD     A,'B'
        LD      (DialLevier2Vue50),A
        LD      A,(PosLevier)
        AND     1
        LD      B,A
        ADD     A,A
        ADD     A,B
        ADD     A,A
        ADD     A,'B'
        LD      (DialLevier3Vue50),A
        LD      HL,DialQCMLevierVue50
        LD      A,3                     ; 3 choix possibles
        CALL    WaitQCM                 ; Attente rponse du joueur
        LD      HL,PosLevier
        DEC     A                       ; Choix = 1 ?
        JR      NZ,FctTest2Vue50
        LD      A,4
        XOR     (HL)
        LD      (HL),A
        JR      FctTestLeviers
FctTest2Vue50:
        DEC     A                       ; Choix = 2 ?
        JR      NZ,FctTest3Vue50
        LD      A,2
        XOR     (HL)
        LD      (HL),A
        JR      FctTestLeviers
FctTest3Vue50:
        LD      A,1
        XOR     (HL)
        LD      (HL),A
FctTestLeviers:
        PUSH    AF
        CALL    FctStartVue50
        POP     AF
        AND     7
        CP      5
        JR      NZ,FctafficheVue50
        LD      HL,DialPorteVue50
        JP      AfficheWinWaitC7
FctAfficheVue50:
        JP      AffImgVue

;
; ########################################
; ##                                    ##
; ## Vue 52 - Merlin de Gauntlet        ##
; ##                                    ##
; ########################################
;
FctMerlinVue52:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(MerlinVu)
        AND     A                       ; A-t-on dj vu Merlin ?
        LD      HL,DialMerlin3Vue52
        JR      NZ,FctMerlinRepVue52    ; Si oui, "bonjour" simple
        INC     A
        LD      (MerlinVu),A            ; On a vu Merlin
        LD      HL,DialMerlin1Vue52
        CALL    AfficheWinWait
        LD      HL,DialMerlin2Vue52
FctMerlinRepVue52:
        CALL    AfficheWinWait
        LD      A,(ZakarEnFuite)
        AND     A                       ; Zakar en fuite ?
        JR      NZ,FctMerlinQCM2        ; Si oui, passe au 2e QCM de Merlin
        LD      HL,DialQCMMerlinVue52
        CALL    AfficheWinMsg
        LD      A,5
        LD      (MaxChoixQCM+1),A
        CALL    WaitQCMKey
        LD      HL,DialRepMerlin1Vue52
        DEC     A
        JR      Z,FctMerlinRepVue52     ; Choix = 1
        LD      HL,DialRepMerlin2Vue52
        DEC     A
        JR      Z,FctMerlinRepVue52     ; Choix = 2
        LD      HL,DialRepMerlin3Vue52
        DEC     A
        JR      Z,FctMerlinRepVue52     ; Choix = 3
        LD      HL,DialRepMerlin5Vue52
        DEC     A
        JR      NZ,FctAfficheVue52      ; Choix = 5
        LD      HL,DialRepMerlin41Vue52
        CALL    AfficheWinWaitC7
        LD      HL,DialRepMerlin42Vue52
        CALL    AfficheWinWaitC7
        LD      HL,DialRepMerlin43Vue52
        CALL    AfficheWinWaitC7
FctTraverseDonjon
        LD      B,53
        JP      GoVue
FctMerlinQCM2:
        LD      HL,DialQCMMerlin2Vue52
        LD      A,3
        CALL    WaitQCM
        DEC     A
        JR      Z,FctTraverseDonjon
        LD      B,50                    ; Vers les gouts
        LD      HL,DialRepMerlin5Vue52
        DEC     A
        JP      Z,GoVue
FctAfficheVue52:
        JP      AfficheWinWait

;
; ########################################
; ##                                    ##
; ## Vue 55 - Salle du trone            ##
; ##                                    ##
; ########################################
;
FctStartVue55:
        LD      A,#FF
        LD      (ZoneVue55+1),A         ; Inhiber zone du passage secret
        LD      A,(PassageSecret)
        AND     A                       ; Passage secret dcouvert ?
        RET     Z
        LD      A,43
        LD      (ZoneVue55+1),A         ; Autoriser zone du passage secret
        LD      HL,SptPassageSecret
        JP      DepkWin

FctTorcheGVue55:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(PassageSecret)
        AND     A
        JP      NZ,FctAffRienSpecial
        INC     A
        LD      (PassageSecret),A
        LD      HL,DialPassageSecretVue55
        JP      AfficheWinWaitC7

;
; ########################################
; ##                                    ##
; ## Vue 56 - Zakar                     ##
; ##                                    ##
; ########################################
;
FctStartVue56:
        LD      A,(ZakarEnFuite)
        AND     A                       ; Zakar est en fuite ?
        RET     NZ
        LD      HL,SptZakar
        CALL    DepkWin
        CALL    SetColImg
        LD      HL,DialZakar1Vue56
        CALL    FctAfficheTexteZakar
        LD      HL,DialZakar2Vue56
        CALL    FctAfficheTexteZakar
        LD      HL,DialZakar3Vue56
        CALL    FctAfficheTexteZakar

        LD      HL,SptLaser
        CALL    DepkWin
        LD      A,#30
        CALL    SetAdrMemEcr
        LD      B,20                    ; Nombre de rptitions
FctFlashVue56:
        PUSH    BC
        CALL    #BD19
        LD      BC,#1A1A
        CALL    #BC38
        XOR     A
        LD      BC,#1A1A
        CALL    #BC32
        CALL    #BD19
        LD      BC,0
        CALL    #BC38
        XOR     A
        LD      BC,0
        CALL    #BC32
        POP     BC
        DJNZ    FctFlashVue56
        LD      HL,SptZakar
        CALL    DepkWin
        LD      A,(ProtectionArmure)
        AND     A                       ; Avons-nous l'armure d'Antiriad ?
        JR      NZ,FctAvecArmureVue56
        LD      A,1
        LD      (PerdVie),A             ; On pert une vie...
        LD      HL,DialZakarLaser1Vue56
        JR      FctAfficheTexteZakar

FctAvecArmureVue56:
        LD      HL,DialZakarLaser2Vue56
        CALL    FctAfficheTexteZakar
        LD      HL,DialZakarLaser3Vue56
        CALL    FctAfficheTexteZakar
        LD      A,(ProtectionMagie)
        AND     A                       ; Avons-nous la protection/magie ?
        JR      NZ,FctAvecMagieVue56
        LD      A,1
        LD      (JoueurPerdu),A         ; Perdu...
        LD      HL,DialZakarMagie1Vue56
        JR      FctAfficheTexteZakar
FctAvecMagieVue56:
        LD      A,1
        LD      (ZakarEnFuite),A        ; Zakar est en fuite !!!
        LD      HL,DialZakarMagie2Vue56
        CALL    FctAfficheTexteZakar
        LD      HL,DialZakarMagie3Vue56
        CALL    FctAfficheTexteZakar
        LD      HL,DialZakarMagie4Vue56
        CALL    FctAfficheTexteZakar
        JP      AffImgDcmp

FctCoffreVue56:
        LD      A,OBJ_EcranCPC
        CALL    RechObjInv              ; Avons-nous dj l'cran du CPC ?
        JP      Z,FctAffRienSpecial
        LD      A,OBJ_EcranCPC
        CALL    AjouteObjInv
        LD      HL,DialEcranVue56
        JP      AfficheWinWait

FctAfficheTexteZakar:
        CALL    AfficheWinNoWaitC7
        LD      A,#30
        CALL    SetAdrMemEcr
        CALL    CopieEcran
        CALL    #BB18
        CALL    VideBuffClav
        CALL    AffImgDcmp
        LD      HL,SptZakar
        JP      DepkWin


;
; ########################################
; ##                                    ##
; ## Vue 57 - L'entre de la base       ##
; ##                                    ##
; ########################################
;
FctPorteVue57:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(CodeBaseOk)
        AND     A
        JR      NZ,FctDeplaceOkVue57
        LD      HL,DialPorteVue57
        CALL    AfficheWinNoWait
        LD      HL,#0217
        CALL    #BB75
        CALL    SaisieMot               ; Saisie clavier
        LD      DE,CodeBase
        CALL    RechercheMot
        JR      Z,FctCodeBonVue57
        LD      HL,DialGardePasOk
        JP      AfficheWinWait
FctCodeBonVue57:
        LD      A,1
        LD      (CodeBaseOk),A
        LD      HL,DialGardeOk
        CALL    AfficheWinWait
FctDeplaceOkVue57:
        LD      B,58
        JP      GoVue

;
; ########################################
; ##                                    ##
; ## Vue 61 - L'entrepot de munitions   ##
; ##                                    ##
; ########################################
;
FctTntVue61:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(DynamiteDonnee)
        LD      HL,DialPlusTntVue61
        AND     A                       ; Dynamite dj donne  Rick ?
        JR      NZ,FctAfficheVue61
        LD      A,OBJ_Dynamite
        CALL    RechObjInv              ; Dj dynamite dans inventaire ?
        LD      HL,DialDejaTntVue61
        JR      Z,FctAfficheVue61
        LD      A,OBJ_Dynamite
        CALL    AjouteObjInv            ; Prends les batons de TNT
        LD      HL,DialTntVue61
FctAfficheVue61:
        JP      AfficheWinWaitC7

;
; #########################################
; ##                                     ##
; ## Vue 63 - L'arche du capitaine Blood ##
; ##                                     ##
; #########################################
;
FctGalaxieVue63:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialSaisieCoordVue63
        CALL    AfficheWinNoWait
        LD      HL,#0217
        CALL    #BB75
        CALL    SaisieMot               ; Saisie coordonnes plante
        LD      IX,MotSaisi
        LD      HL,0
        LD      BC,100
        LD      A,(IX+0)
        SUB     '0'
        JR      C,CalcDixCoordX
CalcCentCoordX:
        AND     A
        JR      Z,CalcDixCoordX
        ADD     HL,BC                   ; Ajoute centaines coordonne X
        DEC     A
        JR      CalcCentCoordX
CalcDixCoordX:
        LD      A,(IX+1)
        SUB     '0'
        JR      C,CalcUnCoordX
        LD      BC,10
CalcDixCoordX2:
        AND     A
        JR      Z,CalcUnCoordX
        ADD     HL,BC                   ; Ajoute dixaines coordonne X
        DEC     A
        JR      CalcDixCoordX2
CalcUnCoordX:
        LD      A,(IX+2)
        SUB     '0'
        JR      C,CalcFinCoordX
        LD      C,A
        LD      B,0
        ADD     HL,BC                   ; Ajoute units coordonne X
CalcFinCoordX:
        LD      (CoordXArche),HL
        LD      HL,0
        LD      BC,100
        LD      A,(IX+4)
        SUB     '0'
        JR      C,CalcDixCoordY
CalcCentCoordY:
        AND     A
        JR      Z,CalcDixCoordY
        ADD     HL,BC                   ; Ajoute centaines coordonne Y
        DEC     A
        JR      CalcCentCoordY
CalcDixCoordY:
        LD      A,(IX+5)
        SUB     '0'
        JR      C,CalcUnCoordY
        LD      BC,10
CalcDixCoordY2:
        AND     A
        JR      Z,CalcUnCoordY
        ADD     HL,BC                   ; Ajoute dixaines coordonne Y
        DEC     A
        JR      CalcDixCoordY2
CalcUnCoordY:
        LD      A,(IX+6)
        SUB     '0'
        JR      C,CalcFinCoordY
        LD      C,A
        LD      B,0
        ADD     HL,BC                   ; Ajoute units coordonne Y
CalcFinCoordY:
        LD      (CoordYArche),HL
        CALL    AffCoordArche
        CALL    FctGetNumAllie
        LD      (AllieTrouve),A         ; Numro de l'alli
        LD      HL,MessAllieVide
        LD      DE,PhraseAllie
        LD      BC,8
        LDIR                            ; Phrase alli vide au dmarrage
        LD      B,64                    ; Vers plante de l'arche
        LD      HL,(CoordXArche)
        LD      A,H
        OR      L                       ; Coordonne X diffrente de Zro ?
        JR      NZ,GoArche
        LD      HL,(CoordYArche)
        LD      A,H
        OR      L                       ; Coordonne Y diffrente de Zro ?
        JR      NZ,GoArche
        LD      B,62                    ; Vers la base
GoArche:
        JP      GoVue

;
; Affiche les coordonnes de l'arche
;
AffCoordArche:
        LD      HL,#1102
        CALL    #BB75
        LD      HL,(CoordXArche)
        LD      D,'0'
        CALL    PrintNum
        LD      HL,#1602
        CALL    #BB75
        LD      HL,(CoordYArche)
        LD      D,'0'
        JP      PrintNum

;
; Retourne le numro de l'alli trouv en fonction des coordonnes
; Sortie - A = 1, 2, 3 (numro de l'alli), ou 0 si pas trouv
;
FctGetNumAllie:
        LD      HL,Allie3Rallie
        LD      A,(HL)
        AND     A
        JR      NZ,FctGetNumAllie2
        LD      IX,CoordAllie3
        CALL    FctTestCoordAllie
        LD      A,3
        RET     Z
FctGetNumAllie2:
        LD      HL,Allie2Rallie
        LD      A,(HL)
        AND     A
        JR      NZ,FctGetNumAllie1
        LD      IX,CoordAllie2
        CALL    FctTestCoordAllie
        LD      A,2
        RET     Z
FctGetNumAllie1:
        LD      HL,Allie1Rallie
        LD      A,(HL)
        AND     A
        JR      NZ,FctGetNumAlliePasOk
        LD      IX,CoordAllie1
        CALL    FctTestCoordAllie
        LD      A,1
        RET     Z
FctGetNumAlliePasOk:
        XOR     A
        RET
FctTestCoordAllie:
        LD      HL,CoordXArche
        LD      A,(HL)
        INC     HL
        CP      (IX+0)
        RET     NZ
        LD      A,(HL)
        INC     HL
        CP      (IX+1)
        RET     NZ
        LD      A,(HL)
        INC     HL
        CP      (IX+2)
        RET     NZ
        LD      A,(HL)
        CP      (IX+3)
        RET

;
; ########################################
; ##                                    ##
; ## Vue 64 - L'arche sur une plante   ##
; ##                                    ##
; ########################################
;
FctStartVue64:
        LD      A,(NouvelleVue)
        AND     A
        JR      Z,FctStart2Vue64
        LD      HL,TaillePhraseArche
        LD      D,H
        LD      E,L
        LD      BC,16
        LD      (HL),A
        LDIR                            ; Efface phrases alli et nous
        CALL    FctEffaceIconesVue64
FctStart2Vue64:
        CALL    AffCoordArche
        LD      IX,PhraseAllie
        LD      DE,#FC14
        CALL    FctAffichePhrase        ; Affiche la phrase de l'alli
        LD      IX,PhraseArche
        LD      DE,#FC3D
        CALL    FctAffichePhrase        ; Affiche la phrase du joueur
        LD      A,(AllieTrouve)
        AND     A                       ; Alli trouv ?
        CALL    NZ,FctAfficheSpriteAllie
        LD      A,(NouvelleVue)
        AND     A
        RET     Z
        XOR     A
        LD      (NouvelleVue),A
        LD      (EtatDialAllie),A
        LD      HL,DialStartVue64
        CALL    AfficheWinInit
        CALL    FctAfficheSpriteAllie
        JP      FctMess1Allie

;
; Premire question de l'alli - "Toi vouloir moi aider ?"
;
FctMess1Allie:
        LD      HL,Mess1Allie
        LD      A,(AllieTrouve)
        AND     A
        RET     Z
        DEC     A
        ADD     A,A
        ADD     A,A
        ADD     A,A
        LD      C,A
        LD      B,0
        ADD     HL,BC
        CALL    FctSetPhraseAllie
        LD      HL,DialAllieSuiteVue64
        CALL    AfficheTexteInit
        CALL    FctAfficheSpriteAllie
        LD      HL,Mess2Allie
        CALL    FctSetPhraseAllie
        LD      HL,DialAllieQuestionVue64
        CALL    AfficheTexteInit
        JP      FctStartVue64
;
; Deuxime question de l'alli - "Moi dtruire ennemi toi ?"
;
FctMess2Allie:
        LD      HL,Mess3Allie
        CALL    FctSetPhraseAllie
        LD      HL,DialAllieSuiteVue64
        CALL    AfficheWinWait
        CALL    FctAfficheSpriteAllie
        LD      HL,Mess4Allie
        CALL    FctSetPhraseAllie
        LD      HL,DialAllieQuestionVue64
        CALL    AfficheWinWait
        JP      FctAfficheSpriteAllie


FctClearPhraseAllie:
        LD      HL,MessAllieVide
FctSetPhraseAllie:
        LD      DE,PhraseAllie
        LD      BC,8
        LDIR
        LD      IX,PhraseAllie
        LD      DE,#FC14
        JP      FctAffichePhrase

FctEffaceIconesVue64:
        XOR     A
        LD      (TaillePhraseArche),A
        LD      (FctOldIcone+1),A
        LD      HL,PhraseArche
        LD      DE,PhraseArche+1
        LD      (HL),A
        LD      BC,7
        LDIR
        LD      IX,PhraseArche
        LD      DE,#FC3D
        JP      FctAffichePhrase

FctBoucheVue64:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,(AllieTrouve)
        AND     A                       ; Un alli sur la plante ?
        RET     Z
        LD      A,(PhraseArche)
        CP      3                       ; "Oui" ?
        JR      Z,FctBoucheOuiVue64
        CP      4                       ; "Non" ?
        JR      Z,FctBoucheNonVue64
        CALL    FctEffaceIconesVue64
        LD      HL,MessQuestionAllie    ; Alli comprends pas
        CALL    FctSetPhraseAllie
        LD      B,100
        CALL    WaitFrames
        LD      A,(EtatDialAllie)
        AND     A
        JP      Z,FctMess1Allie         ; Reposer question 1
        JP      FctMess2Allie           ; Reposer question 2

FctBoucheOuiVue64:
        CALL    FctEffaceIconesVue64
        LD      HL,EtatDialAllie
        INC     (HL)
        LD      A,(HL)
        DEC     A
        JP      Z,FctMess2Allie
;
; Dernier message de l'alli - "Moi fort, moi aller dtruire ennemi"
;
        LD      HL,Mess5Allie
        CALL    FctSetPhraseAllie
        LD      B,100
        CALL    WaitFrames
        LD      B,0                     ; Normalement inutile ???
        LD      HL,Allie1Rallie
        LD      A,(AllieTrouve)
        PUSH    AF
        DEC     A
        LD      C,A
        ADD     HL,BC
        LD      (HL),1                  ; Alli ralli  notre cause !
        XOR     A
        LD      (AllieTrouve),A         ; Alli parti
        CALL    AffImgVue               ; Pour effacer l'alli
        LD      HL,DialAllieRallieVue64
        POP     AF
        DEC     A
        JR      NZ,FctAllieRallie
        LD      HL,DialAllieGRallieVue64
FctAllieRallie
        CALL    AfficheWinWait
        CALL    FctClearPhraseAllie
        LD      HL,Allie1Rallie
        XOR     A
        ADD     A,(HL)                  ; Ajoute tat alli 1 ralli
        INC     HL
        ADD     A,(HL)                  ; Ajoute tat alli 2 ralli
        INC     HL
        ADD     A,(HL)                  ; Ajoute tat alli 3 ralli
        LD      (NbreAllies),A
        DEC     A
        ADD     A,A
        LD      C,A
        LD      B,0
        LD      HL,PtrDialAllieTrouve   ; Pointeur vers message  afficher
        ADD     HL,BC
        LD      A,(HL)
        INC     HL
        LD      H,(HL)
        LD      L,A
        JP      AfficheWinWait

FctBoucheNonVue64:
        CALL    FctEffaceIconesVue64
        LD      HL,MessByeAllie
        CALL    FctSetPhraseAllie
        LD      B,50
        CALL    WaitFrames
        LD      HL,DialPlusCommVue64
        CALL    AfficheWinWait
        LD      B,63
        JP      GoVue

FctAfficheSpriteAllie:
        CALL    AffCoordArche
        LD      A,(AllieTrouve)
        AND     A
        RET     Z
        DEC     A
        ADD     A,A
        LD      C,A
        LD      B,0
        LD      HL,PtrSptAllie
        ADD     HL,BC
        LD      A,(HL)
        INC     HL
        LD      H,(HL)
        LD      L,A
        JP      DepkWin                 ; Affiche le sprite de l'alli

FctQuestionVue64:
        LD      E,1
        JR      FctAjouteIconeVue64

FctPasVue64:
        LD      E,2
        JR      FctAjouteIconeVue64

FctOuiVue64:
        LD      E,3
        JR      FctAjouteIconeVue64

FctNonVue64:
        LD      E,4
        JR      FctAjouteIconeVue64

FctMoiVue64:
        LD      E,5
        JR      FctAjouteIconeVue64

FctToiVue64:
        LD      E,6
        JR      FctAjouteIconeVue64

FctBonjourVue64:
        LD      E,7
        JR      FctAjouteIconeVue64

FctAuRevoirVue64:
        LD      E,8
        JR      FctAjouteIconeVue64

FctAllerVue64:
        LD      E,9
        JR      FctAjouteIconeVue64

FctVouloirVue64:
        LD      E,10
        JR      FctAjouteIconeVue64

FctAimerVue64:
        LD      E,11
        JR      FctAjouteIconeVue64

FctDonnerVue64:
        LD      E,12
        JR      FctAjouteIconeVue64

FctConnuVue64:
        LD      E,13
        JR      FctAjouteIconeVue64

FctInconnuVue64:
        LD      E,14
        JR      FctAjouteIconeVue64

FctVoyagerViteVue64:
        LD      E,15
        JR      FctAjouteIconeVue64

FctAideVue64:
        LD      E,16
        JR      FctAjouteIconeVue64

FctPeurVue64:
        LD      E,17
        JR      FctAjouteIconeVue64

FctDetruireVue64:
        LD      E,18
        JR      FctAjouteIconeVue64

FctDangerVue64:
        LD      E,19
        JR      FctAjouteIconeVue64

FctUrgentVue64:
        LD      E,20
        JR      FctAjouteIconeVue64

FctAmiVue64:
        LD      E,21
        JR      FctAjouteIconeVue64

FctEnnemiVue64:
        LD      E,22
        JR      FctAjouteIconeVue64

FctIdentiteVue64:
        LD      E,23
        JR      FctAjouteIconeVue64

FctFortVue64:
        LD      E,24
        JR      FctAjouteIconeVue64

FctFouVue64:
        LD      E,25
        JR      FctAjouteIconeVue64

FctInsulteVue64:
        LD      E,26
        JR      FctAjouteIconeVue64

FctPaixVue64:
        LD      E,27
        JR      FctAjouteIconeVue64

FctMortVue64:
        LD      E,28

;
; Ajoute une icone dans la phrase
; Entre - E = code icone (1  28)
;
FctAjouteIconeVue64:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,E
FctOldIcone:
        CP      0
        RET     Z
        LD      (FctOldIcone+1),A
        LD      A,(TaillePhraseArche)
        CP      8                       ; Phrase = 8 icones ?
        RET     NC                      ; Si oui, plus rien  ajouter
        LD      C,A                     ; C = taille phrase
        LD      B,0
        LD      HL,PhraseArche
        ADD     HL,BC                   ; Positionne  l'endroit de la phrase
        LD      (HL),E                  ; Mettre icone dans phrase
        LD      A,C
        INC     A
        LD      (TaillePhraseArche),A
        LD      IX,PhraseArche
        LD      DE,#FC3D
;
; IX = Adresse phrase  afficher
; DE = Adresse cran dbut affichage phrase
;
FctAffichePhrase:
        LD      B,8
BclAffichePhrase:
        PUSH    BC
        PUSH    DE
        LD      HL,#C000
        LD      A,(IX+0)
        AND     A
        JR      Z,BclAffichePhrase2
        LD      HL,#CD5C
        AND     #1E                     ; Bit 0 = 0
        ADD     A,A
        ADD     A,L
        LD      L,A
        BIT     0,(IX+0)
        JR      NZ,BclAffichePhrase2
        LD      BC,#189C                ; + 19 Lignes ( 80 * 2 + 0x800 * 3 )
        ADD     HL,BC
BclAffichePhrase2:
        LD      A,18                    ; 18 Lignes  copier
BclAffichePhrase3:
        LDI
        LDI
        LDI
        LDI
        LD      BC,#7FC
        ADD     HL,BC
        JR      NC,BclAffichePhrase4
        LD      BC,#C050
        ADD     HL,BC
BclAffichePhrase4:
        EX      DE,HL
        LD      BC,#7FC
        ADD     HL,BC
        JR      NC,BclAffichePhrase5
        LD      BC,#C050
        ADD     HL,BC
BclAffichePhrase5:
        EX      DE,HL
        DEC     A
        JR      NZ,BclAffichePhrase3
        POP     DE
        POP     BC
        INC     IX
        INC     DE
        INC     DE
        INC     DE
        INC     DE
        DJNZ        BclAffichePhrase
        RET

PtrSptAllie:
        DW      SptHeroEspace1
        DW      SptHeroEspace2
        DW      SptHeroEspace3

PtrDialAllieTrouve:
        DW      DialAllieReste2Vue64
        DW      DialAllieReste1Vue64
        DW      DialAllieReste0Vue64

;
; Messages des allis
;
Mess1Allie:
        DB      5,24,0,0,0,0,0,0        ; Message de bienvenue alli 1
        DB      7,6,0,0,0,0,0,0         ; Message de bienvenue alli 2
        DB      5,21,6,0,0,0,0,0        ; Message de bienvenue alli 3

Mess2Allie:
        DB      6,10,5,16,1,0,0,0       ; "Toi vouloir moi aider ?"

Mess3Allie:
        DB      3,5,16,6,0,0,0,0        ; "Moi aider toi"

Mess4Allie:
        DB      5,18,22,6,1,0,0,0       ; "Moi dtruire ennemi toi ?"

Mess5Allie:
        DB      5,24,5,9,18,22,0,0      ; "Moi fort, moi aller dtruire ennemi"

MessByeAllie:
        DB      8,0,0,0,0,0,0,0         ; "Au revoir"

MessQuestionAllie:
        DB      1,0,0,0,0,0,0,0         ; "?"

MessAllieVide:
        DB      0,0,0,0,0,0,0,0         ; Message Vide

;
; ########################################
; ##                                    ##
; ## Vue 65 - Le garage spatial         ##
; ##                                    ##
; ########################################
;
FctEtagereVue65:
        LD      A,(NavigateurRepare)
        AND     A                       ; Navigateur dj rpar ?
        JR      Z,FctNavigateurVue65
        LD      A,OBJ_Navigateur
        CALL    RechObjInv              ; Possde-t-on le navigateur ?
        JP      Z,FctAffRienSpecial
FctNavigateurVue65:
        LD      A,OBJ_Navigateur
        CALL    AjouteObjInv            ; On prends le navigateur
        LD      HL,DialEtagereVue65
        JR      FctAfficheVue65

FctTableVue65:
        LD      A,OBJ_Courroie
        CALL    RechObjInv              ; Possde-t-on la courroie ?
        JP      Z,FctAffRienSpecial
        LD      A,OBJ_Courroie
        CALL    AjouteObjInv            ; On prends la courroie
        LD      HL,DialTableVue65
FctAfficheVue65:
        JP      AfficheWinWaitC7

;
; ########################################
; ##                                    ##
; ## Vue 67 - Le bar                    ##
; ##                                    ##
; ########################################
;
FctJhonny5Vue67:
        LD      HL,DialJhonny1Vue77
        LD      A,(MissionAlienOk)
        AND     A                       ; Mission dj accomplie ?
        JR      Z,FctAfficheVue67
        LD      HL,DialJhonny3Vue77
        LD      A,(BoissonGratuite)
        AND     A                       ; Dj donn boisson ?
        JR      NZ,FctAfficheVue67
        INC     A
        LD      (BoissonGratuite),A     ; Donne boisson gratuite
        LD      HL,DialJhonny2Vue77
FctAfficheVue67:
        JP      AfficheWinWaitC7

FctBarmanVue67:
        LD      HL,DialBarman1Vue77
        LD      A,(BoissonGratuite)
        CP      1
        JR      NZ,FctAfficheVue67
        INC     A
        LD      (BoissonGratuite),A
        LD      HL,DialBarman2Vue77
        JR      FctAfficheVue67

;
; ########################################
; ##                                    ##
; ## Vue 68 - La police de l'espace     ##
; ##                                    ##
; ########################################
;
FctChefPoliceVue68:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,OBJ_PasseMagnetique
        CALL    RechObjInv              ; Possde-t-on dj le passe ?
        JR      Z,FctChefMissionVue68
        LD      HL,DialPolice1Vue68
        CALL    AfficheWinWaitC7
        LD      HL,DialQCMPoliceVue68
        LD      A,2
        CALL    WaitQCM
        CP      2
        RET     Z
        LD      A,OBJ_PasseMagnetique
        CALL    AjouteObjInv
        LD      HL,DialPolicePassVue68
        JR      FctAfficheVue68
FctChefMissionVue68:
        LD      A,(CorpsDecouvert)
        CP      1
        JR      NZ,FctTestAllieVue68
        INC     A
        LD      (CorpsDecouvert),A
        LD      HL,DialCorpsVue68
        JR      FctAfficheVue68
FctTestAllieVue68:
        LD      A,(NbreAllies)
        CP      3                       ; 3 allis rallis ?
        JR      Z,FctChefMissionOkVue68
        LD      HL,DialPolice2Vue68
        JR      FctAfficheVue68
FctChefMissionOkVue68:
        LD      A,(MissionAlienOk)
        AND     A                       ; Mission dj accomplie ?
        JR      NZ,FctDejaEnergiumVue68
        LD      A,OBJ_PasseMagnetique
        CALL    SupObjInv               ; Le chef reprends le passe
        LD      A,OBJ_Energium
        CALL    AjouteObjInv            ; On gagne l'energium
        INC     A
        LD      (MissionAlienOk),A
        LD      HL,DialPolice3Vue68
        CALL    FctAfficheVue68
FctDejaEnergiumVue68:
        LD      HL,DialPolice4Vue68
FctAfficheVue68:
        JP      AfficheWinWaitC7

;
; ########################################
; ##                                    ##
; ## Vue 69 - Le couloir                ##
; ##                                    ##
; ########################################
;
FctSalleVue69:
        LD      A,(ModeUtil)
        AND     A
        JR      Z,FctSalleTestPassVue69
        LD      A,(ObjUtil)
        CP      OBJ_PasseMagnetique
        JP      NZ,FctAffMarchePas
FctSalleTestPassVue69:
        LD      A,OBJ_PasseMagnetique
        CALL    RechObjInv
        LD      HL,DialPortePasPasseVue69
        JP      NZ,AfficheWinWaitC7
        LD      HL,DialPortePasseVue69
        CALL    AfficheWinWaitC7
        LD      B,70
        JP      GoVue

;
; ########################################
; ##                                    ##
; ## Vue 70 - La salle des ordinateurs  ##
; ##                                    ##
; ########################################
;
FctStartVue70:
        LD      A,(CorpsDecouvert)
        AND     A
        RET     NZ
        INC     A
        LD      (CorpsDecouvert),A
        LD      HL,DialStartVue70
        JP      AfficheTexteInit

FctOrdinateurVue70:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialOrdinateurVue70
        CALL    AfficheWinMsg
        LD      A,7
        CALL    SetBank
        LD      HL,DialOrdinateur2Vue70 ; Listing sur l'cran
        CALL    PrintMessCPC
        CALL    #BB18
        JP      AffImgVue

FctListingVue70:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      HL,DialListingVue70
        CALL    AfficheWinMsg
        LD      HL,DialListingAllie1Vue70
        LD      IX,CoordAllie1
        CALL    FctPrintCoordAllie
        LD      HL,DialListingAllie2Vue70
        LD      IX,CoordAllie2
        CALL    FctPrintCoordAllie
        LD      HL,DialListingAllie3Vue70
        LD      IX,CoordAllie3
        CALL    FctPrintCoordAllie
        CALL    #BB18
        JP      AffImgVue

FctPrintCoordAllie:
        CALL    PrintMessCPC
        LD      L,(IX+0)
        LD      H,(IX+1)
        LD      D,'0'
        CALL    PrintNum
        LD      A,','
        CALL    #BB5A
        LD      L,(IX+2)
        LD      H,(IX+3)
        LD      D,'0'
        JP      PrintNum

;
; ########################################
; ##                                    ##
; ## Vue 72 - La mafia                  ##
; ##                                    ##
; ########################################
;
FctStartVue72:
        LD      A,(NbPiecesOr)
        CP      10                      ; Au moins 10 pices d'or ?
        JR      NC,FctPlusCaisseVue72
        LD      A,OBJ_CaisseWhisky
        CALL    RechObjInv              ; A-t-on dj la caisse de whisky ?
        JR      Z,FctPlusCaisseVue72
        LD      A,(ProtectionMagie)
        AND     A                       ; A-t-on dj la protection contre la magie ?
        JR      NZ,FctPlusCaisseVue72
        LD      HL,DialMafia1Vue72
        CALL    AfficheTexteInit
FctQCMVue72:
        LD      A,1
        LD      (InhibeInit+1),A        ; Inhibition fonction init. (viter auto-rappel)
        LD      HL,DialQCMMafiaVue72
        LD      A,3
        CALL    WaitQCM                 ; Attente rponse du joueur
        DEC     A
        JR      Z,FctStoppeMafiaVue72
        DEC     A
        JR      Z,FctTueZakarVue72
        LD      B,71
        CALL    GoVue                   ; Retourner  l'entre de la ville
        LD      A,OBJ_CaisseWhisky
        CALL    AjouteObjInv            ; Obtenir caisse de whisky
        LD      HL,DialRepMafia3Vue72
        JR      FctAfficheVue72
FctPlusCaisseVue72:
        LD      HL,DialDejaVue72
        CALL    AfficheTexteInit
        LD      B,71
        JP      GoVue
FctStoppeMafiaVue72:
        LD      A,(ProtectionArmure)
        AND     A                       ; Avons-nous l'armure d'Antiriad ?
        JR      NZ,FctStoppeMafia2Vue72
        LD      A,1
        LD      (PerdVie),A             ; On pert une vie...
        LD      HL,DialRepMafia1PasArmureVue72
        JR      FctAfficheVue72
FctStoppeMafia2Vue72:
        LD      HL,DialRepMafia1ArmureVue72
        CALL    FctAfficheVue72
        JR      FctQCMVue72
FctTueZakarVue72:
        LD      HL,DialRepMafia21Vue72
        CALL    AfficheTexteInit
        LD      HL,DialRepMafia22Vue72
        CALL    AfficheTexteInit
        JR      FctQCMVue72
FctAfficheVue72:
        JP      AfficheTexteInit

;
; ########################################
; ##                                    ##
; ## Vue 73 - Robocop                   ##
; ##                                    ##
; ########################################
;
FctStartVue73:
        LD      A,(NouvelleVue)
        AND     A
        RET     Z
        XOR     A
        LD      (NouvelleVue),A
        LD      HL,DialRobocop1Vue73
        CALL    AfficheTexteInit
        LD      A,1
        LD      (InhibeInit+1),A        ; Inhibition fonction init. (viter auto-rappel)
        LD      HL,DialQCMRobocopVue73
        LD      A,2                     ; 2 choix possibles
        CALL    WaitQCM                 ; Attente rponse du joueur
        CP      2
        JR      Z,FctRefuseVue73        ; On refuse d'ouvir son sac...
        LD      A,OBJ_CaisseWhisky
        CALL    RechObjInv              ; Avons-nous la caisse de whisky ?
        LD      HL,DiaRobocop4Vue73
        JR      NZ,FctAfficheVue73      ; si non, juste un avertissement
        LD      A,OBJ_CaisseWhisky
        CALL    SupObjInv               ; Supprime la caisse de whiksy
        LD      HL,DialRobocop3Vue73
        JR      FctAfficheVue73
FctRefuseVue73:
        LD      HL,DialRobocop2Vue73
        LD      A,(ProtectionArmure)
        AND     A                       ; Avons-nous l'armure d'Antiriad ?
        JR      Z,FctPerdVieVue73
        CALL    AfficheTexteInit
        LD      HL,DialArmureSauve      ; L'armure nous sauve...
        JR      FctAfficheVue73
FctPerdVieVue73:
        LD      A,1
        LD      (PerdVie),A             ; On pert une vie...
FctAfficheVue73:
        JP      AfficheTexteInit

;
; ########################################
; ##                                    ##
; ## Vue 75 - Jour de foot              ##
; ##                                    ##
; ########################################
;
FctStartVue75:
        LD      HL,DialFootVue75
        JP      AfficheTexteInit

;
; ########################################
; ##                                    ##
; ## Vue 76 - La chambre d'hotel        ##
; ##                                    ##
; ########################################
;
FctStartVue76:
        LD      A,(NouvelleVue)
        AND     A
        RET     Z
        XOR     A
        LD      (NouvelleVue),A
        LD      HL,DialEntreeHotelVue76
        JP      AfficheTexteInit

FctTableauVue76:
        LD      A,(ModeUtil)
        AND     A
        JP      NZ,FctAffMarchePas
        LD      A,OBJ_PetiteCle
        CALL    RechObjInv
        JP      Z,FctAffRienSpecial
        LD      A,OBJ_PetiteCle
        CALL    AjouteObjInv
        LD      HL,DialTableauVue76
FctAfficheVue76:
        JP      AfficheWinWaitC7

FctArmoireVue76:
        LD      A,(ModeUtil)
        AND     A                       ; Mode utilisation ?
        JR      NZ,FctUtilArmoireVue76
        LD      HL,DialArmoire1Vue76
        LD      A,(ArmoireOuverte)
        AND     A                       ; Armoire dj ouverte ?
        JR      Z,FctAfficheVue76
        LD      A,OBJ_Traducteur
        CALL    RechObjInv              ; Traducteur dj rcupr
        JP      Z,FctAffRienSpecial
        LD      HL,DialArmoire2Vue76
        CALL    AfficheWinWaitC7
        LD      A,OBJ_Traducteur
        CALL    AjouteObjInv            ; Ajoute le traducteur dans l'inventaire
        LD      HL,DialArmoire3Vue76
        JR      FctAfficheVue76
FctUtilArmoireVue76:
        LD      A,(ObjUtil)
        CP      OBJ_PetiteCle
        JP      NZ,FctAffMarchePas
        LD      A,1
        LD      (ArmoireOuverte),A
        LD      HL,DialArmoireOuvre
        JR      FctAfficheVue76

;
; ########################################
; ##                                    ##
; ## Vue 77 - Les rengats              ##
; ##                                    ##
; ########################################
;
FctRenegatsVue77:
        LD      A,(ModeUtil)
        AND     A                       ; Mode utilisation ?
        JR      Z,FctCombatVue77
        LD      A,(ObjUtil)
        CP      OBJ_Epee                ; Objet = pe ?
        JP      NZ,FctAffMarchePas
        LD      HL,DialEpeeVue77
        JR      FctAfficheVue77
FctCombatVue77
        LD      HL,DialQCMRenegatsVue77
        LD      A,2
        CALL    WaitQCM                 ; Attente rponse du joueur
        CP      2                       ; Pas prt ?
        RET     Z
        LD      HL,DialPasKarateVue77
        LD      A,(LeconKarate)
        AND     A
        JR      Z,FctAfficheVue77
        LD      HL,DialKarateVue77
        CALL    AfficheWinWaitC7
        LD      B,78
        JP      GoVue
FctAfficheVue77:
        JP      AfficheWinWaitC7
        RET

;
; ########################################
; ##                                    ##
; ## Vue 78 - Billy la banlieue         ##
; ##                                    ##
; ########################################
;
FctStartVue78:
        LD      A,(NouvelleVue)
        AND     A
        RET     Z
        XOR     A
        LD      (NouvelleVue),A
        LD      HL,DialStartVue78
        JP      AfficheTexteInit

FctBillyVue78:
        LD      A,(DejaVuBilly)
        AND     A
        JR      NZ,FctDejaBilly
        LD      HL,DialBilly1Vue78
        CALL    AfficheWinWaitC7
        LD      HL,DialBilly2Vue78
        CALL    AfficheWinWaitC7
        LD      HL,DialBilly3Vue78
        CALL    AfficheWinWaitC7
        LD      HL,DialBilly4Vue78
        CALL    AfficheWinWaitC7
        LD      HL,DialBilly5Vue78
        CALL    AfficheWinWaitC7
        LD      A,1
        LD      (DejaVuBilly),A
FctDejaBilly:
        LD      HL,DialDejaGagneVue78
        LD      A,(DisquetteGagne)
        AND     A
        JR      NZ,FctAfficheVue78
        LD      HL,DialBilly6Vue78
FctAfficheVue78:
        JP      AfficheWinWaitC7

FctArcadeVue78:
        LD      HL,DialBillyJoueVue78
        LD      A,(DejaVuBilly)
        AND     A                       ; Dj vu Billy ?
        JR      Z,FctAfficheVue78
        LD      HL,DialJeuArcadeVue78
        CALL    AfficheWinWaitC7
        LD      A,#10
        CALL    SetAdrMemEcr
        CALL    EffaceEcran
        LD      A,1
        LD      BC,#1212
        CALL    #BC32
        LD      A,#30
        CALL    SetAdrMemEcr
        CALL    Pong                    ; Jouer au pong
        CALL    VideBuffClav
        CALL    AffImgVue               ; Raffiche la vue de Billy
        LD      A,(TxtScoreJoueur)
        CP      MAX_SCORE_PONG          ; Joueur a gagn ?
        JR      Z,FctArcadeGagne
        LD      HL,DialJeuPerduVue78
        JR      FctAfficheVue78
FctArcadeGagne:
        LD      HL,DialJeuGagne2Vue78
        LD      A,(DisquetteGagne)
        AND     A                       ; Disquette dj gagne ?
        JR      NZ,FctAfficheVue78
        LD      A,OBJ_Disquette
        CALL    AjouteObjInv            ; On gagne la disquette
        LD      A,1
        LD      (DisquetteGagne),A
        LD      HL,DialJeuGagneVue78
        JR      FctAfficheVue78
