#include  <windows.h>
#include  <stdlib.h>
#include  <stdio.h>

#include  "GestDsk.h"
#include  "Pack.h"


#define     MAX_VUE_FACE    100

#define     ID_DISK         "CPC-AVENTURE"


#define     INT_PISTE       0
#define     INT_SECTEUR     7
#define     INT_MAX_SECT    0x16

#define     SPT_PISTE       2
#define     SPT_SECTEUR     9
#define     SPT_MAX_SECT    0x16

#define     DIA_PISTE       5
#define     DIA_SECTEUR     1
#define     DIA_MAX_SECT    0x1A

#define     JEU_PISTE       7
#define     JEU_SECTEUR     7
#define     JEU_MAX_SECT    0x18

#define     DC7_PISTE       10
#define     DC7_SECTEUR     1
#define     DC7_MAX_SECT    0xB

#define     OCT_REMP        0xE5


typedef struct
    {
    BYTE    NumVue;         // Numro de la vue, >0
    BYTE    NumFace;        // Numro de face
    BYTE    StartTrack;     // Piste de dpart
    BYTE    StartSect;      // Secteur de dpart
    BYTE    NbSects;        // Nombre de secteurs
    } StInfoVue;


typedef struct
    {
    char        Identite[ 15 ];     // Identit Disquette
    BYTE        NumFace;            // Numro de face
    StInfoVue   TabInfoVue[ MAX_VUE_FACE + 1 ];
    } StInfoDisk;


char * TabNomFic[] = 
    {
    "Maison01",     // Vue 1
    "Maison02",     // Vue 2
    "Maison03",     // Vue 3
    "Maison04",     // Vue 4
    "Maison05",     // Vue 5
    "Maison06",     // Vue 6
    "Maison07",     // Vue 7
    "Maison08",     // Vue 8 
    "Maison09",     // Vue 9
    "Plaine01",     // Vue 10
    "Plaine02",     // Vue 11
    "Plaine03",     // Vue 12
    "Plaine04",     // Vue 13
    "Plaine05",     // Vue 14
    "Plaine06",     // Vue 15
    "Plaine07",     // Vue 16
    "Plaine08",     // Vue 17
    "Plaine09",     // Vue 18
    "ForMin01",     // Vue 19
    "ForMin02",     // Vue 20
    "ForMin03",     // Vue 21
    "ForMin04",     // Vue 22
    "ForMin05",     // Vue 23
    "ForMin06",     // Vue 24
    "ForMin07",     // Vue 25
    "ForMin08",     // Vue 26
    "ForMin09",     // Vue 27
    "ForMin10",     // Vue 28
    "ForMin12",     // Vue 29
    "ForMin13",     // Vue 30
    "Desert01",     // Vue 31
    "Desert02",     // Vue 32
    "Desert03",     // Vue 33
    "Desert04",     // Vue 34
    "Desert05",     // Vue 35
    "Desert06",     // Vue 36
    "Desert07",     // Vue 37
/****** FACE 2 ******/
    "Karate01",     // Vue 38
    "Karate02",     // Vue 39
    "Ile01",        // Vue 40
    "Ile02",        // Vue 41
    "Ile03",        // Vue 42
    "Ile04",        // Vue 43
    "Ile05",        // Vue 44
    "Ile06",        // Vue 45
    "Ile07",        // Vue 46
    "Ile08",        // Vue 47
    "Ile09",        // Vue 48
    "Chateau01",    // Vue 49
    "Chateau02",    // Vue 50
    "Chateau03",    // Vue 51
    "Chateau04",    // Vue 52
    "Chateau05",    // Vue 53
    "Chateau06",    // Vue 54
    "Chateau07",    // Vue 55
    "Chateau08",    // Vue 56
    "Base01",       // Vue 57
    "Base02",       // Vue 58
    "Base03",       // Vue 59
    "Base04",       // Vue 60
    "Base05",       // Vue 61
    "Espace01",     // Vue 62
    "Espace02",     // Vue 63
    "Espace03",     // Vue 64
    "Espace04",     // Vue 65
    "Espace05",     // Vue 66
    "Espace06",     // Vue 67
    "Espace07",     // Vue 68
    "Espace08",     // Vue 69
    "Espace09",     // Vue 70
    "Ville01",      // Vue 71
    "Ville02",      // Vue 72
    "Ville03",      // Vue 73
    "Ville04",      // Vue 74
    "Ville05",      // Vue 75
    "Ville06",      // Vue 76
    "Ville07",      // Vue 77
    "Ville08",      // Vue 78
    "Maison01",     // Vue 79
    "Traducteur",   // Vue 80
    };


static BYTE BufLect[ 0x10000 ];
static BYTE BufCmp[ 0x10000 ];


//
// Convertit les codes ASCII des caractres accentus windows
// Vers le jeu ASCII des caractres accentus du CPC
//
static char ConvertAscii( char p )
{
    switch( p )
        {
        case '' :
            return( '@' );
            break;

        case '' :
            return( '\\' );
            break;

        case '' :
            return( '{' );
            break;

        case '' :
            return( '}' );
            break;

        case '' :
            return( '~' );
            break;

        case '' :
            return( 127 );
            break;

        case '' :
            return( '|' );
            break;

//
// Caractres non cods, pour le futur ???
//
        case '' :
        case '' :
            return( 'a' );

        case '' :
            return( 'e' );

        case '' :
        case '' :
            return( 'i' );
            break;

        case '' :
            return( 'o' );

        case '' :
        case '' :
            return( 'u' );
            break;
        }
    return( p );
}


static void ConvAccents( BYTE * Buffer, int l )
{
    // Recherche le dbut des textes ($DIAL$)
    for ( int i = 0; i < l - 6; i++ )
        if ( ! strncmp( ( char * )&Buffer[ i ], "$DIAL$", 6 ) )
            {
            // Convertit les caractres accentus
            for ( int j = i; j < l; j++ )
                {
                Buffer[ j ] = ( BYTE )ConvertAscii( ( char )Buffer[ j ] );
                if ( ! strncmp( ( char * )&Buffer[ j ], "$FIN$", 5 ) )
                    break;
                }
            break;
            }
}


static void FillBuffers( void )
{
    memset( BufCmp, 0, sizeof( BufCmp ) );
    memset( BufLect, 0, sizeof( BufLect ) );
}

//
// Ajoute un fichier  un endroit prcis de la disquette
//
static BOOL AjouteFichier( BYTE * BufLect
                         , int LongReel
                         , StInfoDisk * InfoDisk
                         , int * Piste
                         , int * Sect
                         , int NbSects
                         , int NumFic
                         , int Face
                         )
{
    int PosBuf = 0;
    int NbSect = 0;
    LongReel = TailleSect( LongReel );
    int PosReel = ( ( * Piste * 10 ) + * Sect ) << 9;
    if ( PosReel + LongReel > 0x34800 )
        return( FALSE );

    if ( InfoDisk )
        {
        InfoDisk->TabInfoVue[ NumFic ].StartSect = ( BYTE ) * Sect + 0xC0;
        InfoDisk->TabInfoVue[ NumFic ].StartTrack = ( BYTE ) * Piste;
        InfoDisk->TabInfoVue[ NumFic ].NumFace = Face;
        }
    while( PosBuf < LongReel )
        {
        WriteSect( * Piste, * Sect, NbSects, &BufLect[ PosBuf ] );
        PosBuf += 512;
        NbSect++;
        ( * Sect )++;
        if ( * Sect == NbSects )
            {
            * Sect = 0;
            ( * Piste )++;
            }
        }
    if ( InfoDisk )
        {
        InfoDisk->TabInfoVue[ NumFic ].NumVue = ( BYTE )( NumFic + 1 );
        InfoDisk->TabInfoVue[ NumFic ].NbSects = ( BYTE )NbSect;
        }
    return( TRUE );
}


static int LectFic( char * Nom )
{
    int l;

    FillBuffers();
    FILE * fp = fopen( Nom, "rb" );
    if ( fp )
        {
        l = fread( BufLect, 1, sizeof( BufLect ), fp );
        fclose( fp );
        if ( CheckAmsdos( BufLect ) )
            {
            l -= 0x80;
            memcpy( BufLect, &BufLect[ 0x80 ], l );
            }
        return( l );
        }
    return( 0 );
}


static BOOL AjouteFichiersJeu( void )
{
    int l, lcmp;
    int Piste, Sect;

    // Ajoute introduction (compact)
    l = LectFic( "Fichiers\\CPC-AVT.INT" );
    if ( l )
        {
        ConvAccents( BufLect, l );
        lcmp = PackBuffer( BufLect, l, BufCmp );
        if ( lcmp < 512 * INT_MAX_SECT )
            {
            Sect = INT_SECTEUR;
            Piste = INT_PISTE;
            printf( "\n\n Dbut introduction                           p=%d, s=#%02X"
                  , Piste
                  , Sect + 0xC0
                  );
            AjouteFichier( BufCmp
                         , 512 * INT_MAX_SECT
                         , NULL
                         , &Piste
                         , &Sect
                         , 10
                         , 0
                         , 0
                         );
            printf( "\nIntroduction ajouts sur face 1  Reste=%5d, p=%d, s=#%02X"
                  , ( 512 * INT_MAX_SECT ) - lcmp
                  , Piste
                  , Sect + 0xC0
                  );
            printf( "\nTaille non compacte = %d", l );
            }
        else
            {
            printf( "\n!!! Taille introduction = %d", lcmp );
            return( FALSE );
            }
        }

    // Ajoute sprites
    l = LectFic( "Fichiers\\CPC-AVT.SPT" );
    if ( l && l < 512 * SPT_MAX_SECT )
        {
        Sect = SPT_SECTEUR;
        Piste = SPT_PISTE;
        printf( "\n\n Dbut sprites                                p=%d, s=#%02X"
              , Piste
              , Sect + 0xC0
              );
        AjouteFichier( BufLect
                     , 512 * SPT_MAX_SECT
                     , NULL
                     , &Piste
                     , &Sect
                     , 10
                     , 0
                     , 0
                     );
        printf( "\nSprites ajouts sur face 1       Reste=%5d, p=%d, s=#%02X"
              , ( 512 * SPT_MAX_SECT ) - l
              , Piste
              , Sect + 0xC0
              );
        }
    else
        {
        printf( "\n!!! Taille sprite = %d", l );
        return( FALSE );
        }

    // Ajoute dialogues (compacts)
    l = LectFic( "Fichiers\\CPC-AVT.DIA" );
    if ( l )
        {
        ConvAccents( BufLect, l );
        lcmp = PackBuffer( BufLect, l, BufCmp );
        if ( lcmp < 512 * DIA_MAX_SECT )
            {
            Sect = DIA_SECTEUR;
            Piste = DIA_PISTE;
            printf( "\n\n Dbut dialogues                              p=%d, s=#%02X"
                  , Piste
                  , Sect + 0xC0
                  );
            AjouteFichier( BufCmp
                         , 512 * DIA_MAX_SECT
                         , NULL
                         , &Piste
                         , &Sect
                         , 10
                         , 0
                         , 0
                         );
            printf( "\nDialogues ajouts sur face 1     Reste=%5d, p=%d, s=#%02X"
                  , ( 512 * DIA_MAX_SECT ) - lcmp
                  , Piste
                  , Sect + 0xC0
                  );
            printf( "\nTaille non compacte = %d", l );
            }
        else
            {
            printf( "\n!!! Taille dialogues = %d", lcmp );
            return( FALSE );
            }
        }

    // Ajoute programme principal (compact)
    l = LectFic( "Fichiers\\CPC-AVT.JEU" );
    if ( l )
        {
        lcmp = PackBuffer( BufLect, l, BufCmp );
        if ( lcmp < 512 * JEU_MAX_SECT )
            {
            Sect = JEU_SECTEUR;
            Piste = JEU_PISTE;
            printf( "\n\n Dbut jeu                                    p=%d, s=#%02X"
                  , Piste
                  , Sect + 0xC0
                  );
            AjouteFichier( BufCmp
                         , 512 * JEU_MAX_SECT
                         , NULL
                         , &Piste
                         , &Sect
                         , 10
                         , 0
                         , 0
                         );
            printf( "\nJeu ajouts sur face 1           Reste=%5d, p=%d, s=#%02X"
                  , ( 512 * JEU_MAX_SECT ) - lcmp
                  , Piste
                  , Sect + 0xC0
                  );
            printf( "\nTaille non compacte = %d", l );
            }
        else
            {
            printf( "\n!!! Taille jeu = %d", lcmp );
            return( FALSE );
            }
        }

    // Ajoute dialogues #C7(compacts)
    l = LectFic( "Fichiers\\CPC-AVT.DC7" );
    if ( l )
        {
        for ( int j = 0; j < l; j++ )
            BufLect[ j ] = ( BYTE )ConvertAscii( ( char )BufLect[ j ] );

        lcmp = PackBuffer( BufLect, l, BufCmp );
        if ( lcmp < 512 * DC7_MAX_SECT )
            {
            Sect = DC7_SECTEUR;
            Piste = DC7_PISTE;
            printf( "\n\n Dbut dialogues (#C7)                        p=%d, s=#%02X"
                  , Piste
                  , Sect + 0xC0
                  );
            AjouteFichier( BufCmp
                         , 512 * DC7_MAX_SECT
                         , NULL
                         , &Piste
                         , &Sect
                         , 10
                         , 0
                         , 0
                         );
            printf( "\nDialogues ajouts sur face 1     Reste=%5d, p=%d, s=#%02X"
                  , ( 512 * DC7_MAX_SECT ) - lcmp
                  , Piste
                  , Sect + 0xC0
                  );
            printf( "\nTaille non compacte = %d", l );
            }
        else
            {
            printf( "\n!!! Taille dialogues = %d", lcmp );
            return( FALSE );
            }
        }

    printf( "\n" );
    return( TRUE );
}


static void AjouteSample( void )
{
    int l, lcmp;
    int Piste, Sect;

    // Ajoute introduction (compact)
    l = LectFic( "Fichiers\\RIRE6.SPL" );
    if ( l )
        {
        ConvAccents( BufLect, l );
        lcmp = PackBuffer( BufLect, l, BufCmp );
        if ( lcmp < 512 * 10 )
            {
            Sect = 0;
            Piste = 41;
            printf( "\n\n Dbut sample                           p=%d, s=#%02X"
                  , Piste
                  , Sect + 0xC0
                  );
            AjouteFichier( BufCmp
                         , 512 * 10
                         , NULL
                         , &Piste
                         , &Sect
                         , 10
                         , 0
                         , 0
                         );
            printf( "\nsample ajouts sur face 2  Reste=%5d, p=%d, s=#%02X"
                  , ( 512 * 10 ) - lcmp
                  , Piste
                  , Sect + 0xC0
                  );
            printf( "\nTaille non compacte = %d", l );
            }
        else
            printf( "\n!!! Taille sample = %d", lcmp );
        }

}


//
// Gestion des faces des disquettes (pour les images)
//
int Genere( char * NomDsk, int Piste, BOOL WriteImages )
{
    char Tmp[ 128 ], NomComplet[ 256 ];
    StInfoDisk InfoDisk;
    int NumFic = 0;
    int Sect = 0, NbSects = 10;
    int TailleMax = 0;
    int StartImg = 1, Face = 1;
    int lCmp = 0, TailleTotale = 0;

    memset( &InfoDisk, 0, sizeof( InfoDisk ) );
    while( TabNomFic[ NumFic ] )
        {
        if ( ! Piste )
            Sect = 5;       // Dmarre au secteur #C5 piste 0 si face 2
        else
            Sect = 2;       // Dmarre au secreur #C2 si face 1

        BOOL Erase = FALSE;
        sprintf( NomComplet, "%s_Face%d.DSK", NomDsk, Face );
        strcpy( InfoDisk.Identite, ID_DISK );
        if ( ! ReadDsk( NomComplet ) )
            {
            printf( "\nCreation disquette %s", NomComplet );
            Erase = TRUE;
            }
        else
            printf( "\nLecture disquette %s ok", NomComplet );

        FormatDsk( NbSects, 42, OCT_REMP, Erase );

        if ( Face == 1 )
            if ( ! AjouteFichiersJeu() )    // Ajoute les fichiers du jeu
                break;

        printf( "\nDbut Piste %2d Secteur #%02X", Piste, 0xC0 + Sect );
        while( TabNomFic[ NumFic ] )
            {
            if ( WriteImages )
                {
                sprintf( Tmp, "ImagesOK\\%s.BIN", TabNomFic[ NumFic ] );
                FILE * fp = fopen( Tmp, "rb" );
                if ( fp )
                    {
                    printf( "\nLecture (%2d) %-30s", NumFic + 1, Tmp );
                    FillBuffers();
                    int TailleLect = fread( BufLect, 1, sizeof( BufLect ), fp );
                    fclose( fp );
                    if ( CheckAmsdos( BufLect ) )
                        {
                        TailleLect -= 0x80;
                        memcpy( &BufLect[ 0 ], &BufLect[ 0x80 ], TailleLect );
                        }
                    lCmp = PackScreen( BufLect, &BufCmp[ 4 ] ) + 4;
                    int Taille = TailleSect( lCmp );
                    if ( TailleMax < Taille )
                        TailleMax = Taille;

                    printf( ": %5d Octets -> %5d", lCmp, Taille );
                    if ( Taille - lCmp > 500 )
                        printf( "(*)" );

                    BufCmp[ 0 ] = Face;
                    memcpy( &BufCmp[ 1 ], &BufLect[ 0x17D2 ], 3 );
                    if ( ! AjouteFichier( BufCmp
                                        , lCmp
                                        , &InfoDisk
                                        , &Piste
                                        , &Sect
                                        , NbSects
                                        , NumFic
                                        , Face
                                        )
                       )
                        {
                        printf( " <!!!>" );
                        break;
                        }
                    else
                        printf( " <Ok>" );
                    }
                }
            NumFic++;
            TailleTotale += TailleSect( lCmp );
            }
        if ( WriteImages )
            {
            printf( "\nFin   Piste %2d Secteur #%02X", Piste, 0xC0 + Sect );
            printf( "\nNombre de fichiers ecrits : %d", NumFic - StartImg + 1 );

            FillBuffers();
            int Reste = 1 + ( 41 - Piste ) * 10 + ( 9 - Sect );
            AjouteFichier( BufLect
                         , 512 * Reste
                         , NULL
                         , &Piste
                         , &Sect
                         , 10
                         , 0
                         , 0
                         );
            }
        if ( Face == 2 )
            AjouteSample();

        printf( "\nEcriture fichier %s", NomComplet );
        WriteDsk( NomComplet );
        Face++;
        Piste = 0;
        }
    if ( WriteImages )
        {
        printf( "\nEcriture bitmaps." );
        for ( int i = 1; i < Face; i++ )
            {
            sprintf( NomComplet, "%s_Face%d.DSK", NomDsk, i );
            ReadDsk( NomComplet );
            InfoDisk.NumFace = i;
            WriteSect( 0, 0, NbSects, ( BYTE * )&InfoDisk );
            WriteDsk( NomComplet );
            }
        printf( "\n\nTaille Maxi image : %d (#%04X)\n", TailleMax, TailleMax );
        printf( "\nTaille totale images : %d\n", TailleTotale );
        }
    printf( "\nTermine.\n" );
    return( NumFic );
}
