#include  <windows.h>
#include  <stdio.h>

#include  "GestDsk.h"


static CPCEMUEnt Infos;

static BYTE ImgDsk[ 1024 * 256 ];

static BYTE Bitmap[ 256 ];


static int GetMinSect( void )
{
    int s, Sect = 0x100;
    CPCEMUTrack * tr = ( CPCEMUTrack * )ImgDsk;
    for ( s = 0; s < tr->NbSect; s++ )
        if ( Sect > tr->Sect[ s ].R )
            Sect = tr->Sect[ s ].R;

    return( Sect );
}


static int GetPosData( int track, int sect, int NbSects )
{
    int s, Pos = 0;
    // Recherche position secteur
    CPCEMUTrack * tr = ( CPCEMUTrack * )&ImgDsk[ Pos ];
    Pos = ( sizeof( * tr ) + NbSects * SECTSIZE ) * track + sizeof( * tr );
    
    for ( s = 0; s < tr->NbSect; s++ )
        {
        if ( tr->Sect[ s ].R == sect )
            break;

        if ( tr->Sect[ s ].Un2 )
            Pos += tr->Sect[ s ].Un2;
        else
            Pos += ( 128 << tr->Sect[ s ].N );
        }
    return( Pos );
}


BYTE * ReadBloc( int bloc )
{
    static BYTE BufBloc[ SECTSIZE * 2 ];
    int Pos, track = ( bloc << 1 ) / 9;
    int sect = ( bloc << 1 ) % 9;
    int MinSect = GetMinSect();
    if ( MinSect == 0x41 )
        track += 2;

    Pos = GetPosData( track, sect + MinSect, 9 );
    memcpy( BufBloc, &ImgDsk[ Pos ], SECTSIZE );
    if ( ++sect > 8 )
        {
        track++;
        sect = 0;
        }

    Pos = GetPosData( track, sect + MinSect, 9 );
    memcpy( &BufBloc[ SECTSIZE ], &ImgDsk[ Pos ], SECTSIZE );
    return( BufBloc );
}


static void WriteBloc( int bloc, BYTE BufBloc[ SECTSIZE * 2 ] )
{
    int Pos, track = ( bloc << 1 ) / 9;
    int sect = ( bloc << 1 ) % 9;
    int MinSect = GetMinSect();
    if ( MinSect == 0x41 )
        track += 2;

    Pos = GetPosData( track, sect + MinSect, 9 );
    memcpy( &ImgDsk[ Pos ], BufBloc, SECTSIZE );
    if ( ++sect > 8 )
        {
        track++;
        sect = 0;
        }
    Pos = GetPosData( track, sect + MinSect, 9 );
    memcpy( &ImgDsk[ Pos ], &BufBloc[ SECTSIZE ], SECTSIZE );
}


void GetPosBloc( int Bloc, int * Track, int * Sect )
{
    * Track = ( Bloc << 1 ) / 9;
    * Sect = ( Bloc << 1 ) % 9;
    if ( GetMinSect() == 0x41 )
        * Track += 2;
}


int RechercheBloc( void )
{
    int i;

    for ( i = 0; i < 256; i++ )
        if ( ! Bitmap[ i ] )
            {
            Bitmap[ i ] = 1;
            return( i );
            }
    return( 0 );
}


static int RechercheDir( void )
{
    int i;

    for ( i = 0; i < 64; i++ )
        {
        StDirEntry * Dir = GetInfoDirEntry( i );
        if ( Dir->User == 0xE5 )
            return( i );
        }
    return( -1 );
}


int TailleSect( int t )
{
    return( ( t + 0x1FF ) & 0xFFFFFE00 );
}


void WriteSect( int Track, int Sect, int NbSects, BYTE * Buff )
{
    int MinSect = GetMinSect();
    int Pos = GetPosData( Track, Sect + MinSect, NbSects );
    memcpy( &ImgDsk[ Pos ], Buff, SECTSIZE );
}


BYTE * ReadSect( int Track, int Sect, int NbSects )
{
    static BYTE DataSect[ SECTSIZE ];

    int MinSect = GetMinSect();
    int Pos = GetPosData( Track, Sect + MinSect, NbSects );
    memcpy( DataSect, &ImgDsk[ Pos ], SECTSIZE );
    return( DataSect );
}


int FillBitmap( void )
{
    int i, j, b, NbKo = 0;

    memset( Bitmap, 0, sizeof( Bitmap ) );
    Bitmap[ 0 ] = Bitmap[ 1 ] = 1;
    for ( i = 0; i < 64; i++ )
        {
        StDirEntry * Dir = GetInfoDirEntry( i );
        if ( Dir->User != 0xE5 )
            {
            for ( j = 0; j < 16; j++ )
                {
                b = Dir->Blocks[ j ];
                if ( b > 1 && ( ! Bitmap[ b ] ) )
                    {
                    Bitmap[ b ] = 1;
                    NbKo++;
                    }
                }
            }
        }
    return( NbKo );
}


void SetInfoDirEntry( int NumDir, StDirEntry * Dir )
{
    int MinSect = GetMinSect();
    int s = ( NumDir >> 4 ) + MinSect;
    int t = ( MinSect == 0x41 ? 2 : 0 );
    int Pos = ( ( NumDir & 15 ) << 5 ) + GetPosData( t, s, 9 );
    memcpy( &ImgDsk[ Pos ], Dir, sizeof( StDirEntry ) );
}


StDirEntry * GetInfoDirEntry( int NumDir )
{
    static StDirEntry Dir;
    int MinSect = GetMinSect();
    int s = ( NumDir >> 4 ) + MinSect;
    int t = ( MinSect == 0x41 ? 2 : 0 );
    int Pos = ( ( NumDir & 15 ) << 5 ) + GetPosData( t, s, 9 );
    memcpy( &Dir, &ImgDsk[ Pos ], sizeof( StDirEntry ) );
    return( &Dir );
}


int CopieFichier( BYTE * BufFile
                , char * NomFic
                , USHORT AdrDeb
                , USHORT TailleFic
                , USHORT PointEntree
                , BOOL ForceReadOnly
                , BOOL ForceHidden
                )
{
    BYTE BlocEntete[ 1024 ];
    StDirEntry DirLoc;
    int i, j, l, Bloc, PosFile, NbPages = 0, PosDir, TaillePage;
    int TailleBloc = 1024 - sizeof( StAmsdos );

    memcpy( BlocEntete
          , ( BYTE * )CreeEntete( NomFic
                                , AdrDeb
                                , TailleFic
                                , PointEntree
                                )
          , sizeof( StAmsdos )
          );
    memcpy( &BlocEntete[ sizeof( StAmsdos ) ]
          , BufFile
          , TailleBloc
          );
    TailleFic += sizeof( StAmsdos );
    FillBitmap();
    for ( PosFile = 0; PosFile < TailleFic; )
        {
        memset( &DirLoc, 0, sizeof( DirLoc ) );
        memset( DirLoc.Nom, ' ', 8 );
        memset( DirLoc.Ext, ' ', 3 );
        PosDir = RechercheDir();
        if ( PosDir != -1 )
            {
            char * p = strchr( NomFic, '.' );
            if ( p )
                {
                p++;
                memcpy( DirLoc.Nom, NomFic, min( p - NomFic - 1, 8 ) );
                memcpy( DirLoc.Ext, p, min( strlen( p ), 3 ) );
                }
            else
                memcpy( DirLoc.Nom, NomFic, min( strlen( NomFic ), 8 ) );

            for ( i = 0; i < 11; i++ )
                DirLoc.Nom[ i ] = ( char )toupper( DirLoc.Nom[ i ] );

            DirLoc.User = 0;
            DirLoc.NumPage = ( BYTE )( NbPages++ );
            TaillePage = ( ( TailleFic - PosFile ) + 127 ) >> 7;
            if ( TaillePage > 128 )
                TaillePage = 128;

            DirLoc.NbPages = ( BYTE )TaillePage;
            l = ( DirLoc.NbPages + 7 ) >> 3;
            for ( j = 0; j < l; j++ )
                {
                Bloc = RechercheBloc();
                if ( Bloc )
                    {
                    DirLoc.Blocks[ j ] = ( BYTE )Bloc;
                    if ( TailleBloc == 1024 )
                        WriteBloc( Bloc, &BufFile[ PosFile ] );
                    else
                        WriteBloc( Bloc, BlocEntete );

                    PosFile += TailleBloc;
                    TailleBloc = 1024;
                    }
                else
                    return( ERR_NO_BLOCK );
                }
            //
            // Ajoute attributs fichier
            //
            if ( ForceReadOnly )
                DirLoc.Ext[ 0 ] |= 0x80;
            else
                DirLoc.Ext[ 0 ] &= ~0x80;
            if ( ForceHidden )
                DirLoc.Ext[ 1 ] |= 0x80;
            else
                DirLoc.Ext[ 1 ] &= ~0x80;

            SetInfoDirEntry( PosDir, &DirLoc );
            }
        else
            return( ERR_NO_DIRENTRY );
        }
    return( ERR_NO_ERR );
}


static BOOL CheckDsk( void )
{
    if ( Infos.NbHeads == 1 )
        {
        CPCEMUTrack * tr;
        int MinSect, MaxSect, track, Pos, s;
        int MinSectFirst = GetMinSect();
        if ( MinSectFirst != 0x41 && MinSectFirst != 0xC1 )
            return( FALSE );

        for ( track = 0; track < Infos.NbTracks; track++ )
            {
            // Recherche position secteur
            Pos = ( 0x1200+ sizeof( CPCEMUTrack ) ) * track;
            tr = ( CPCEMUTrack * )&ImgDsk[ Pos ];
            MinSect = 0xFF;
            MaxSect = 0;
            if ( tr->NbSect != 9 )
                return( FALSE );

            for ( s = 0; s < tr->NbSect; s++ )
                {
                if ( MinSect > tr->Sect[ s ].R )
                    MinSect = tr->Sect[ s ].R;

                if ( MaxSect < tr->Sect[ s ].R )
                    MaxSect = tr->Sect[ s ].R;
                }
            if ( MaxSect - MinSect != 8 )
                return( FALSE );

            if ( MinSect != MinSectFirst )
                return( FALSE );
            }
        return( TRUE );
        }
    return( FALSE );
}


BOOL ReadDsk( char * NomFic )
{
    BOOL Ret = FALSE;
    FILE * f = fopen( NomFic, "rb" );
    if ( f )
        {
        fread( &Infos, sizeof( Infos ), 1, f );
        if (  ! strncmp( Infos.debut, "MV -", 4 )
           || ! strncmp( Infos.debut, "EXTENDED CPC DSK", 16 )
           )
            {
            memset( ImgDsk, 0xE5, sizeof( ImgDsk ) );
            fread( ImgDsk, sizeof( ImgDsk ), 1, f );
            Ret = TRUE;
            }
        fclose( f );
        }
    return( Ret );
}


void FormatDsk( int NbSect, int NbTrack, int OctRemp, BOOL Erase )
{
    int t, s, ss;

    memset( &Infos, 0, sizeof( Infos ) );
    strcpy( Infos.debut, "MV - CPCEMU Disk-File\r\nDisk-Info\r\n" );
    Infos.DataSize = ( SHORT )( sizeof( CPCEMUTrack ) + 0x200 * NbSect );
    Infos.NbTracks = ( BYTE )NbTrack;
    Infos.NbHeads = 1;
    if ( Erase )
        memset( ImgDsk, OctRemp, sizeof( ImgDsk ) );

    for ( t = 0; t < NbTrack; t++ )
        {
        CPCEMUTrack * tr = ( CPCEMUTrack * )&ImgDsk[ t * Infos.DataSize ];
        memset( tr, 0, sizeof( CPCEMUTrack ) );
        strcpy( tr->ID, "Track-Info\r\n" );
        tr->Track = ( BYTE )t;
        tr->Head = 0;
        tr->SectSize = 2;
        tr->NbSect = ( BYTE )NbSect;
        // Ajuster le GAP#3 en fct du nombre de secteurs/pistes
        tr->Gap3 = ( BYTE )( NbSect <= 9 ? 0x4E : 0x32 );
        tr->OctRemp = OctRemp;
        ss = 0;
        for ( s = 0; s < NbSect; )
            {
            tr->Sect[ s ].C = ( BYTE )t;
            tr->Sect[ s ].H = 0;
            tr->Sect[ s ].R = ( BYTE )( ss + 0xC0 );
            tr->Sect[ s ].N = 2;
            tr->Sect[ s ].Un2 = 0x200;
            ss++;
            if ( ++s < NbSect )
                {
                tr->Sect[ s ].C = ( BYTE )t;
                tr->Sect[ s ].H = 0;
                tr->Sect[ s ].R = ( BYTE )( ss + 0xC4 );
                tr->Sect[ s ].N = 2;
                tr->Sect[ s ].Un2 = 0x200;
                s++;
                }
            }
        }
    FillBitmap();
}


BOOL WriteDsk( char * NomDsk )
{
    FILE * f = fopen( NomDsk, "wb" );
    if ( f )
        {
        fwrite( &Infos, sizeof( Infos ), 1, f );
        fwrite( ImgDsk, Infos.NbTracks * 0x1500/*Infos.DataSize*/, 1, f );
        fclose( f );
        return( TRUE );
        }
    return( FALSE );
}


BOOL CheckAmsdos( BYTE * Buf )
{
    int i, Checksum = 0;
    BOOL ModeAmsdos = FALSE;
    StAmsdos * pEntete = ( StAmsdos * )Buf;

    for ( i = 0; i < 67; i++ )
        Checksum += Buf[ i ];

    if ( pEntete->CheckSum == ( USHORT )Checksum )
        ModeAmsdos = TRUE;

    return( ModeAmsdos );
}


void CalcCheckSum( BYTE * Buf )
{
    int i, Checksum = 0;
    StAmsdos * pEntete = ( StAmsdos * )Buf;

    for ( i = 0; i < 67; i++ )
        Checksum += Buf[ i ];

    pEntete->CheckSum = ( USHORT )Checksum;
}


//
// Cre une en-tte au format AMSDOS
//
StAmsdos * CreeEntete( char * n, USHORT Start, USHORT Length, USHORT Entry )
{
    char NomFic[ 256 ];
    static StAmsdos Entete;
    char Nom[ 12 ];
    int i, l, CheckSum = 0;
    char * p = NULL;
    BYTE * pEntete;

    memset( Nom, ' ', sizeof( Nom ) );
    memset( &Entete, 0, sizeof( Entete ) );
    Entete.UserNumber = 0;
    do
        {
        p = strchr( n, '\\' );
        if ( p )
            n = ++p;
        }
    while( p );
    strcpy( NomFic, n );
    p = strchr( NomFic, '.' );
    if ( p )
        * p++ = 0;

    l = strlen( NomFic );
    if ( l > 8 )
        l = 8;

    for ( i = 0; i < l; i++ )
        Nom[ i ] = ( BYTE )( NomFic[ i ] & 0xDF );

    if ( p )
        for ( i = 0; i < 3; i++ )
            Nom[ i + 8 ] = ( BYTE )( p[ i ] & 0xDF );

    memcpy( Entete.FileName, Nom, 11 );
    pEntete = ( BYTE * )&Entete;
    Entete.Adress = Start;
    Entete.Length = Entete.RealLength = Entete.LogicalLength = Length;
    Entete.FileType = 2;
    Entete.EntryAdress = Entry;

    for ( i = 0; i < 67; i++ )
        CheckSum += * pEntete++;

    Entete.CheckSum = ( USHORT )CheckSum;
    return( &Entete );
}
