#ifndef GESTDSK_H
#define GESTDSK_H


//
// Structure d'une entre AMSDOS
//
typedef struct
    {
    BYTE    UserNumber;             // User
    BYTE    FileName[ 15 ];         // Nom + extension
    BYTE    BlockNum;               // Numro du premier bloc (disquette)
    BYTE    LastBlock;              // Numro du dernier bloc (disquette)
    BYTE    FileType;               // Type de fichier
    USHORT  Length;                 // Longueur
    USHORT  Adress;                 // Adresse
    BYTE    FirstBlock;             // Premier bloc de fichier (disquette)
    USHORT  LogicalLength;          // Longueur logique
    USHORT  EntryAdress;            // Point d'entre
    BYTE    Unused[ 0x24 ];
    USHORT  RealLength;             // Longueur relle
    BYTE    BigLength;              // Longueur relle (3 octets)
    USHORT  CheckSum;               // CheckSum Amsdos
    BYTE    Unused2[ 0x3B ];
    } StAmsdos;


#define SECTSIZE   512
#define NBSECT     9


typedef struct
    {
    char        debut[ 0x30 ];  // "MV - CPCEMU Disk-File\r\nDisk-Info\r\n"
    BYTE        NbTracks;
    BYTE        NbHeads;
    short       DataSize;       // 0x1300 = 256 + ( 512 * nbsecteurs )
    BYTE        Unused[ 0xCC ];
    } CPCEMUEnt;


typedef struct
    {
    BYTE        C;              // track
    BYTE        H;              // head
    BYTE        R;              // sect
    BYTE        N;              // size
    short       Un1;
    short       Un2;
    } CPCEMUSect;


typedef struct
    {
    char        ID[ 0x10 ];     // "Track-Info\r\n"
    BYTE        Track;
    BYTE        Head;
    short       Unused;
    BYTE        SectSize;       // 2
    BYTE        NbSect;         // 9
    BYTE        Gap3;           // 0x4E
    BYTE        OctRemp;        // 0xE5
    CPCEMUSect  Sect[ 29 ];
    } CPCEMUTrack;


typedef struct
    {
    BYTE        User;
    char        Nom[ 8 ];
    char        Ext[ 3 ];
    BYTE        NumPage;
    BYTE        Unused[ 2 ];
    BYTE        NbPages;
    BYTE        Blocks[ 16 ];
    } StDirEntry;


enum { ERR_NO_ERR = 0, ERR_NO_DIRENTRY, ERR_NO_BLOCK };


int TailleSect( int t );

BYTE * ReadBloc( int bloc );

int RechercheBloc( void );

void GetPosBloc( int Bloc, int * Track, int * Sect );

int FillBitmap( void );

void WriteSect( int Track, int Sect, int NbSects, BYTE * Buff );

BOOL ReadDsk( char * NomFic );

void FormatDsk( int NbSect, int NbTrack, int OctRemp, BOOL Erase );

int CopieFichier( BYTE * BufFile
                , char * NomFic
                , USHORT AdrDeb
                , USHORT TailleFic
                , USHORT PointEntree
                , BOOL ForceReadOnly
                , BOOL ForceHidden
                );

BOOL WriteDsk( char * NomDsk );

StDirEntry * GetInfoDirEntry( int NumDir );

void SetInfoDirEntry( int NumDir, StDirEntry * Dir );

BYTE * ReadSect( int Track, int Sect, int NbSects );

BOOL CheckAmsdos( BYTE * Buf );

void CalcCheckSum( BYTE * Buf );

StAmsdos * CreeEntete( char * n, USHORT Start, USHORT Length, USHORT Entry );


#endif
