;
; Gestion affichage et dplacement curseur
;
MovCursor:
        XOR     A
        LD      (FIPR),A
        LD      A,#09                   ; Code touche COPY
        CALL    #BB1E
        JR      NZ,SetCursorFire
        LD      A,#2F                   ; Code touche ESPACE
        CALL    #BB1E
        JR      NZ,SetCursorFire
        LD      A,#4C                   ; Code FIRE Joystick
        CALL    #BB1E
        JR      Z,TestMovCursor
SetCursorFire:
        LD      A,#FF
        LD      (FIPR),A                ; Indique validation active
TestMovCursor:
        LD      HL,Y1
        LD      A,(Y)
        CP      (HL)                    ; Y1 <> Y ?
        JR      NZ,AffCurseur           ; Si oui, affichage
        LD      HL,X1
        LD      A,(X)
        CP      (HL)                    ; X1 <> X ?
        JP      Z,DeplHaut              ; Sinon, test dplacement
        ;
        ; Dplacement -> Affichage nouveau curseur
        ;
AffCurseur:
        LD      HL,(X)                  ; Anciennes coordonnes = nouvelles
        LD      DE,(Y)
        LD      (X1),HL
        LD      (Y1),DE
        EX      DE,HL                   ; DE = x, HL = y, calcule adresse dans HL
        CALL    #BC1D                   ; SCR GET POS
        PUSH    HL
        CALL    #BD19                   ; Attendre VBL
        CALL    CurseurOff              ; Restaurer image ancienne position
        POP     HL
        LD      (DrawFleche1+1),HL
        CALL    SavScrCurseur           ; Sauvegarder image nouvelle position

        ;
        ; Calculer Adresse de zone en fonction du numro de vue
        ;
        LD      A,(NumVue)
        DEC     A                       ; Vue commence  1, pointeurs commence  0
        ADD     A,A                     ; Taille pointeur = 2 octets (1 mot)
        LD      C,A
        LD      B,0
        LD      HL,PtrZone              ; Dbut des zones
        ADD     HL,BC
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        PUSH    DE
        POP     IX                      ; Adresse de zone dans IX

        XOR     A
        LD      (TypeFleche+1),A
        LD      HL,0
        LD      (ExecFct+1),HL
        LD      HL,(X)                  ; Coordonne X du curseur
        SRL     H
        RR      L
        SRL     L                       ; L = X/4
        ;
        ; Parcourir les zones pour aspect curseur
        ;
        LD      BC,7                    ; Taille d'une zone
BclZone:
        LD      A,(IX+0)
        AND     A                       ; Fin de zone ?
        JR      Z,DrawFleche
        LD      DE,0                    ; Servira  stocker pointeur fct
        LD      A,L                     ; A = X/4
        CP      (IX+1)                  ; XD
        JR      C,NextZone
        CP      (IX+2)                  ; XA
        JR      NC,NextZone
        LD      A,(Y)                   ; A = Y
        CP      (IX+3)                  ; YD
        JR      C,NextZone
        CP      (IX+4)                  ; YA
        JR      NC,NextZone
        LD      A,(IX+0)
        LD      (TypeFleche+1),A        ; Positionne type de curseur
        LD      D,(IX+6)
        LD      E,(IX+5)                ; DE = pointeur de fonction
        EX      DE,HL
        LD      (ExecFct+1),HL
        JR      DrawFleche              ; Inutile de continuer quand 1 zone trouv
NextZone:
        ADD     IX,BC                   ; Pointer vers zone suivante
        JR      BclZone
        ;
DrawFleche:
        LD      DE,DataCursUtil         ; Curseur mode utilisation
        LD      A,(ModeUtil)
        AND     A
        JR      NZ,DrawFleche1
TypeFleche:
        LD      A,0                     ; Type de flche
        AND     #03                     ; Garder seulement bits 0 et 1
        ADD     A,A
        LD      C,A
        LD      B,0
        LD      HL,PtrTypeFleche
        ADD     HL,BC
        LD      E,(HL)
        INC     HL
        LD      D,(HL)                  ; DE = buffer type de flche (bitmap)
DrawFleche1:
        LD      HL,0                    ; HL = adresse crand d'affichage
        CALL    AfficheCurseur           ; Affichage
DeplHaut:
        LD      A,0
        LD      (OldDeplHaut+1),A
DeplBas:
        LD      A,0
        LD      (OldDeplBas+1),A
DeplGauche:
        LD      A,0
        LD      (OldDeplGauche+1),A
DeplDroite:
        LD      A,0
        LD      (OldDeplDroite+1),A
        XOR     A                       ; Code flche HAUT
        CALL    #BB1E
        CALL    NZ,HAUT
        LD      A,#48                   ; Code UP Joystick
        CALL    #BB1E
        CALL    NZ,HAUT

        LD      A,#02                   ; Code flche BAS
        CALL    #BB1E
        CALL    NZ,BAS
        LD      A,#49                   ; Code DOWN Joystick
        CALL    #BB1E
        CALL    NZ,BAS

        LD      A,#01                   ; Code flche DROITE
        CALL    #BB1E
        CALL    NZ,DROITE
        LD      A,#4B                   ; Code RIGHT Joystick
        CALL    #BB1E
        CALL    NZ,DROITE

        LD      A,#08                   ; Code flche GAUCHE
        CALL    #BB1E
        CALL    NZ,GAUCHE
        LD      A,#4A                   ; Code LEFT Joystick
        CALL    #BB1E
        CALL    NZ,GAUCHE

        LD      HL,DeplBas+1
OldDeplBas:
        LD      A,0
        CP      (HL)                    ; Dplacement dans le mme sens ?
        JR      NZ,IncDeplBas
        LD      A,1                     ; Passe la vitesse de dplacement  1
        LD      (VitDeplBas+1),A
        LD      (HL),A
        JR      TstDeplHaut
IncDeplBas:
        CP      SeuilAcceleration       ; Atteint le seuil ?
        JR      C,TstDeplHaut           ; Sinon, test direction suivante
        LD      A,SeuilAcceleration
        LD      (HL),A
        DEC     A                       ; Si > Seul -> = Seuil
        LD      (OldDeplBas+1),A
        LD      A,2                     ; Passe la vitesse de dplacement  2
        LD      (VitDeplBas+1),A

TstDeplHaut:
        LD      HL,DeplHaut+1
OldDeplHaut:
        LD      A,0
        CP      (HL)                    ; Dplacement dans le mme sens ?
        JR      NZ,IncDeplHaut
        LD      A,1                     ; Passe la vitesse de dplacement  1
        LD      (VitDeplHaut+1),A
        LD      (HL),A
        JR      TstDeplGauche
IncDeplHaut:
        CP      SeuilAcceleration       ; Atteint le seuil ?
        JR      C,TstDeplGauche         ; Sinon, test direction suivante
        LD      A,SeuilAcceleration
        LD      (HL),A
        DEC     A                       ; Si > Seul -> = Seuil
        LD      (OldDeplHaut+1),A
        LD      A,2                     ; Passe la vitesse de dplacement  2
        LD      (VitDeplHaut+1),A

TstDeplGauche:
        LD      HL,DeplGauche+1
OldDeplGauche:
        LD      A,0
        CP      (HL)                    ; Dplacement dans le mme sens ?
        JR      NZ,IncDeplGauche
        LD      A,1                     ; Passe la vitesse de dplacement  1
        LD      (VitDeplGauche+1),A
        LD      (HL),A
        JR      TstDeplDroite
IncDeplGauche:
        CP      SeuilAcceleration       ; Atteint le seuil ?
        JR      C,TstDeplDroite         ; Sinon, test direction suivante
        LD      A,SeuilAcceleration
        LD      (HL),A
        DEC     A                       ; Si > Seul -> = Seuil
        LD      (OldDeplGauche+1),A
        LD      A,2                     ; Passe la vitesse de dplacement  2
        LD      (VitDeplGauche+1),A

TstDeplDroite:
        LD      HL,DeplDroite+1
OldDeplDroite:
        LD      A,0
        CP      (HL)                    ; Dplacement dans le mme sens ?
        JR      NZ,IncDeplDroite
        LD      A,1                     ; Passe la vitesse de dplacement  1
        LD      (VitDeplDroite+1),A
        LD      (HL),A
        RET
IncDeplDroite:
        CP      SeuilAcceleration       ; Atteint le seuil ?
        RET     C                       ; Sinon, fini !
        LD      A,SeuilAcceleration
        LD      (HL),A
        DEC     A                       ; Si > Seul -> = Seuil
        LD      (OldDeplDroite+1),A
        LD      A,2                     ; Passe la vitesse de dplacement  2
        LD      (VitDeplDroite+1),A
        RET

HAUT:
        LD      A,(Y)
        CP      196                     ; Y >= 196 ?
        RET     NC
VitDeplHaut:
        ADD     A,1
        LD      (Y),A
        LD      A,(DeplHaut+1)
        INC     A                       ; Incrmente le nombre de dplacements
        LD      (DeplHaut+1),A          ; en haut
        RET
BAS:
        LD      A,(Y)
        CP      16                      ; Y < 16 ?
        RET     C
VitDeplBas:
        SUB     1
        LD      (Y),A
        LD      A,(DeplBas+1)
        INC     A                       ; Incrmente le nombre de dplacements
        LD      (DeplBas+1),A           ; en bas
        RET
GAUCHE:
        LD      HL,(X)                  ; Position X
        LD      A,H
        AND     A
        JR      NZ,VitDeplGauche
        LD      A,L
        CP      2                       ; X < 2 ?
        RET     C
VitDeplGauche:
        LD      C,1
        LD      B,0
        SBC     HL,BC
        LD      (X),HL
        LD      A,(DeplGauche+1)
        INC     A                       ; Incrmente le nombre de dplacements
        LD      (DeplGauche+1),A        ;  gauche
        RET
DROITE:
        LD      HL,(X)                  ; Position X
        LD      A,H
        AND     A
        JR      Z,VitDeplDroite
        LD      A,L
        CP      55                      ; X >= 311 ?
        RET     NC
VitDeplDroite:
        LD      C,1
        LD      B,0
        ADD     HL,BC
        LD      (X),HL
        LD      A,(DeplDroite+1)
        INC     A                       ; Incrmente le nombre de dplacements
        LD      (DeplDroite+1),A        ;  droite
        RET

;
; Forcer l'affichage du curseur
;
CurseurOn
        LD      HL,DrawFleche1+1
        XOR     A
        LD      (HL),0
        INC     HL
        LD      (HL),A
        LD      (X1),A          ; forcer affichage
        RET

;
; Sauvegarder la zone cran qui est sous le curseur
;
SavScrCurseur:
        LD      DE,BuffFleche
        LD      A,15                    ; 15 lignes  sauvegarder
SavScrCurseur2:
        LDI
        LDI
        LDI
        LD      BC,#7FD
        ADD     HL,BC
        JR      NC,SavScrCurseur3
        LD      BC,#C050
        ADD     HL,BC
SavScrCurseur3:
        DEC     A
        JR      NZ,SavScrCurseur2
        RET

;
; Restaurer la zone cran qui tait sous le curseur
;
CurseurOff:
        LD      HL,(DrawFleche1+1)
        LD      A,H
        OR      L
        RET     Z
        LD      DE,BuffFleche
        LD      A,15                    ; 15 lignes  restaurer
CurseurOff2:
        EX      DE,HL
        LDI
        LDI
        LDI
        EX      DE,HL
        LD      BC,#7FD
        ADD     HL,BC
        JR      NC,CurseurOff3
        LD      BC,#C050
        ADD     HL,BC
CurseurOff3:
        DEC     A
        JR      NZ,CurseurOff2
        RET

;
; Afficher le curseur
;
AfficheCurseur:
        LD      A,(X)                   ; Faire ( X AND 3 ) * 45
        AND     3
        LD      B,A
        ADD     A,A                     ; * 2
        ADD     A,A                     ; * 4
        ADD     A,A                     ; * 8
        ADD     A,A                     ; * 16
        LD      C,A
        ADD     A,A                     ; * 32
        ADD     A,C                     ; * 48
        SUB     B
        SUB     B
        SUB     B                       ; * 45
        LD      C,A                     ; C = ( X AND 3 ) * 45
        LD      B,0
        EX      DE,HL
        ADD     HL,BC
        EX      DE,HL
        LD      B,15                    ; 15 lignes  afficher
AfficheCurseur2:
        PUSH    BC
        LD      B,3                     ; 3 colonnes  afficher
        EX      DE,HL
AfficheCurseur3:
        LD      A,(HL)
        LD      C,A
        RRCA
        RRCA
        RRCA
        RRCA
        OR      C                       ; Bits 0-3 | Bits 4-7 dans tous les bits
        CPL
        LD      C,A
        LD      A,(DE)
        AND     C
        OR      (HL)
        LD      (DE),A
        INC     HL
        INC     DE
        DJNZ    AfficheCurseur3         ; Boucle pour les 3 colonnes
        EX      DE,HL
        LD      BC,#7FD
        ADD     HL,BC
        JR      NC,AfficheCurseur4
        LD      BC,#C050
        ADD     HL,BC
AfficheCurseur4:
        POP     BC
        DJNZ    AfficheCurseur2         ; Boucle pour les 15 lignes
        RET

;
; Pointeurs vers les bitmaps dfinissant les diffrents types de curseur
;
PtrTypeFleche:
        DW      DataCursFleche          ; Flche (standard)
        DW      DataCursLoupe           ; Loupe (mode recherche sur zone trouve)
        DW      DataCursDepl            ; Dplacement (mode recherche->issue)
        DW      DataCursUtil            ; Mode utilisation
