;
; Dbut programme, sauvegarde couleurs par dfaut
;
        LD      HL,SauveInk
        LD      DE,Ink1
        LDI
        LDI
        LDI
        CALL    RestoreEcran            ; Copie cran de #4000 en #C000
        LD      A,5
        CALL    SetBank                 ; Banque par dfaut = 5
        CALL    InitDatas               ; Initialisation des donnes

BouclePrg:
        LD      A,#30
        CALL    SetAdrMemEcr            ; Positionne adresse cran en #C000
        LD      A,(NumVue)
OldVue:
        CP      0                       ; Vue dj charge ?
        JR      Z,DejaLue
        LD      (OldVue+1),A            ; Ancienne vue = vue courante
        LD      (NouvelleVue),A         ; Nouvelle vue = vue courante
        CALL    ReadImage               ; Lecture image
        LD      A,4
        CALL    SetBank                 ; Banque 4 = buffer dcompactage
        LD      HL,StartImgCmp
        LD      DE,#4000
        CALL    DepkLzw                 ; Dcompactage
        CALL    AffImgVueSansCopie
        LD      HL,160                  ; Recentrer le curseur
        LD      (X),HL
        LD      A,100
        LD      (Y),A
        JR      BouclePrg               ; Au cas ou fonction init modifie n vue
DejaLue:
        LD      A,(PerdVie)
        AND     A                       ; A-t-on perdu une vie ?
        JP      NZ,DecNbVie
        LD      A,(JoueurPerdu)
        AND     A                       ; A-t-on perdu le jeu ?
        JR      NZ,DemandeRejoue
        CALL    CurseurOn               ; Afficher le curseur
Bcl:
        CALL    MovCursor               ; Dplacer le curseur
        CALL    #BB09                   ; Lit clavier
        JP      C,DecodeClavier         ; Si une touche appuye...
        LD      A,(FIPR)
        AND     A                       ; Click ?
        JR      Z,Bcl                   ; Sinon, boucle dplacement curseur
        CALL    VideBuffClav
        LD      HL,(ExecFct+1)
        LD      A,H                     ; Fonction  excuter ?
        OR      L
        JR      Z,Bcl                   ; Sinon, boucle dplacement curseur
        CALL    CurseurOff              ; Effacer le curseur
        LD      HL,(ExecFct+1)
        LD      A,(TypeFleche+1)
        AND     #F0                     ; Masquer Bits 0-3
        JR      Z,ExecFct               ; Si = 0 -> excuter fonction
        BIT     4,A                     ; Affichage message ?
        CALL    NZ,FctAffMessGene
        LD      A,(ExecFct+1)
        LD      B,A
        LD      A,(TypeFleche+1)
        BIT     5,A                     ; Changement salle ?
        CALL    NZ,GoVue
        JP      BouclePrg
ExecFct:
        CALL    0                       ; Executer la fonction
        JP      BouclePrg               ; Boucle

;
; Demande au joueur si il veut rejouer
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
DemandeRejoue:
        LD      HL,MsgRejoue
        PUSH    HL
        LD      HL,FenDialogue
        LD      A,1
        LD      (InhibeInit+1),A        ; Inhibition fonction init.
        CALL    AfficheWinMsg
        POP     DE
        CALL    PrtMWin
DemandeRejoue1:
        CALL    #BB18
        CP      'a'
        JR      C,DemandeRejoue2
        SUB     32
DemandeRejoue2:
        CP      'N'
        JP      Z,0
        CP      'O'
        JR      NZ,DemandeRejoue1
        XOR     A
        LD      (JoueurPerdu),A
        INC     A
        LD      (InhibeInit+1),A        ; Inhibition fonction init.
        CALL    AffImgVue               ; Raffiche l'image
        CALL    InitDatas               ; Initialisatin Datas
        CALL    VideBuffClav
        JP      BouclePrg

;
; Dcrmente une vie du joueur
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
DecNbVie:
        XOR     A
        LD      (PerdVie),A
        LD      A,(NbVies)
        DEC     A
        LD      (NbVies),A
        JR      Z,DecNbVieMort
        LD      HL,MsgPerdVie
        LD      A,1
        LD      (InhibeInit+1),A        ; Inhibition fonction init.
        CALL    AfficheWinWait
        LD      A,18
        LD      (NumVue),A
        JP      BouclePrg
DecNbVieMort:
        LD      HL,MsgMort
        LD      A,1
        LD      (InhibeInit+1),A        ; Inhibition fonction init.
        CALL    AfficheWinWait
        JR      DemandeRejoue

;
; Dcode une touche du clavier
; Entre
; - A = code ascii touche (retourne par le vecteur #BB09)
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
DecodeClavier:
        CP      252                     ; Touche ESC = Menu
        JP      Z,AfficheMenu
        CP      'a'
        JR      C,NoLower
        SUB     32
NoLower:
        CP      'I'                     ; Inventaire
        JR      Z,AfficheInventaire
        CP      'R'                     ; Mode recherche ?
        JR      Z,SetModeRecherche
        CP      'U'                     ; Mode utilisation ?
        JR      Z,SetModeUtilisation
        CP      'C'
        JP      Z,AfficheCarte
        CP      'S'                     ; Sauvegarde
        JP      Z,SaveGame
        CP      'L'                     ; Lecture
        JP      Z,LoadGame
        CP      'X'                     ; Inversion couleurs curseur
        JP      Z,ChangeCurseur
        JP      Bcl

;
; Passage du curseur en mode "recherche"
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
SetModeRecherche:
        LD      A,(ModeUtil)            ; Mode utilisation
        AND     A
        JP      Z,Bcl                   ; Si dja en mode recherche
        XOR     A
        LD      (ModeUtil),A
        CALL    CurseurOff
        JP      BouclePrg

;
; Passage du curseur en mode "utilisation"
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
SetModeUtilisation
        LD      A,(ModeUtil)            ; Mode utilisation
        AND     A
        JP      NZ,Bcl                  ; Si dj en mode utilisation
        LD      A,(ObjUtil)
        AND     A                       ; Utilise dj un objet ?
        JR      Z,AfficheInventaire     ; Sinon, appelle inventaire
        LD      A,1
        LD      (ModeUtil),A            ; Passe en mode utilisation
        CALL    CurseurOff
        CALL    TestUtilDirect
        JP      BouclePrg

;
; Affichage de l'inventaire, attends l'appui sur une touche pour utiliser
; un objet ou la touche escape pour sortir de l'inventaire
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
AfficheInventaire:
        CALL    CurseurOff
        LD      HL,FenInventaire1
        CALL    AfficheWinMsg
        LD      HL,FenInventaire2
        CALL    AfficheWinMsg
        LD      HL,FenInventaire3
        CALL    AfficheWinMsg
        LD      HL,MsgInventaire
        CALL    PrintMessCPC
        LD      DE,Inventaire
        LD      B,10                    ; 10 objets max.
PrintObjInv2:
        PUSH    BC
        PUSH    DE
        LD      H,2                     ; Position X = 2
        LD      A,19
        SUB     B
        LD      L,A                     ; Position Y = 19 - numro obj.
        ADD     A,'0'-9
        LD      B,A                     ; Sauvegarde A
        CALL    #BB75                   ; LOCATE
        LD      A,B                     ; Rcupre A
        CALL    #BB5A
        LD      A,32
        CALL    #BB5A
        LD      A,(DE)                  ; Objet inventaire
        AND     A
        JR      Z,PrintObjInv5
        LD      D,A                     ; D = numro d'objet  afficher
        LD      A,(ObjUtil)             ; Regarde objet utilis
        CP      D                       ; Est gal objet  afficher ?
        CALL    Z,#BB9C                 ; Inverse vido
        LD      A,D
        CALL    FindTxtObj
        LD      A,D
        CP      23                      ; Objet = pices d'or ?
        JR      NZ,PrintObjInv3
        LD      A,(NbPiecesOr)
        LD      E,A
        CP      10
        JR      C,PrintNbPieces2
        SUB     10
        LD      E,A
        LD      A,'1'
        CALL    #BB5A
PrintNbPieces2:
        LD      A,E
        ADD     A,'0'
        CALL    #BB5A
        LD      A,32
        CALL    #BB5A
PrintObjInv3:
        LD      A,(HL)
        CP      32
        JR      C,PrintObjInv4
        CALL    #BB5A
        INC     HL
        JR      PrintObjInv3
PrintObjInv4:
        LD      A,(ObjUtil)             ; Regarde objet utilis
        CP      D                       ; Est gal objet  afficher ?
        CALL    Z,#BB9C                 ; Inverse vido
PrintObjInv5:
        POP     DE
        INC     DE
        POP     BC
        DJNZ    PrintObjInv2
        LD      A,(ProtectionArmure)
        LD      HL,MsgProtectArmure
        AND     A
        CALL    NZ,PrintMessCPC
        LD      A,(ProtectionEsprit)
        LD      HL,MsgProtectEsprit
        AND     A
        CALL    NZ,PrintMessCPC
        LD      A,(ProtectionMagie)
        LD      HL,MsgProtectMagie
        AND     A
        CALL    NZ,PrintMessCPC
ToucheInv:
        CALL    #BB18
        CP      252                     ; ESC
        JR      Z,FinInv
        CP      '0'
        JR      C,ToucheInv
        CP      '9'+1
        JR      NC,ToucheInv
        SUB     '0'
        LD      C,A                     ; C = numro press (0  9)
        LD      B,0
        LD      HL,Inventaire
        ADD     HL,BC
        LD      A,(HL)
        AND     A
        JR      Z,ToucheInv
        ;
        ; Ici, C = index de l'objet dans inv, A = Numro de l'objet
        ;
        LD      (ObjUtil),A
        LD      A,1
        LD      (ModeUtil),A
        CALL    TestUtilDirect          ; Pour objets  utilisation directe
        LD      A,(OldVue+1)
        AND     A                       ; Demande recharger image ?
        JP      Z,BouclePrg

FinInv:
        CALL    AffImgVue               ; Raffiche l'image
        CALL    VideBuffClav
        JP      BouclePrg

;
; Affichage de la carte
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
AfficheCarte:
        LD      A,(NumVue)
        CP      10                      ; Vue >= 10 ?
        JP      C,Bcl                   ; Si non, pas de carte dans la maison.
        CALL    CurseurOff
        CALL    CopieEcran
        CALL    EffaceEcran
        LD      A,1
        LD      BC,#1A1A
        CALL    #BC32
        LD      A,2
        LD      BC,#0606
        CALL    #BC32
        LD      A,3
        LD      BC,#0606
        CALL    #BC32
        LD      A,#30
        CALL    SetAdrMemEcr
        LD      HL,SptPlan01
        CALL    DepkWin
        LD      HL,SptPlan02
        CALL    DepkWin
        LD      HL,SptPlan03
        CALL    DepkWin
        LD      HL,SptPlan04
        CALL    DepkWin
        LD      A,(NumVue)
        SUB     10
        ADD     A,A
        LD      C,A
        LD      B,0
        LD      HL,PtrAdrCroix
        ADD     HL,BC
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        LD      HL,BitmapCroix
        EX      DE,HL
BclAfficheCroix:
        PUSH    DE
        PUSH    HL
        LD      B,8
AfficheCroix:
        LD      A,(DE)
        XOR     (HL)
        LD      (HL),A
        INC     HL
        INC     DE
        LD      A,(DE)
        XOR     (HL)
        LD      (HL),A
        INC     DE
        DEC     HL
        CALL    #BC26
        DJNZ    AfficheCroix
        LD      B,CroixBlinkSpeed       ; Vitesse clignottement de la croix
        CALL    WaitFrames
        CALL    #BB09
        POP     HL
        POP     DE
        JR      NC,BclAfficheCroix
        CALL    SetColImg
        CALL    RestoreEcran
        JP      BouclePrg

;
; Affichage du menu (aide) du jeu
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
AfficheMenu:
        CALL    CurseurOff
        LD      HL,FenInventaire1
        CALL    AfficheWinMsg
        LD      HL,MsgAide
        CALL    PrintMessCPC
FinMenu:
        CALL    #BB18
        CP      252                     ; ESC
        JR      NZ,FinMenu
        CALL    AffImgVue               ; Raffiche l'image
        CALL    VideBuffClav
        JP      BouclePrg

;
; Sauvegarde d'une partie
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
SaveGame:
        CALL    CurseurOff
        CALL    DemandeSave
        JP      BouclePrg
DemandeSave:
        LD      A,1
        CALL    DemandeFace
        LD      HL,_DataDeb
        LD      BC,#1C9
        LD      D,41
        CALL    WriteSectors
        JR      C,SaveSuite
        LD      HL,MsgSaveErr
        CALL    AfficheWinWait
        JP      BouclePrg
SaveSuite:
        LD      HL,MsgSaveOk
        JP      AfficheWinWait

;
; Lecture d'une partie
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
; -> Saut (JP)  la boucle principale du jeu -> ne pas appeler par un call
;
LoadGame:
        CALL    CurseurOff
        CALL    DemandeLoad
        XOR     A
        LD      (OldVue+1),A            ; Forcer  recharger la vue
        JP      BouclePrg
DemandeLoad:
        LD      A,1
        CALL    DemandeFace
        LD      HL,BuffSpt
        LD      BC,#1C9
        LD      D,41
        CALL    ReadSectors
        JR      C,LoadSuite
LoadErr:
        LD      HL,MsgLoadErr
        CALL    AfficheWinWait
        JP      BouclePrg
LoadSuite:
        LD      HL,IdentData
        LD      DE,BuffSpt
LoadTstOk:
        LD      A,(DE)
        CP      (HL)
        JR      NZ,LoadErr
        INC     HL
        INC     DE
        AND     A
        JR      NZ,LoadTstOk
        INC     A
        LD      (InhibeInit+1),A
        LD      HL,BuffSpt
        LD      DE,_DataDeb
        LD      BC,_DataFin-_DataDeb
        LDIR
        LD      HL,MsgLoadOk
        JP      AfficheWinWait

        LD      HL,FenDialogue
        CALL    AfficheWinMsg
        LD      DE,MsgLoadOk
        JP      PrtMWin

;
; Effacer l'cran en #C000
; Entre
; -
; Sortie
; - BC, DE, HL modifis
;
EffaceEcran:
        LD      HL,#C000
        LD      DE,#C001
        LD      BC,#3FCF
        LD      (HL),L
        LDIR
        RET

;
; Copie l'cran de #C000 vers #4000 et passe l'adresse de dbut de la mmoire
; vido en #4000
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
;
CopieEcran:
        XOR     A
        CALL    SetBank
        LD      HL,#C000
        LD      DE,#4000
        LD      BC,#3FD0
        LDIR
        LD      A,#10
        JP      SetAdrMemEcr

;
; Restaure l'cran de #4000 vers #C000, laisse l'adresse de dbut de la mmoire
; vido en #4000
; Entre
; -
; Sortie
; - AF, BC, DE, HL modifis
;
RestoreEcran:
        XOR     A
        CALL    SetBank
        LD      A,#10
        CALL    SetAdrMemEcr
        LD      HL,#4000
        LD      DE,#C000
        LD      BC,#3FD0
        LDIR
RestoreAdrEcr:
        LD      A,#30
        JP      SetAdrMemEcr            ; #### Exprimental

;
; Vider le buffer clavier
; Entre
; -
; Sortie
; - AF modifi
;
VideBuffClav:
        CALL    #BB09
        JR      C,VideBuffClav
        RET

;
; Attendre pause de 1/50e de secondes
; Entre
; - B = nombre de pauses
; Sortie
; - B = 0
;
WaitFrames:
        CALL    #BD19
        HALT
        HALT
        DJNZ    WaitFrames
        RET

;
; Ajoute un objet dans l'inventaire
; Entre
; - A = numro de l'objet  ajouter
; Sortie
; - Si objet ajout ok, flag C = 1, sinon (plus de place), Flag C = 0
; - HL, BC, A modifis
;
AjouteObjInv:
        LD      B,10
        LD      HL,Inventaire
        LD      C,A
AjouteObjInvTst:
        LD      A,(HL)
        AND     A
        JR      Z,AjouteObjInvOk        ; Place trouve
        INC     HL
        DJNZ    AjouteObjInvTst
        ; Pas trouv de place dans l'inventaire...
        POP     AF                      ; Rcupre adresse de retour
        JP      FctAffInvPlein
AjouteObjInvOk:
        LD      (HL),C                  ; Ajoute objet dans inventaire
        RET

;
; Recherche si un objet est prsent dans l'inventaire
; Entre
; - A = numro d'objet  rechercher
; Sortie
; - Flag Z = 1 si objet trouv
; - HL, BC, A modifis
;
RechObjInv:
        LD      B,10
        LD      HL,Inventaire
        LD      C,A
RechObjInvTst:
        LD      A,(HL)
        CP      C
        RET     Z
        INC     HL
        DJNZ    RechObjInvTst
        RET

;
; Supprime un objet de l'inventaire
; Entre
; - A = numro d'objet  supprimer
; Sortie
; - Si objet supprim ok, flag C = 1, sinon (pas trouv), Flag C = 0
; - HL, DE, BC, A modifis
;
SupObjInv:
        LD      B,10
        LD      HL,Inventaire
        LD      C,A
SupObjInvTst:
        LD      A,(HL)
        CP      C
        JR      Z,SupObjInvTrouve
        INC     HL
        DJNZ    SupObjInvTst
        XOR     A
        RET
SupObjInvTrouve:                        ; Objet touv
        LD      A,B
        DEC     A
        JR      Z,SupObjInvEfface
        LD      C,A
        LD      B,0
        LD      D,H
        LD      E,L
        INC     HL
        LDIR                            ; Dcale l'inventaire vers le haut
        DEC     HL
SupObjInvEfface:
        XOR     A
        LD      (ModeUtil),A            ; Passe en mode recherche
        LD      (ObjUtil),A             ; Pas d'objet utilis
        LD      (HL),A                  ; Dernier objet = 0
        SCF
        RET

;
; Test si l'objet est  "utilisation directe"
; Entre
; -
; Sortie
; - HL, BC, DE, AF modifis
; Si fin du jeu, reboucle le jeu quand on demande au joueur si il veut
; rejouer (un POP est effectu alors pour supprimer l'adresse de retour du
; CALL de la pile).
;
TestUtilDirect:
        LD      A,(ObjUtil)
        CP      14                      ; Objet = Potion ?
        JR      NZ,TestUtilTrad
        CALL    SupObjInv               ; Supprime potion de l'inventaire
        XOR     A
        LD      (ObjUtil),A             ; Plus d'objets utilis
        LD      (ModeUtil),A            ; Mode recherche
        INC     A
        LD      (PotionBue),A           ; Potion bue
        RET
TestUtilTrad:
        CP      OBJ_Traducteur          ; Objet = Traducteur universel ?
        JR      NZ,TestUtilDisquette
        XOR     A
        LD      (ModeUtil),A
        LD      (ObjUtil),A
        XOR     A
        LD      (OldVue+1),A            ; Pour forcer relecture
        LD      A,80                    ; Image traducteur
        CALL    ReadImage
        LD      A,4
        LD      (InhibeInit+1),A
        CALL    SetBank                 ; Banque 4 = buffer dcompactage
        LD      HL,StartImgCmp
        LD      DE,#4000
        CALL    DepkLzw                 ; Dcompactage
        CALL    AffImgVueSansCopie
        JP      #BB18
TestUtilDisquette:
        CP      OBJ_Disquette
        RET     NZ
        XOR     A
        LD      (ModeUtil),A
        LD      (ObjUtil),A
        LD      A,OBJ_EcranCPC
        CALL    RechObjInv
        LD      HL,DialManqueEcran
        JP      NZ,TestUtilDisquetteManque
        LD      A,OBJ_ClavierCPC
        CALL    RechObjInv
        LD      HL,DialManqueClavier
        JP      NZ,TestUtilDisquetteManque
        LD      A,OBJ_Courroie
        CALL    RechObjInv
        LD      HL,DialManqueCourroie
        JP      NZ,TestUtilDisquetteManque
        ;
        ; Tous les lments du CPC sont runis, la disquette nous ramne
        ; dans le monde rel !!!
        ;
FinJeu:
        CALL    AffImgVue               ; Raffiche l'image
        LD      HL,DialFin1
        CALL    AfficheWinWaitC7
        CALL    VideBuffClav
        CALL    CopieEcran
        LD      A,#30
        CALL    SetAdrMemEcr            ; Positionne adresse cran en #C000
        LD      A,79
        CALL    ReadImage               ; Lecture image
        LD      A,4
        CALL    SetBank                 ; Banque 4 = buffer dcompactage
        LD      HL,StartImgCmp
        LD      DE,#4000
        CALL    DepkLzw                 ; Dcompactage
        CALL    AffImgVueSansCopie
        LD      HL,DialFin2
        CALL    AfficheWinWaitC7
        LD      HL,DialFin3
        CALL    AfficheWinWaitC7
        LD      HL,DialFin4
        CALL    AfficheWinWaitC7
        LD      HL,DialFin5
        CALL    AfficheWinWaitC7
        LD      HL,DialFin6
        CALL    AfficheWinWaitC7
        LD      B,50
        CALL    WaitFrames
        LD      HL,SptMonstre1
        CALL    DepkWin
        LD      B,50
        CALL    WaitFrames
        LD      HL,SptMonstre2
        CALL    DepkWin
        LD      B,50
        CALL    WaitFrames
        LD      HL,SptMonstre3
        CALL    DepkWin
        LD      A,2
        CALL    DemandeFace
        CALL    CopieEcran
        LD      BC,#0AC0
        LD      D,41
        LD      HL,#C000
        PUSH    HL
        CALL    ReadSectors
        POP     HL
        LD      DE,#D400
        PUSH    DE
        CALL    DepkLzw
        POP     HL
        CALL    PlaySample
        CALL    RestoreEcran
        LD      HL,DialFin7
        CALL    AfficheWinNoWaitC7
        CALL    VideBuffClav
        LD      A,#30
        CALL    SetAdrMemEcr
        CALL    #BB18
        CALL    RestoreEcran
        LD      HL,DialFinMerci1
        CALL    AfficheWinWait
        CALL    RestoreEcran
        POP     HL                      ; Car nous venons d'un CALL
        JP      DemandeRejoue           ; Demande si l'on veut rejouer
TestUtilDisquetteManque:
        JP      AfficheWinWait

;
; Recherche le texte d'un objet
; Entre
; - A = numro d'objet
; Sortie
; - HL = pointeur sur le texte de l'objet, C = longueur texte
; - A = 0, B = 0
;
FindTxtObj:
        LD      HL,ListeObj
        LD      B,0
FindTxtObj2:
        LD      C,(HL)
        INC     HL
        DEC     A
        RET     Z
        ADD     HL,BC
        JR      FindTxtObj2

;
; Change une banke RAM du CPC 6128 (numro banque de 4  8, ou 0 (0=8) )
; Entre
; - A = numro de banque (de 0  8)
; Sortie
; - BC = #7FCX
;
SetBank:
        OR      #C0
        LD      (NumBank+1),A
NumBank:
        LD      BC,#7FC0
        OUT     (C),C
        RET

;
; Positionne l'adresse de dbut de la mmoire cran (poids fort)
; Entre
; - A = valeur  positionner dans le registre 12 du CRTC
; sortie
; - BC = #BD0C
;
SetAdrMemEcr:
        LD      BC,#BC0C
        OUT     (C),C
        INC     B
        OUT     (C),A
        RET

;
; Affiche l'image dcompacte
; Entre
; -
; Sortie
; HL, BC, DE, AF modifis
;
AffImgDcmp:
        LD      A,4
        CALL    SetBank                 ; Banque 4 = buffer dcompactage
        LD      HL,#4000
        LD      DE,#C000
        LD      B,200
Affiche1:
        PUSH    BC
        LD      A,80
Affiche2:
        LDI
        LD      BC,199
        ADD     HL,BC
        DEC     A
        JR      NZ,Affiche2
        LD      BC,#C181
        ADD     HL,BC
        EX      DE,HL
        LD      BC,#7B0
        ADD     HL,BC
        JR      NC,Affiche3
        LD      BC,#C050
        ADD     HL,BC
Affiche3:
        EX      DE,HL
        POP     BC
        DJNZ    Affiche1
        LD      A,5
        JR      SetBank

;
; Affichage complet de l'image de la vue en cours + appel fonction initialisation
; Entre
; -
; Sortie
; HL, DE, BC, AF modifis
;
AffImgVue:
        CALL    CopieEcran
AffImgVueSansCopie:
        LD      A,#10
        CALL    SetAdrMemEcr
        CALL    AffImgDcmp
InhibeInit:
        LD      A,0
        AND     A                       ; Fonction init. inhibe ?
        JR      NZ,FinInitVue
        LD      A,(NumVue)
        DEC     A
        ADD     A,A
        LD      C,A
        LD      B,0
        LD      HL,PtrFctInitVue        ; Pointeurs fonctions init. vues
        ADD     HL,BC
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        LD      A,D
        OR      E                       ; Y-a-t-il une fonction ?
        JR      Z,FinInitVue
        LD      (ExecFctInit+1),DE
ExecFctInit:
        CALL    0                       ; Appel fonction init. vue
FinInitVue:
        XOR     A
        LD      (InhibeInit+1),A        ; Dsactive inhibition fonction init.
        LD      B,#F5
        IN      A,(C)
        RRA
        JR      NC,FinInitVue
        CALL    SetColImg
        LD      A,#30
        CALL    SetAdrMemEcr
        LD      A,5
        JP      SetBank

;
; Positionne les couleurs de l'image
; Entre
; -
; Sortie
; HL, DE, BC, AF modifis
;
SetColImg:
        LD      HL,Ink1                 ; Dbut pointeur image = couleurs
        LD      A,1                     ; On commence  la couleur 1
SetColImg2:
        PUSH    AF
        PUSH    HL
        LD      B,(HL)
        LD      C,B
        CALL    #BC32                   ; Positionner les couleurs
        POP     HL
        POP     AF
        INC     HL
        INC     A
        CP      4                       ; Arrt quand couleur 3 positionne
        JR      C,SetColImg2
        RET

;
; Affiche un message avec la police CPC
; Entre
; - HL pointe sur le message, qui doit se terminer par un zro.
; Sortie
; HL, DE, BC, AF modifis
;
PrintMessCPC:
        LD      A,(HL)
        AND     A
        RET     Z
        INC     HL
        CP      32
        JR      C,PrintMessCtrl
        PUSH    HL
        CALL    #BB5D
        POP     HL
        JR      PrintMessCPC
PrintMessCtrl:
        CALL    #BB5A
        JR      PrintMessCPC

;
; Affichage d'une fentre avec une question  choix multiples, et attends
; la rponse du joueur, puis efface la fentre et retourne la rponse.
; Entre
; - HL = texte  afficher dans la fentre
; - A = nombre de rponses possibles (de 1  9).
; Sortie
; - A = numro choisi par le joueur (de 1  X)
; - HL, DE, BC modifis
;
WaitQCM:
        LD      (MaxChoixQCM+1),A
        PUSH    HL
        LD      HL,FenDialogue
        CALL    AfficheWinMsg
        POP     DE
        CALL    PrtMWin
        LD      A,#30
        CALL    SetAdrMemEcr
WaitQCMKey:
        CALL    #BB18
        SUB     '1'
MaxChoixQCM:
        CP      1
        JR      NC,WaitQCMKey
        INC     A
        PUSH    AF
        CALL    AffImgVue
        CALL    VideBuffClav
        POP     AF
        RET

;
; Dplacement vers la vue prcdente
; Entre
; -
; Sortie
; A, B modifis
;
GoPrevVue:
        LD      A,(PrevVue)
        LD      B,A                     ; B = numro vue prcdente

;
; Dplacement vers une vue
; Entre
; - B = numro de la vue
; Sortie
; - A = B
;
GoVue:
        LD      A,(ModeUtil)            ; Dans quel mode sommes-nous
        AND     A                       ; Mode utilisation ?
        RET     NZ                      ; Si oui, pas de dplacements
        LD      A,(NumVue)
        LD      (PrevVue),A             ; Vue courrante devient vue prcdente
        LD      A,B
        LD      (NumVue),A              ; Changement de vue
        RET

;
; Recherche un mot dans une phrase saisie
; Entre
; - DE = mot  rechercher
; Sortie
; - Si trouv, Flag Z = 1, A = 0, sinon, A != 0, Flag Z = 0
; - HL, DE, B modifis
;
RechercheMot:
        LD      HL,MotSaisi
        LD      B,TailleMot
RechercheMot1:
        PUSH    DE
        PUSH    HL
RechercheMot2:
        LD      A,(DE)
        AND     A                       ; Fin du mot ?
        JR      Z,RechercheMotTrouve    ; Si oui, on a trouv
        CP      (HL)                    ; Compare mot avec phrase
        JR      NZ,RechercheMot3        ; Pas gal
        INC     HL
        INC     DE
        JR      RechercheMot2
RechercheMot3:
        POP     HL
        POP     DE
        INC     HL                      ; Passe au caractre suivant de la phrase
        DJNZ    RechercheMot1
        AND     A                       ; Positionne flag Z  zro (A!=0)
        RET
RechercheMotTrouve:
        POP     HL
        POP     DE
        RET

;
; Affichage d'un message si mode recherche, sinon, affiche marche pas
;
FctAffMessGene:
        LD      A,(ModeUtil)
        AND     A                       ; Mode recherche ?
        JR      Z,AfficheWinWait        ; Si oui, affiche message
FctAffMarchePas:
        LD      HL,DialMarchePas        ; Message "a ne marche pas"
        JR      AfficheWinWait

;
; Message "rien de spcial"
;
FctAffRienSpecial:
        LD      HL,DialRienSpecial
        JR      FctAffMessGene

;
; Message "rien d'intressant"
;
FctAffRienInteressant:
        LD      HL,DialRienInteressant
        JR      FctAffMessGene

;
; Message "placard s'ouvre"
;
FctAffPlacardOuvre:
        LD      HL,DialPlacardOuvre
        JR      AfficheWinWait

;
; Message "placard ferm"
;
FctAffPlacFerme:
        LD      HL,DialPlacFerme
        JR      FctAffMessGene

;
; Message "inventaire plein"
;
FctAffInvPlein:
        LD      HL,DialInvPlein
        JR      AfficheWinWait

;
; Affichage d'un texte dans une fentre spcifique lors de l'initialisation
; Entre
; - HL = adresse de la fentre texte  afficher
; Sortie
; - HL, DE, BC, AF modifis
;
AfficheWinInit:
        PUSH    HL
        CALL    SetColImg
        POP     HL
        CALL    AfficheWinMsg
AfficheWinInitWaitKey:
        LD      A,#30
        CALL    SetAdrMemEcr
        CALL    #BB18
        CALL    VideBuffClav
        CALL    CopieEcran
        JP      AffImgDcmp

;
; Affichage d'un texte lors de l'initialisation de la vue
; Entre
; - HL = adresse du texte  afficher
; Sortie
; - HL, DE, BC, AF modifis
;
AfficheTexteInit:
        PUSH    HL
        CALL    SetColImg
        LD      HL,FenDialogue
        CALL    AfficheWinMsg
        POP     DE
        CALL    PrtMWin
        JR      AfficheWinInitWaitKey

;
; Affichage d'une fentre avec un message.
; Entre
; - HL = adresse texte  afficher dans la fentre
; Sortie
; - HL, DE, BC, AF modifis
;
AfficheWinNoWait:
        PUSH    HL
        LD      HL,FenDialogue
        CALL    AfficheWinMsg
        POP     DE
        JP      PrtMWin

;
; Affichage d'une fentre avec un message.contenu en bank #C7
; Entre
; - HL = texte  afficher dans la fentre
; Sortie
; - HL, DE, BC, AF modifis
;
AfficheWinNoWaitC7:
        PUSH    HL
        LD      HL,FenDialogue
        CALL    AfficheWinMsg
        LD      A,7
        CALL    SetBank
        POP     DE
        JP      PrtMWin

;
; Affichage d'une fentre avec un message et attends l'appui sur une touche
; pour effacer la fentre (rafficher la vue en cours)
; Entre
; - HL = texte  afficher dans la fentre
; Sortie
; - HL, DE, BC, AF modifis
;
AfficheWinWait:
        CALL    AfficheWinNoWait
        LD      A,#30
        CALL    SetAdrMemEcr
        CALL    #BB18
        CALL    VideBuffClav
        JP      AffImgVue

;
; Affichage d'une fentre avec un message et attends l'appui sur une touche
; pour effacer la fentre (rafficher la vue en cours)
; Entre
; - HL = texte  afficher contenu en bank #C7 dans la fentre
; Sortie
; - HL, DE, BC, AF modifis
;
AfficheWinWaitC7:
        CALL    AfficheWinNoWaitC7
        CALL    #BB18
        CALL    VideBuffClav
        JP      AffImgVue

;
; Inverse les couleurs du curseur
; Entre
; -
; Sortie
; HL, DE, BC, AF modifis
;
ChangeCurseur:
        LD      HL,DataCursFleche
        LD      BC,720
ChangeCurseur1:
        LD      A,(HL)
        RRCA
        RRCA
        RRCA
        RRCA
        LD      (HL),A
        INC     HL
        DEC     BC
        LD      A,B
        OR      C
        JR      NZ,ChangeCurseur1
        CALL    CurseurOff
        JP      BouclePRG

;
; Calcule un nombre alatoire dans HL
; Entre
; -
; Sortie
; - HL = valeur alatoire, AF modifi
;
Random:
        LD      A,R
        XOR     (HL)
        RRCA
        RRCA
        RRCA
        RRCA
        LD      H,A
        LD      A,R
        XOR     (HL)
        LD      L,A
        RET

;
; Ajuste un nombre pour qu'il soit infrieur  1000 (coordonne alatoire)
; Entre
; - HL = nombre
; Sortie
; - HL = nombre ajust, BC = 1000, Flags modifis
;
Ajuste999:
        LD      BC,1000
Ajuste999Tst:
        AND     A
        SBC     HL,BC
        JR      NC,Ajuste999Tst
        ADD     HL,BC
        RET

;
; Initialisation des coordonnes des 3 allis
; Entre
; -
; Sortie
; HL, BC, AF modifis
;
InitCoordAllies:
        CALL    Random
        CALL    Ajuste999
        LD      (CoordAllie1),HL
        CALL    Random
        CALL    Ajuste999
        LD      (CoordAllie1+2),HL
        CALL    Random
        CALL    Ajuste999
        LD      (CoordAllie2),HL
        CALL    Random
        CALL    Ajuste999
        LD      (CoordAllie2+2),HL
        CALL    Random
        CALL    Ajuste999
        LD      (CoordAllie3),HL
        CALL    Random
        CALL    Ajuste999
        LD      (CoordAllie3+2),HL
        RET

;
; Rinitialise les datas (pour redmarrage complet du jeu)
; Entre
; -
; Sortie
; HL, DE, BC, AF modifis
;
InitDatas:
        XOR     A
        LD      HL,ModeUtil
        LD      BC,_DataFin-ModeUtil-1
        LD      D,H
        LD      E,L
        INC     DE
        LD      (HL),A
        LDIR
        LD      HL,InfoDisquette_Identite
        LD      BC,NouvelleVue-InfoDisquette_Identite
        LD      D,H
        LD      E,L
        INC     DE
        LD      (HL),A
        LDIR
        LD      HL,160                  ; Recentrer le curseur
        LD      (X),HL
        LD      A,100
        LD      (Y),A
        LD      A,1
        LD      (NumVue),A              ; Dpart  la vue 1
        LD      (NbVies),A              ; 1 vie au dpart
        JR      InitCoordAllies

;
; Affichage d'un nombre entre 0 et 999
; Entre
; - HL = nombre
; - D = 0 ou '0' si affichage de '0'  gauche
; Sortie
; - HL, BC, DE, AF modifis
;
PrintNum:
        LD      E,'0'
        LD      BC,100
        LD      A,#FF
PrintNum1:
        INC     A
        SBC     HL,BC
        JR      NC,PrintNum1
        ADD     HL,BC
        CP      D
        JR      Z,PrintNum2
        LD      D,E
        OR      E
        CALL    #BB5A
PrintNum2:
        LD      C,10
        LD      A,#FF
PrintNum3:
        INC     A
        SBC     HL,BC
        JR      NC,PrintNum3
        ADD     HL,BC
        ADD     A,D
        JR      Z,PrintNum4
        OR      E
        CALL    #BB5A
PrintNum4:
        LD      A,L
        OR      E
        JP      #BB5D

;
; Bitmap dfinissant la croix
;
BitmapCroix:
        DB      #0C,#03
        DB      #0E,#07
        DB      #07,#0E
        DB      #03,#0C
        DB      #03,#0C
        DB      #07,#0E
        DB      #0E,#07
        DB      #0C,#03

;
; Positions de la croix en fonction du numro de vue
;
PtrAdrCroix:
        DW      #F1A5                   ; Vue 10
        DW      #F1B5                   ; Vue 11
        DW      #D8C5                   ; Vue 12
        DW      #F9CA                   ; Vue 13
        DW      #EDFF                   ; Vue 14
        DW      #EE05                   ; Vue 15
        DW      #EE15                   ; Vue 16
        DW      #EE2A                   ; Vue 17
        DW      #EECA                   ; Vue 18
        DW      #F4D5                   ; Vue 19
        DW      #F4D8                   ; Vue 20
        DW      #F4D3                   ; Vue 21
        DW      #F4D0                   ; Vue 22
        DW      #FAF6                   ; Vue 23
        DW      #D396                   ; Vue 24
        DW      #D394                   ; Vue 25
        DW      #D393                   ; Vue 26
        DW      #D393                   ; Vue 27
        DW      #D393                   ; Vue 28
        DW      #D393                   ; Vue 29
        DW      #D393                   ; Vue 30
        DW      #F705                   ; Vue 31
        DW      #E757                   ; Vue 32
        DW      #FF58                   ; Vue 33
        DW      #FF5A                   ; Vue 34
        DW      #D752                   ; Vue 35
        DW      #D74F                   ; Vue 36
        DW      #C7A1                   ; Vue 37
        DW      #E956                   ; Vue 38
        DW      #E951                   ; Vue 39
        DW      #F19E                   ; Vue 40
        DW      #E9E6                   ; Vue 41
        DW      #D1E5                   ; Vue 42
        DW      #D1E4                   ; Vue 43
        DW      #E234                   ; Vue 44
        DW      #F197                   ; Vue 45
        DW      #F196                   ; Vue 46
        DW      #D996                   ; Vue 47
        DW      #C194                   ; Vue 48
        DW      #F97A                   ; Vue 49
        DW      #F17A                   ; Vue 50
        DW      #E97A                   ; Vue 51
        DW      #E17A                   ; Vue 52
        DW      #E17B                   ; Vue 53
        DW      #E17B                   ; Vue 54
        DW      #E17B                   ; Vue 55
        DW      #E17B                   ; Vue 56
        DW      #E9D3                   ; Vue 57
        DW      #E9D5                   ; Vue 58
        DW      #F187                   ; Vue 59
        DW      #E1D8                   ; Vue 60
        DW      #CA27                   ; Vue 61
        DW      #E0E7                   ; Vue 62
        DW      #E0E9                   ; Vue 63
        DW      #E0E9                   ; Vue 64
        DW      #C8E5                   ; Vue 65
        DW      #C0E3                   ; Vue 66
        DW      #D0E3                   ; Vue 67
        DW      #D893                   ; Vue 68
        DW      #D893                   ; Vue 69
        DW      #D893                   ; Vue 70
        DW      #E634                   ; Vue 71
        DW      #E637                   ; Vue 72
        DW      #CE35                   ; Vue 73
        DW      #C685                   ; Vue 74
        DW      #D689                   ; Vue 75
        DW      #E637                   ; Vue 76
        DW      #E63C                   ; Vue 77
        DW      #E63C                   ; Vue 78
