;
; Lecture image depuis disquette
; Entre 
; - A = numro d'image (>0)
;
ReadImage:
        CALL    SauveImageAvantRead
;
ReadImage2:
        CALL    TestBitmapFace          ; Vrifier bitmap OK
        JR      Z,ReadStartData

        CALL    ReadBitmap              ; Si non, relecture
        JR      Z,ReadStartData

        LD      A,(ReadSectors+1)
        XOR     1                       ; Swap du drive
        LD      (ReadSectors+1),A
        CALL    TestDriveReady          ; Drive prsent ?
        JR      NZ,ReadImage3           ; Si drive ok, saut

        LD      A,(ReadSectors+1)
        XOR     1                       ; Swap du drive (remet drive initial)
        LD      (ReadSectors+1),A
        CALL    AffBadFace
        JR      ReadImage2              ; Reboucle

ReadImage3:
        CALL    ReadBitmap              ; Si non, relecture
        JR      Z,ReadStartData
        CALL    AffBadFace
        JR      ReadImage2

ReadStartData:
        CALL    ReadImageData           ; Lecture donnes images
        RET     NC
        CALL    AffBadFace
        ;
        ; Modifie premier octet bitmap -> forcer  relire
        ;
        LD      HL,(InfoDisquette_Identite)
        RRC     (HL)
        JR      ReadImage2

;
; Sauvegarde de l'image actuelle avant lecture nouvelle en #C000
;
SauveImageAvantRead:
        LD      (ReadImageData+1),A
        LD      BC,#FA7E
        LD      A,1
        OUT     (C),A
        CALL    CopieEcran
        LD      HL,Ink1
        LD      DE,SauveInk
        LDI                             ; Sauvegarde couleurs
        LDI
        LDI
        RET

;
; Demande l'insertion d'une face prcise
; Entre 
; - A = numro de face
;
DemandeFace:
        LD      (DemandeFace2+1),A
        CALL    SauveImageAvantRead

DemandeFace2:
        LD      A,0
        CALL    TestFaceOk              ; Face est la bonne ?
        JR      Z,DemandeFaceFin        ; Si oui, termin.
        LD      A,(ReadSectors+1)
        XOR     1                       ; Swap du drive
        LD      (ReadSectors+1),A
        CALL    TestDriveReady          ; Drive prsent ?
        JR      NZ,DemandeFace3         ; Si drive ok, saut

        LD      A,(ReadSectors+1)
        XOR     1                       ; Swap du drive (remet drive initial)
        LD      (ReadSectors+1),A
        LD      A,(DemandeFace2+1)
        CALL    AffBadFace1
        JR      DemandeFace2            ; Reboucle

DemandeFace3:
        LD      A,(DemandeFace2+1)
        CALL    TestFaceOk
        RET     Z
        LD      A,(DemandeFace2+1)
        CALL    AffBadFace1
        JR      DemandeFace2

DemandeFaceFin:
        LD      A,#30
        JP      SetAdrMemEcr            ; Remet adresse cran en #C000

ReadImageData:
        LD      A,0                     ; Numro d'image  lire
        AND     A
        RET     Z
;
; Recherche les donnes de la vue dans la bitmap
;
        CALL    FindInfoImage
        JR      Z,ReadImageData2
;        LD      A,#C0
;        CALL    SetBank
        SCF                             ; Indique erreur
        RET
;
; Lecture image en fonction des donnes de la bitmap
;
ReadImageData2:
        INC     HL
        LD      A,(HL)
        INC     HL
        LD      (AffBadFace+1),A
        LD      B,A                     ; Numro face image
        LD      A,(InfoDisquette_Face)
        CP      B
        JR      NZ,ReadImageData5
        LD      D,(HL)                  ; Piste dbut
        INC     HL
        LD      C,(HL)                  ; Secteur dbut
        INC     HL
        LD      B,(HL)                  ; Nombre de secteurs
        LD      HL,BuffCp               ; Buffer de lecture
        LD      (HL),C                  ; Pour effacer ancien n de face
        CALL    ReadSectors
        LD      HL,BuffCp
        LD      B,(HL)
        INC     HL
        LD      A,(AffBadFace+1)
        CP      B
        JR      NZ,ReadImageData5
        LD      HL,BuffCp+1
        LD      DE,Ink1
        LDI                             ; Positionner les couleurs
        LDI
        LDI
        RET                             ; Face correcte
ReadImageData5:
        SCF                             ; Forcer relecture
        RET

;
; Affichage face  insrer
;
AffBadFace:
        LD      A,0
AffBadFace1:
        ADD     A,'0'
        PUSH    AF
        LD      A,5
        CALL    SetBank
        POP     AF
        LD      (NumFaceInsere),A
        LD      DE,Ink1
        LD      HL,SauveInk
        LDI                             ; Restore ancienne couleurs
        LDI
        LDI
        CALL    RestoreEcran
        LD      HL,FenetreChgtFace
        CALL    AfficheWinMsg
        CALL    #BB18
        LD      A,#10
        JP      SetAdrMemEcr            ; Adresse cran en #4000

;
; Lecture de plusieurs secteurs
; Entre
; - B = nombre de secteurs
; - C = premier secteur
; - D = premire piste
; - HL = buffer de lecture
;
ReadSectors:
        LD      E,0
        RST     #18
        DW      FctLoadP
        RET     NC                      ; Retour si erreur
        INC     H
        INC     H
        INC     C
        LD      A,C
        CP      #CA
        JR      C,ReadSector2
        LD      C,#C0
        INC     D
ReadSector2:
        DJNZ    ReadSectors
        SCF                             ; Indique lecture ok
        RET

;
; Ecriture de plusieurs secteurs
; Entre
; - B = nombre de secteurs
; - C = premier secteur
; - D = premire piste
; - HL = buffer d'criture
;
WriteSectors:
        LD      E,0
        RST     #18
        DW      FctSaveP
        RET     NC                      ; Retour si erreur
        INC     H
        INC     H
        INC     C
        LD      A,C
        CP      #CA
        JR      C,WriteSector2
        LD      C,#C0
        INC     D
WriteSector2:
        DJNZ    WriteSectors
        SCF                             ; Indique criture ok
        RET

;
; Lecture bitmap et vrifie bitmap ok
; Sortie Flag Z = 1 -> OK, Flag Z = 0 -> Pas bonne face
;
ReadBitmap:
        LD      HL,InfoDisquette_Identite   ; Si non, relecture
        LD      D,H
        LD      E,L
        INC     DE
        LD      BC,#1FF
        LD      (HL),B                  ; Efface les donnes pour relecture
        LDIR
        LD      HL,InfoDisquette_Identite
        LD      D,0
        LD      BC,#1C0
        CALL    ReadSectors

;
; Vrifie bitmap prsent et bonne face insre
; Sortie Flag Z = 1 -> OK, Flag Z = 0 -> Erreur
;
TestBitmapFace:
        CALL    TestIdentite
        RET     NZ
        LD      A,(ReadImageData+1)     ; Numro de l'image
        CALL    FindInfoImage
        INC     HL
        LD      A,(HL)
        LD      (AffBadFace+1),A
        LD      B,A
        LD      A,(InfoDisquette_Face)  ; Face de la disquette insre
        CP      B                       ; Egale face image demande ?
        RET

;
; Vrifie face demande est la bonne
; Entre A = numro de face demande
; Sortie Flag Z = 1 -> Face ok
;
TestFaceOk:
        PUSH    AF
        CALL    ReadBitmap
        CALL    TestIdentite
        POP     BC
        RET     NZ
        LD      A,(InfoDisquette_Face)
        CP      B
        RET

;
; Vrifie identit disquette correcte
; Sortie Flag Z = 1 -> Identit ok
;
TestIdentite:
        LD      HL,InfoDisquette_Identite
        LD      DE,InfoDisquette_CheckIdentite
        LD      B,12
TestBitmapFace1:
        LD      A,(DE)
        CP      (HL)
        RET     NZ
        INC     DE
        INC     HL
        DJNZ    TestBitmapFace1
        RET
;
; Recherche les informations de l'image dans la bitmap
; Entre - A = numro d'image
; Sortie - HL = pointeur sur informations images
;
FindInfoImage:
        LD      HL,InfoDisquette_InfoVue
        LD      B,100
FindInfoImage2:
        CP      (HL)
        RET     Z
        INC     HL
        INC     HL
        INC     HL
        INC     HL
        INC     HL
        DJNZ    FindInfoImage2
        RET

;
; Vrifie si un lecteur est OK
; Sortie  si Z=0 -> drive OK, si Z=1 -> drive NON OK
;
TestDriveReady:
        LD      A,(ReadSectors+1)
        RST     #18
        DW      FctTestDrive
        JR      C,TestDriveReady2       ; Si Carry = 1, A = tat drive
        INC     HL                      ; Sinon, (HL+1) = tat
        LD      A,(HL)
TestDriveReady2:
        AND     #20
        RET

FctLoadP:
        DW      #C03C
        DB      7

FctSaveP:
        DW      #C03F
        DB      7

FctTestDrive:
        DW      #C048
        DB      7
