MAX_SCORE_PONG  EQU     '3'             ; Score  atteindre pour gagner

Pong:
        LD      A,'0'
        LD      (TxtScoreJoueur),A
        LD      (TxtScoreCPC),A
        CALL    InitPong                ; Premire initialisation des donnes
BclPong:
        CALL    AfficheScore            ; Affichage du score
        CALL    Wait5Sec                ; Attente 5 secondes
        CALL    InitPong                ; Initialisation des donnes
        CALL    Jeu                     ; Jouer un jeu
        LD      A,(JoueurPerdBalle)
        AND     A                       ; Le joueur  perdu la manche ?
        JR      NZ,CPCGagne
        LD      A,(TxtScoreJoueur)
        INC     A                       ; Joueur gagne une manche
        LD      (TxtScoreJoueur),A
        CALL    AfficheScore            ; Affiche le score
        LD      A,(TxtScoreJoueur)
        CP      MAX_SCORE_PONG          ; Joueur a gagn ?
        JR      Z,Fin
        JR      BclPong                 ; Recommence une nouvelle manche
CPCGagne:
        LD      A,(TxtScoreCPC)
        INC     A                       ; CPC a gagn une manche
        LD      (TxtScoreCPC),A
        CALL    AfficheScore
        LD      A,(TxtScoreCPC)
        CP      MAX_SCORE_PONG          ; CPC a gagn ?
        JR      NZ,BclPong              ; Recommencer une nouvelle manche
        XOR     A                       ; A = 0 indique cpc a gagn
Fin:
        PUSH    AF
        CALL    ClearAll
        POP     AF
        LD      B,0                     ; Pause 5 secondes
WaitFin:
        HALT
        DJNZ    WaitFin
        RET

;
; Affichage du score
;
AfficheScore:
        LD      HL,TxtScore
        JR      PrintMess

;
; Affiche "ready?" et attends 5 secondes
;
Wait5Sec:
        LD      HL,MsgReady
        CALL    PrintMess
        CALL    ClearAll
        LD      B,0
Wait5Sec1:
        HALT
        DJNZ    Wait5Sec1
        LD      HL,MsgEff
        JR      PrintMess

;
; Affichage d'un message
;
PrintMess:
        LD      A,(HL)
        AND     A
        RET     Z
        CALL    #BB5A
        INC     HL
        JR      PrintMess

;
; Initialisation des donnes
;
InitPong:
        XOR     A
        LD      (JoueurPerdBalle),A
        LD      (CPCPerdBalle),A
        LD      A,100
        LD      (PosYjoueur),A
        LD      (PosYCPC),A
        LD      (PosYBalle),A
        LD      A,39
        LD      (PosXBalle),A
        LD      A,1
        LD      (IncXBalle),A       ; Incrment X de la balle = 1 -> vers CPC
CalcIncY:
        LD      A,R                 ; Valeur alatoire de l'incrment Y
        RRCA                        ; de la balle
        RRCA
        AND     3
        SUB     1
        CP      2
        JR      NC,CalcIncY
        LD      (IncYBalle),A
        LD      A,1
        LD      HL,Enveloppe01
        CALL    #BCBC
        RET

Jeu:
        CALL    #BD19
        CALL    DrawBalle               ; Affichage de la balle
        CALL    DrawRaqJoueur           ; Affichage raquette joueur
        CALL    DrawRaqCPC              ; Affichage raquette CPC
        CALL    DeplCPC                 ; Calcul dplacement CPC
        CALL    DeplBalle               ; Calcul dplacement balle
        LD      A,(JoueurPerdBalle)
        AND     A                       ; Joueur perdu ?
        RET     NZ
        LD      A,(CPCPerdBalle)
        AND     A                       ; CPC perdu ?
        RET     NZ
        XOR     A                       ; Code flche HAUT
        CALL    #BB1E
        CALL    NZ,DeplRaqHaut
        LD      A,#48                   ; Code UP Joystick
        CALL    #BB1E
        CALL    NZ,DeplRaqHaut

        LD      A,#02                   ; Code flche BAS
        CALL    #BB1E
        CALL    NZ,DeplRaqBas
        LD      A,#49                   ; Code DOWN Joystick
        CALL    #BB1E
        CALL    NZ,DeplRaqBas
        JR      Jeu                     ; Boucle sur le jeu

;
; Demande de dplacment de la raquette vers le haut
;
DeplRaqHaut:
        LD      A,(PosYJoueur)
        CP      29
        RET     C
        SUB     2
        LD      (PosYJoueur),A
        RET

;
; Demande de dplacement de la raquette vers le bas
;
DeplRaqBas:
        LD      A,(PosYJoueur)
        CP      180
        RET     NC
        ADD     A,2
        LD      (PosYJoueur),A
        RET

;
; Gestion dplacement de la balle
;
DeplBalle:
        LD      A,(IncXBalle)
        LD      B,A
        LD      A,(PosXBalle)
        ADD     A,B
        LD      (PosXBalle),A
        CP      2
        JR      C,DeplBalleXMin
        CP      77
        JP      C,DeplBalleY
;
; Vrifie CPC touche la balle
;
        LD      A,(PosYBalle)
        LD      B,A
        LD      A,(PosYCPC)
        SUB     4
        SUB     B
        LD      C,A
        AND     #F0
        JR      Z,CPCToucheBallePlus
        LD      A,C
        NEG
        AND     #F0
        JR      Z,CPCToucheBalleMoins
        LD      A,1
        LD      (CPCPerdBalle),A            ; CPC a perdu
        LD      HL,Sound02
        CALL    #BCAA
        RET
CPCToucheBalleMoins:
        LD      A,C
        NEG
        AND     #F
        SRA     A
        SRA     A                       ; Rebond vers le bas
        JR      CPCSetYBalle
CPCToucheBallePlus:
        LD      A,C
        AND     #F
        SRA     A
        SRA     A
        NEG                             ; Rebond vers le haut
CPCSetYBalle:
        LD      (IncYBalle),A
        LD      HL,Sound01
        CALL    #BCAA
        JR      DeplBalleSuiteX

;
; Vrifie joueur touche la balle
;
DeplBalleXMin:
        LD      A,(PosYBalle)
        LD      B,A
        LD      A,(PosYJoueur)
        SUB     4
        SUB     B
        LD      C,A
        AND     #F0
        JR      Z,JoueurToucheBallePlus
        LD      A,C
        NEG
        AND     #F0
        JR      Z,JoueurToucheBalleMoins
        LD      A,1
        LD      (JoueurPerdBalle),A         ; Joueur a perdu
        LD      HL,Sound02
        CALL    #BCAA
        RET
JoueurToucheBalleMoins:
        LD      A,C
        NEG
        AND     #F
        SRA     A
        SRA     A                       ; Rebond vers le bas
        JR      JoueurSetYBalle
JoueurToucheBallePlus:
        LD      A,C
        AND     #F
        SRA     A
        SRA     A
        NEG                             ; Rebond vers le haut
JoueurSetYBalle:
        LD      (IncYBalle),A
        LD      HL,Sound00
        CALL    #BCAA

DeplBalleSuiteX:
        LD      A,(IncXBalle)
        NEG
        LD      (IncXBalle),A
DeplBalleY:
        LD      A,(IncYBalle)
        LD      B,A
        LD      A,(PosYBalle)
        ADD     A,B
        LD      (PosYBalle),A
        CP      16
        JR      C,DeplBalleYMin
        CP      188
        RET     C
DeplBalleYMin:
        LD      A,(IncYBalle)
        NEG
        LD      (IncYBalle),A
        RET
;
; Gestion dplacement cpc
;
DeplCPC:
        LD      C,0
        LD      A,R
        AND     #78
        CP      #78
        JR      NZ,DeplCPC2
        LD      A,R
        AND     7
        SUB     3
        LD      C,A
DeplCPC2:
        LD      A,(PosYBalle)
        SUB     C
        LD      B,A
        LD      A,(PosYCPC)
        SUB     10
        CP      B
        RET     Z
        JR      NC,DeplCPCUp
        LD      A,(PosYCPC)
        CP      180
        RET     NC
        ADD     A,2
        LD      (PosYCPC),A
        RET
DeplCPCUp:
        LD      A,(PosYCPC)
        CP      29
        RET     C
        SUB     2
        LD      (PosYCPC),A
        RET

;
; Efface tout
;
ClearAll:
        CALL    DrawBalle
        LD      A,(PosYBalle)
        CALL    CalcAdrEcr
        LD      B,0
        LD      A,(PosXBalle)
        LD      C,A
        ADD     HL,BC
        XOR     A
        LD      D,8
        CALL    DrawPtRaq

        LD      A,(PosYJoueur)
        SUB     20                ; Pour centrer
        CALL    CalcAdrEcr
        XOR     A
        LD      D,40
        CALL    DrawPtRaq

        LD      A,(PosYCPC)
        SUB     20                ; Pour centrer
        CALL    CalcAdrEcr
        LD      BC,78
        ADD     HL,BC
        XOR     A
        LD      D,40
        JR      DrawPtRaq

;
; Dessin de la balle
;
DrawBalle:
        LD      A,(OldPosYBalle)
        CALL    CalcAdrEcr
        LD      B,0
        LD      A,(OldPosXBalle)
        LD      C,A
        ADD     HL,BC
        LD      A,B
        LD      D,8
        CALL    DrawPtRaq
        LD      A,(PosYBalle)
        LD      (OldPosYBalle),A
        CALL    CalcAdrEcr
        LD      B,0
        LD      A,(PosXBalle)
        LD      (OldPosXBalle),A
        LD      C,A
        ADD     HL,BC
        LD      A,#F0
        LD      D,8
        JR      DrawPtRaq

;
; Routines Affichage raquette joueur et cpc
; Longueur raquette = 32 pixels, + 4 pixels "blancs" en haut et en bas
;
DrawRaqJoueur:
        LD      A,(PosYJoueur)
        SUB     20                ; Pour centrer
        CALL    CalcAdrEcr
        JR      DrawRaq

DrawRaqCPC:
        LD      A,(PosYCPC)
        SUB     20                ; Pour centrer
        CALL    CalcAdrEcr
        LD      BC,78
        ADD     HL,BC

DrawRaq:
        XOR     A
        LD      D,4
        CALL    DrawPtRaq
        LD      A,#F0
        LD      D,32
        CALL    DrawPtRaq
        XOR     A
        LD      D,4
        JP      DrawPtRaq

DrawPtRaq:
        LD      (HL),A
        INC     HL
        LD      (HL),A
        LD      BC,#7FF
        ADD     HL,BC
        JR      NC,DrawPtRaq2
        LD      BC,#C050
        ADD     HL,BC
DrawPtRaq2:
        DEC     D
        JR      NZ,DrawPtRaq
        RET

;
; Routine Calcul position Y mmoire cran en fonction de la valeur de A
;
CalcAdrEcr:
        LD      C,A
        AND     #F8
        LD      H,0
        LD      L,A                     ; HL = INT(Y/8)*8
        LD      A,C
        ADD     HL,HL                   ; HL = INT(Y/8)*16
        LD      B,H
        LD      C,L
        ADD     HL,HL                   ; HL = INT(Y/8)*32
        ADD     HL,HL                   ; HL = INT(Y/8)*64
        ADD     HL,BC                   ; HL = INT(Y/8)*80
        AND     #7
        ADD     A,A
        ADD     A,A
        ADD     A,A
        OR      #C0
        ADD     A,H
        LD      H,A
        RET

JoueurPerdBalle:
        DB      0

CPCPerdBalle:
        DB      0

PosYJoueur:
        DB      0

PosYCPC:
        DB      0

PosXBalle:
        DB      0

PosYBalle:
        DB      0

IncXBalle:
        DB      0

IncYBalle:
        DB      0

OldPosXBalle:
        DB      0

OldPosYBalle:
        DB      0
